module db_maintain
/***************************************************************************
                        db_maintain.mod  -  description
                             -------------------
    begin                : 2003
    copyright            : (C) 2004 by tdb Software Service
    email                : tf@tdb.de

		$Id: db_maintain.mod,v 1.1 2005/09/08 07:34:11 path Exp $
 ***************************************************************************

 ***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

 /*<doku>Grundroutinen zur Tabellenpflege basierend auf der eforia-Struktur</doku>
<changed>TF / 2004-07-15 [code cleanup]</changed>
*/

Uses ../lib/fulltext

procedure Db_Maintain_LinkDefs(cTarget,cSource1,cSource2:STRING)
/*<doku>
Fasst 2 Definitionen zu einer zusammen
<author>Horst Klier</author>
<parameters><table>
<tr><td>cTarget<td>Zieldatei
<tr><td>cSource1<td>Quelldatei 1
<tr><td>cSource2<td>Quelldatei 2 (darf auch leer sein)
</table></parameters>
</doku>*/
  VAR fhr,fhw : REAL
  VAR nLastField,nLastInd,nStatus,nFoundFlag : REAL
  VAR cSuch,c : STRING
  .. nStatus: 0=Fields-1, 1=Fields-2, 2=Index-1, 3=Index-2
  fhw:=ReWrite('ramtext:source1')
  Close(fhw)
  fhw:=ReWrite('ramtext:source2')
  Close(fhw)
  CopyFile(cSource1,'ramtext:source1')
  if cSource2#'' and IsFile(cSource2)
    CopyFile(cSource2,'ramtext:source2')
  end
  nLastField:=0
  nLastInd:=0
  fhw:=ReWrite(cTarget)
  if fhw>0
    nStatus:=0
    while nStatus<=5
      if nStatus mod 2=0
        CopyFile(cSource1,'ramtext:source1')
        fhr:=ReSet('ramtext:source1')
      else
        if cSource2#'' and IsFile(cSource2)
          CopyFile(cSource2,'ramtext:source2')
          fhr:=ReSet('ramtext:source2')
        else
          fhr:=0
        end
      end
      if fhr>0
        if nStatus div 2=0 .. Suche nach Fields
          cSuch:='[STRUCTURE]'
        elsif nStatus div 2=1 .. Suche nach Index
          cSuch:='[INDEX]'
        elsif nStatus div 2=2 .. Suche nach Volltext
          cSuch:='[FULLTEXT]'
        end
        if nStatus mod 2=0   .. Wenn source 1 kann cSuch gleich als
          WriteLn(fhw,cSuch) .. Gruppenkopf geschrieben werden
        end
        nFoundFlag:=0
        while nFoundFlag=0 and not eot(fhr)
          c:=ReadLn(fhr)
          if LTrim(RTrim(Upper(c)))=cSuch
            nFoundFlag:=1
          end
        end
        while nFoundFlag=1 and not eot(fhr)
          c:=LTrim(RTrim(ReadLn(fhr)))
          if c[1,1]='['
            nFoundFlag:=0
          else
            if nStatus div 2=0 .. fields
              if c=''
              elsif c[1,2]='..'
              elsif lower(c[1,6])='field_' and Pos('=',c)>0
                c:=c[Pos('=',c)+1,255]
                nLastField:=nLastField+1
                WriteLn(fhw,'field_'+Str(nLastField)+'='+c)
              else
                nLastField:=nLastField+1
                WriteLn(fhw,'field_'+Str(nLastField)+'='+c)
              end
            elsif nStatus div 2=1 .. Index
              if c=''
              elsif c[1,2]='..'
              elsif lower(c[1,3])='id='
                WriteLn(fhw,c)
              elsif lower(c[1,4])='inr='
                WriteLn(fhw,c)
              elsif lower(c[1,6])='index_' and Pos('=',c)>0
                c:=c[Pos('=',c)+1,255]
                nLastInd:=nLastInd+1
                WriteLn(fhw,'index_'+Str(nLastInd)+'='+c)
              else
                nLastInd:=nLastInd+1
                WriteLn(fhw,'index_'+Str(nLastInd)+'='+c)
              end
            elsif nStatus div 2=2 .. Volltext
              if c=''
              elsif c[1,2]='..'
              else
                WriteLn(fhw,c)
              end
            end
          end
        end
        Close(fhr)
        fhr:=0
      end
      nStatus:=nStatus+1
    end
    Close(fhw)
  else
    DelFile(cTarget)
  end
endproc

procedure Db_Maintain_DeleteDir(cBaseDir:STRING)
/*<doku>
Lscht alle Dateien im Verzeichnis und dann das Verzeichnis selbst
<author>Horst Klier</author>
</doku>*/
  VAR c : STRING

  .. Alte Dateien lschen
  repeat
    c:=FirstDir(cBaseDir+'/*','')//*/
    while c[1,1]='.' and c#''
      c:=NextDir
    end
    if c#'' and c[1,1]#'.'
      if DelFile(cBaseDir+'/'+LTrim(RTrim(c[1,63])))#0
        CgiWriteLn('<!-- Fehler beim Loeschen des Volltextverzeichnisses bei '+c+' -->')
        c:=''
      end
    else
      c:=''
    end
  until c=''
  RemDir(cBaseDir)
endproc



procedure Db_Maintain_Restrukt(cName,cDefDir,cBaseDir:STRING):REAL
/*<doku>
Restruktuiert Tabelle
<author>Horst Klier</author>
<parameters><table>
<tr><td>cName<td>Name der Tabelle
<tr><td>cDefDir<td>Verzeichnis in dem die Definition liegt
<tr><td>cBaseDir<td>Verzeichnis in dem de Tabelle liegt
</table></parameters>
<return>Fehlercode als Real</return>
</doku>*/
  VAR fhw,nRet : REAL

  if RightStr(cBaseDir,1)#'/'
    cBaseDir:=cBaseDir+'/'
  end
  if RightStr(cDefDir,1)#'/'
    cDefDir:=cDefDir+'/'
  end

  if IsFile(cBaseDir+cName+'_stand.flg')
    Rename(cBaseDir+cName+'_stand.flg',cBaseDir+'old_'+cName+'_stand.flg')
  end
  fhw:=ReWrite(cBaseDir+cName+'_stand.flg')
  if fhw>0
    WriteLn(fhw,"Datum  : "+DateStr(today))
    WriteLn(fhw,"Uhrzeit: "+TimeStr(now))
    Close(fhw)
  end
  if IsFile(cBaseDir+cName+'.dat')
    If CopyFile(cBaseDir+cName+'.dat',cBaseDir+'old_'+cName+'.dat')=0
      DelFile(cBaseDir+cName+'.dat')
    end
  end
  if IsFile(cBaseDir+cName+'.mmo')
    if CopyFile(cBaseDir+cName+'.mmo',cBaseDir+'old_'+cName+'.mmo')=0
      DelFile(cBaseDir+cName+'.mmo')
    end
  end
  if IsFile(cBaseDir+cName+'.blb')
    if CopyFile(cBaseDir+cName+'.blb',cBaseDir+'old_'+cName+'.blb')=0
      DelFile(cBaseDir+cName+'.blb')
    end
  end

.. MakeDB
.. 12.12.2000 '@' zum Test fr FreeBSD eingefgt
.. 13.02.2001 '@' wieder entfernt und Abfrage fr Restrukt oder Neugenerierung
  if IsFile(cBaseDir+'old_'+cName+'.dat')
    nRet:=MakeDB(cBaseDir+cName+'.dat',"",0,cDefDir+cName+'.def',cBaseDir+'old_'+cName+'.dat')
  else
    nRet:=MakeDB(cBaseDir+cName+'.dat',"",0,cDefDir+cName+'.def')
  end

  if nRet=0
    MakeDir(cBaseDir+'old')
    if IsFile(cBaseDir+'old_'+cName+'.dat')
      Rename(cBaseDir+'old_'+cName+'.dat',cBaseDir+'old/'+cName+'_'+Exchange(DateStr(today),".","")+Exchange(TimeStr(now),":","")+".dat")
    end
    if IsFile(cBaseDir+'old_'+cName+'.mmo')
      Rename(cBaseDir+'old_'+cName+'.mmo',cBaseDir+'old/'+cName+'_'+Exchange(DateStr(today),".","")+Exchange(TimeStr(now),":","")+".mmo")
    end
    if IsFile(cBaseDir+'old_'+cName+'.blb')
      Rename(cBaseDir+'old_'+cName+'.blb',cBaseDir+'old/'+cName+'_'+Exchange(DateStr(today),".","")+Exchange(TimeStr(now),":","")+".blb")
    end
    if IsFile(cBaseDir+'old_'+cName+'_stand.flg')
      DelFile(cBaseDir+'old_'+cName+'_stand.flg')
    end
    Db_Maintain_DeleteDir(cBaseDir+cName+'_vt')
  else
    Rename(cBaseDir+'old_'+cName+'.dat',cBaseDir+cName+'.dat')
    if IsFile(cBaseDir+'old_'+cName+'.mmo')
      Rename(cBaseDir+'old_'+cName+'.mmo',cBaseDir+cName+'.mmo')
    end
    if IsFile(cBaseDir+'old_'+cName+'.blb')
      Rename(cBaseDir+'old_'+cName+'.blb',cBaseDir+cName+'.blb')
    end
    DelFile(cBaseDir+cName+'_stand.flg')
    if IsFile(cBaseDir+'old_'+cName+'_stand.flg')
      Rename(cBaseDir+'old_'+cName+'_stand.flg',cBaseDir+cName+'_stand.flg')
    end
  end
  Return nRet
endproc

procedure Db_Maintain_GenerateFulltext(cName,cDef,cBaseDir:STRING):STRING
/*<doku>
Legt Volltext zu einer Tabelle an
<author>Horst Klier</author>
<parameters><table>
<tr><td>cName<td>Name der Tabelle
<tr><td>cDef<td>Definitionsdatei (wegen Parameter)
<tr><td>cBaseDir<td>Volltextverzeichnis
</table></parameters>
<return>Meldung oder Fehler als String</return>
</doku>*/
  VAR cErr,c : STRING
  VAR nErr,dbTAB,dbSUCHWORT,dbSUCHREL : REAL
  VAR cFields,cExtABC,cKontraindex,cDynKontraIndex : STRING
  VAR nCut,nModus,nStep,nMaskenfeld : REAL

  if RightStr(cBaseDir,1)='/'
    cBaseDir:=cBaseDir[1,Length(cBaseDir)-1]
  end


  cErr:=''

  Db_Maintain_DeleteDir(cBaseDir)
  MakeDir(cBaseDir)

  .EC 1
  nErr:=GenList(cBaseDir+'/d-ind.dat',40)


	if nErr#0
    cErr:='Kann Volltext-Stichworttabelle nicht anlegen'
  else
    nErr:=GenRel(cName,'d-ind',cBaseDir+'/d-rel.rel')
    if nErr#0
      cErr:='Kann Vollext-Relationstabelle nicht anlegen'
    else
      dbTAB:=OpenDB(Exchange(cBaseDir,'_vt','.dat'),"",0,15)
      if dbTAB>0 then

        nErr:=Fulltext_ScanRecs(dbTAB)
				if nErr#0
          cErr:='<font color="#ff0000">Fehler beim Volltext-Indizieren: '+Str(nErr)+'<br>'
          cErr:=cErr+'<b>'+OemToAnsi(TDB_ErrorStr(nErr))+'</b><br>'
          cErr:=cErr+OemToAnsi(TDB_ErrorMsg)+'</font>'
        else
          cErr:='Volltext angelegt'
        end
        CloseDB(dbTAB)
      else
        cErr:='<font color="#ff0000">Volltext-Fehler: Kann '+Exchange(cBaseDir,'_vt','.dat')+' nicht ffnen!</font>'
      end
    end
  end

  Return cErr
endproc
