module common
/***************************************************************************
                        gebo.mod  -  description
                             -------------------
    begin                : 2005
    copyright            : (C) 2004 by tdb Software Service
    email                : tf@tdb.de

		$Id: common.mod,v 1.4 2005/09/08 08:30:14 path Exp $
 ***************************************************************************

 ***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
var sgVersionStr				: STRING = "1.2.1"


//Page type constanst
var cigTypePage			: INTEGER = 0
var cigTypeImg			: INTEGER = 1
var cigTypeFile			: INTEGER = 2
var cigTypeUser 		: INTEGER = 3
var cigTypeGebo			: INTEGER = 4

var sgTempMain			: STRING = "../template/main.template"
var sgTempWiki			:	STRING = "../template/wiki.template"
var sgTempEdit			:	STRING = "../template/edit.template"
var sgTempEditCtrls	:	STRING = "../template/editcontrols.template"
var sgTempList			:	STRING = "../template/list.template"
var sgTempHistory		: STRING = "../template/history.template"
var sgTempLogin			: STRING = "../template/login.template"
var sgTempRegister  : STRING = "../template/register.template"
var sgTempImgEdit		: STRING = "../template/imgedit.template"
var sgTempFileEdit	: STRING = "../template/fileedit.template"
var sgTempUserEdit	: STRING = "../template/useredit.template"
var sgTempUser			: STRING = "../template/userwiki.template"
var sgTempDiff			: STRING = "../template/diff.template"
var sgTempSmartLink	: STRING = "../template/smartlink.template"
var sgTempWikiProtected : STRING = "../template/protected.template"
var sgTempWikiProtectedByID : STRING = "../template/protectedbyid.template"
// Configuration settings (to be overwritten by the gebogebo.conf)
var sgSendmail						: STRING = "sendmail " //-pSMTP:'+host+' "
var sgSendFrom						: STRING = "gebogebo@"+GetEnv("SERVER_NAME")
var sgGeboURL							: STRING = "http://www.gebogebo.org"
var sgLanguage						: STRING = "en"
var bgCountHits						: INTEGER = 1
var bgStaticEnabled				: INTEGER = 0
var bgEMailNotes					: INTEGER = 1
var igTimeout							: INTEGER = 1800
var igLockTimeout 				: INTEGER = 900
var sgDefault							: STRING = "Start"
var sgWikiName						: STRING = "GeboGebo"
var bgUserBase						: INTEGER = 1
var bgUplFiles 						: INTEGER = 1
var bgUplImages 					: INTEGER = 1
var igNaturalLimit 				: INTEGER = 199
var bgAnonymousEdit 			: INTEGER = 1
var bgEnableRegistration	: INTEGER = 1
var bgStaticCreation			: INTEGER = 0
var sgDateTimeFormat			: STRING = "%Y-%M-%D %h:%m"
var gbAutoLink						: INTEGER = 0
var gbAutoLinkTwice				: INTEGER = 0
var sgPathToDiff					: STRING ="diff"
var bgMacroEnabled				: INTEGER = 1
var bgMacroPlugins				: INTEGER = 0
var igMacroTimeout				: INTEGER = 5
var sgMacrosList					: STRING = "../conf/macros.conf"
var igDetailedResultMax		: INTEGER = 99
var sgExportExecute				: STRING = "tar -czf [$WikiName.tar.gz] *"
var sgModRewrite					: STRING = ""
var bgNoHTML							: INTEGER = 0
var sgIntermap						: STRING = "../conf/intermap.conf"
var bgAdminEnables				: INTEGER = 0
var bgInformOnAdminEnables: INTEGER = 1 //inform users by email that the account state changed
var sgAdminEMail					: STRING = ""
var bgNotifyOnNewUsers		: INTEGER = 1
var igSendHello						: INTEGER = 1 //tell gebogebo.org about own existance
var bgCreateStaticIndex		: INTEGER = 1 // shall the index.html be created?

//directories and files
var sgConfDir				: STRING = "../conf/"
var sgConfigFile		: STRING = sgConfDir+"gebogebo.conf"
var sgBlacklist			:	STRING = sgConfDir+"black.list"
var sgRelPath				: STRING = ".."
var sgSelf					: STRING = sgRelPath+"/programm/gebo.prg"
var sgVarDir				: STRING = "../var/gebo/"
var sgLogDir				: STRING = sgVarDir+"log/"
var sgLockDir				: STRING = sgVarDir+"lock/"
var sgDBDir					: STRING = "../database/"
var sgDataDir				: STRING = sgVarDir+"data/"
var sgDataImgDir		: STRING = "/var/gebo/data/img/"
var sgDataFileDir		: STRING = "/var/gebo/data/file/"
var sgStaticDir 		: STRING = "/static/"
var sgTempDir				:	STRING = "../tmp/gebo/"
var sgTempExportDir	: STRING = sgTempDir+"export/"
var sgMailDir				: STRING = sgVarDir+"mails/"
var sgSessionDir		: STRING = sgTempDir
var sgPluginDir			: STRING = "../plugins/"

//internal global variables, depending on the session
var bgConsoleMode				: INTEGER
var sgSession						: STRING
var sgUser							: STRING
var sgName							: STRING
var bgStaticMode				: INTEGER = 0
var sgAction						: STRING
var bgAdminUser 				: INTEGER
var sgLanguageFile			: STRING = sgConfDir+sgLanguage+".lang"
var igUserID						: INTEGER = 0
var sgError							: STRING
var igMaxLinksPerPage 	: INTEGER = 9999
var sgIP								: STRING = GetEnv("REMOTE_ADDR")
var sgRoute							: STRING

var sgOverWriteURL			: STRING = ""

Procedure lang(sSrc : STRING) : STRING
/*
retrieve the translation for sSrc from the translation ressource
*/
	var s : string = GetIdent(sgLanguageFile, sSrc)
	if !s then
		s :=  GetIdent(sgLanguageFile, "missingtranslation")
	end
	return s
endproc

procedure GP(sKey : STRING) : STRING
//get cgi parameters
	var sValue	: STRING
	if sValue := GetQueryString(sKey) = "" then
		sValue := CGIGetParam(sKey)
	end
	return sValue
Endproc


procedure cleanName(sName : STRING) : string
//make sName a valid WikiName
	sName := lower(sName)
	sName := Exchange(sName, " ","_")
	sName := Exchange(sName, ",","_")
	sName := Exchange(sName, "|","_")
	sName := Exchange(sName, ";","_")
	sName := Exchange(sName, "?","_")
	sName := Exchange(sName, "!","_")
	sName := Exchange(sName, "#","_")
	sName := Exchange(sName, "<","_")
	sName := Exchange(sName, ">","_")
	sName := Exchange(sName, "\","_")
	sName := Exchange(sName, "/","_")
	sName := Exchange(sName, "'","_")
	sName := Exchange(sName, '"',"_")
	sName := Exchange(sName, "","ae")
	sName := Exchange(sName, "","oe")
	sName := Exchange(sName, "","ue")
	return sName
endproc

procedure buildRoute(sAdd : STRING)
//store the route the visitor took in his session file
	var sPages : STRING
	var p			 : INTEGER
	var sDummy : STRING
	sPages := sgRoute

	if p := Pos(sAdd+"|", sPages)>1 then
		sPages := sPages[1,p-1] + sPages[p+1+Length(sAdd),255]
	elsif p = 1 then
		sPages := sPages[Length(sAdd)+2,255]
	end
	while Length(sPages) + Length(sAdd) +1 > 250 OR Scan("|",sPages) > 9 do
		p := Pos("|",sPages)
		sPages := sPages[p+1,255]
	end
	sPages := sPages + sAdd+"|"
	sgRoute := sPages
endproc


procedure isValidSession : INTEGER
/*
tests whether a session is still valid
*/
	var dbSESSION			: INTEGER
	var dbUSER				: INTEGER
	var iRec					: INTEGER
	var iSema					: INTEGER
	var iRes					: INTEGER

	if iSema := WaitSema(sgLockDir+"sessions.sema",10000) then
		dbUSER := OpenDB(sgDBDir+"user.dat")
		dbSESSION := OpenDB(sgDBDir+"sessions.dat","",0,15)
		if ReadRec(dbSESSION, iRec := FindRec(dbSESSION,sgSession,1,1)) then
			if UNIX_NOW <= GetRField(dbSESSION,"Expires") then
				igUserID := GetRField(dbSESSION,"User")
				ReadRec(dbUSER, FindAuto(dbUSER, GetRField(dbSESSION,"User")))
				sgUser := GetField(dbUSER,"Name")
				bgAdminUser := GetRField(dbSESSION, "Admin")
				SetRField(dbSESSION,"Expires",UNIX_NOW + igTimeout)
				sgRoute := GetField(dbSESSION,"Route")
			else
				//session expired
				DelRec(dbSESSION, iRec)
				iRec := 0
			end
		end
		CloseDB(dbUSER)
		if iRec = 0 then
			//session unknown
			iRec := FileSize(dbSESSION) +1
			//remRandomlyOldSess //delete random session
			sgSession:=CGIGetSession
			SetField(dbSESSION, "Session", sgSession)
			SetRField(dbSESSION, "Start",UNIX_NOW)
			SetRField(dbSESSION, "Expires", UNIX_NOW + igTimeout)
			iRes := 0
		else
			if sgAction IN ["","show"] then
				buildRoute(cleanName(sgName))
				SetField(dbSESSION, "Route", sgRoute)
			end
			iRes := 1
		end
		if bgStaticEnabled then
			if GP("stay") = "dyn" then
				SetRField(dbSESSION,"Dynamic",1)
				bgStaticMode:=0
			elsif GP("stay") = "static" then
				SetRField(dbSESSION,"Dynamic",0)
				bgStaticMode:=1
			elsif GetRField(dbSESSION,"Dynamic")=1 then
				bgStaticMode:=0
			elsif GetRField(dbSESSION,"Dynamic")=0 then
				bgStaticMode:=1
			end
		end
		SetField(dbSESSION,"IP",sgIP)
		IncrField(dbSESSION, "Hits")
		WriteRec(dbSESSION, iRec)

		CloseDB(dbSESSION)
		EndSema(iSema)
	else
		//error
	end
	return iRes
endproc

procedure dropSession(sSession : STRING)
	var dbSESSION			: INTEGER
	var iRec					: INTEGER
	var iSema					: INTEGER

	if iSema := WaitSema(sgLockDir+"sessions.sema",10000) then
		dbSESSION := OpenDB(sgDBDir+"sessions.dat","",0,15)
		if iRec := FindRec(dbSESSION,sSession,1,1) then
			DelRec(dbSESSION, iRec)
		end
	end
endproc

PROCEDURE sendmails
/*
sends emails, waiting in the queue
*/
	VAR l : STRING = firstdir(sgMailDir+'*.msg','') \\*/
	VAR fn, s_to, s_from, host : STRING
	VAR p,q : INTEGER
	var sExec : STRING
  host:=getenv('SERVER_NAME')
  ramtext("ramtext:_sendmail",8192)
	WHILE l DO
    fn:=rtrim(l[1,63])
    copyfile(sgMailDir+fn,"ramtext:_sendmail")
    IF p:=ramtext_find("ramtext:_sendmail",'To: ') THEN
      q:=ramtext_find("ramtext:_sendmail",^J,p+1)
      IF q-p<255 THEN
        s_to:=ramtext_part("ramtext:_sendmail",p+4,q-p-4)
        // cgiwriteln('to = '+s_to)
      END
    END
    IF p:=ramtext_find("ramtext:_sendmail",'From: ') THEN
      q:=ramtext_find("ramtext:_sendmail",^J,p+1)
      IF q-p<255 THEN
        s_from:=ramtext_part("ramtext:_sendmail",p+6,q-p-6)
      END
    END
    IF s_to, s_from THEN
      sExec := sgSendmail+' -f '+s_from+' '+s_to+' < '+sgMailDir+fn
			CGIExec(sExec)
      DelFile(sgMailDir+fn)
    END
    l:=nextdir
  END
ENDPROC

procedure rMakeDir(sPath:STRING)
/*
recursive makedir
creates a complete path, if it does not exist yet
*/

	var sPre 	: STRING
	var sPart : STRING
	var p : INTEGER

	if !IsFile(sPath) then
		if RightStr(sPath,1)#"/" then
			sPath := sPath +"/"
		end
		p:=Pos("/",sPath)
		if sPath[1,p] = "../" or sPath[1,p] = "./" or sPath[1,p] = "/" then
			sPre := sPath[1,p]
			sPath := sPath[p+1,255]
		end
		while p:=Pos("/",sPath)#0 do
			sPart := sPath[1,p]
			MakeDir(sPre+sPart)
			sPre := sPre + sPart
			sPath := sPath[p+1,255]
		end
	end
endproc

procedure rDelFile(sPattern : STRING)

	var sFile : STRING
	var sDir : STRING
	var p			: INTEGER

	sFile := FirstDir(sPattern,"")
	while p := Pos("/",sPattern) do
		sDir := sDir + sPattern[1,p]
		sPattern := sPattern[p+1,255]
	end
	while sFile do
		sFile := LTrim(RTrim(sFile[1,63]))
		if sFile # "." and sFile # ".." then
			DelFile(sDir+sFile)
		end
		sFile := NextDir
	end
endproc

procedure initGebo
/*
This is the basic initialization of GeboGebo
*/

	rMakeDir(sgVarDir)
	rMakeDir(sgLogDir)
	rMakeDir(sgMailDir)
	rMakeDir(sgLockDir)
	rMakeDir(sgTempDir)
	rMakeDir(sgTempExportDir)
	rMakeDir(sgSessionDir)
	rMakeDir(sgStaticDir)
	rMakeDir(sgDataDir)
	rMakeDir(sgDataImgDir)
	rMakeDir(sgDataFileDir)

// read in basic settings
	if GetIdent(sgConfigFile,"Name") then
		sgWikiName := GetIdent(sgConfigFile,"Name")
	end
	if GetIdent(sgConfigFile,"EditTimeout") then
		igLockTimeout := Val(GetIdent(sgConfigFile,"EditTimeout")) *60
	end
	if GetIdent(sgConfigFile,"SessionTimeout") then
		igTimeout := Val(GetIdent(sgConfigFile,"SessionTimeout")) *60
	end
	if GetIdent(sgConfigFile,"DefaultPage") then
		sgDefault := GetIdent(sgConfigFile,"DefaultPage")
	end
	if GetIdent(sgConfigFile,"UserManagement") then
		bgUserBase := Val(GetIdent(sgConfigFile,"UserManagement"))
	end
	if GetIdent(sgConfigFile,"EnableRegistration") then
		bgEnableRegistration := Val(GetIdent(sgConfigFile,"EnableRegistration"))
	end
	if GetIdent(sgConfigFile,"FileUpload") then
		bgUplFiles := Val(GetIdent(sgConfigFile,"FileUpload"))
	end
	if GetIdent(sgConfigFile,"ImageUpload") then
		bgUplImages := Val(GetIdent(sgConfigFile,"ImageUpload"))
	end
	if GetIdent(sgConfigFile,"NaturalLimit") then
		igNaturalLimit := Val(GetIdent(sgConfigFile,"NaturalLimit"))
	end
	if GetIdent(sgConfigFile,"AnonymousEdit") then
		bgAnonymousEdit := Val(GetIdent(sgConfigFile,"AnonymousEdit"))
	end

	if GetIdent(sgConfigFile,"StaticPages") then
		bgStaticEnabled:= Val(GetIdent(sgConfigFile,"StaticPages"))
	end

	if GetIdent(sgConfigFile,"AlwaysCreateStatic") then
		bgStaticCreation := Val(GetIdent(sgConfigFile,"AlwaysCreateStatic"))
	end

	if GetIdent(sgConfigFile,"EMailNotifications") then //to subscribers
		bgEMailNotes := Val(GetIdent(sgConfigFile,"EMailNotifications"))
	end

	if GetIdent(sgConfigFile,"Sendmail") then
		sgSendmail := GetIdent(sgConfigFile,"Sendmail")
	end

	if GetIdent(sgConfigFile,"FromAddress") then
		sgSendFrom := GetIdent(sgConfigFile,"FromAddress")
	end

	if GetIdent(sgConfigFile,"URL") then
		sgGeboURL := GetIdent(sgConfigFile,"URL")
		if RightStr(sgGeboURL,1)#"/" then
			sgGeboURL := sgGeboURL + "/"
		end
	end

	if  GetIdent(sgConfigFile,"Language") then
		sgLanguage := GetIdent(sgConfigFile,"Language")
		if IsFile(sgConfDir+sgLanguage+".lang") then //does translation ressource exist?
			sgLanguageFile	:= sgConfDir+sgLanguage+".lang"
		else //if not so, stay with the default "en"
			sgLanguage := "en"
		end
	end

	if GetIdent(sgConfigFile,"CountPagehits") then
		bgCountHits := Val(GetIdent(sgConfigFile,"CountPagehits"))
	end

	if GetIdent(sgConfigFile,"DateTimeFormat") then
		sgDateTimeFormat := GetIdent(sgConfigFile,"DateTimeFormat")
	end

	if GetIdent(sgConfigFile,"AutoLink") then
		gbAutoLink := Val(GetIdent(sgConfigFile,"AutoLink"))
	end

	if GetIdent(sgConfigFile,"Diff") then
		sgPathToDiff := GetIdent(sgConfigFile,"Diff")
	end

	if GetIdent(sgConfigFile,"Macros") then
		bgMacroEnabled := Val(GetIdent(sgConfigFile,"Macros") )
	end

	if GetIdent(sgConfigFile,"MacroPlugins") then
		bgMacroPlugins := Val(GetIdent(sgConfigFile,"MacroPlugins") )
	end

	if GetIdent(sgConfigFile,"PluginDirectory") then
		sgPluginDir := GetIdent(sgConfigFile,"PluginDirectory")
	end

	if GetIdent(sgConfigFile,"PluginTimeout") then
		igMacroTimeout := Val(GetIdent(sgConfigFile,"PluginTimeout") )
	end

	if GetIdent(sgConfigFile,"DetailResultMax") then
		igDetailedResultMax := Val(GetIdent(sgConfigFile,"DetailResultMax") )
	end

	if GetIdent(sgConfigFile,"ExportExecute") then
		sgExportExecute := GetIdent(sgConfigFile,"ExportExecute")
	end

	if GetIdent(sgConfigFile,"ModRewrite") then
		sgModRewrite := GetIdent(sgConfigFile,"ModRewrite")
	end

	if GetIdent(sgConfigFile,"NoHTML") then
		bgNoHTML := Val(GetIdent(sgConfigFile,"NoHTML"))
	end

	if GetIdent(sgConfigFile,"Intermap") then
		sgIntermap := GetIdent(sgConfigFile,"Intermap")
	end

	if GetIdent(sgConfigFile,"AdminEnablesUsers") then
		bgAdminEnables := Val(GetIdent(sgConfigFile,"AdminEnablesUsers"))
	end

	if GetIdent(sgConfigFile,"AdminEnablesUsersEMail") then
		bgInformOnAdminEnables := Val(GetIdent(sgConfigFile,"AdminEnablesUsersEMail"))
	end

	if GetIdent(sgConfigFile,"NotifyOnNewUsers") then
		bgNotifyOnNewUsers := Val(GetIdent(sgConfigFile,"NotifyOnNewUsers"))
	end

	if GetIdent(sgConfigFile,"AdminEMail") then
		sgAdminEMail := GetIdent(sgConfigFile,"AdminEMail")
	end

	if GetIdent(sgConfigFile, "TemplateMain") then
		sgTempMain := GetIdent(sgConfigFile, "TemplateMain")
	end


	if GetIdent(sgConfigFile,"SendHello") then
		igSendHello := Val(GetIdent(sgConfigFile,"SendHello"))
	end

	if igSendHello > 0 then
		if igSendHello = 1 then
			igSendHello := 0
		end
		SetIdent(sgConfigFile,"SendHello",Str(igSendHello))

		LoadTemplate("http://www.gebogebo.org/programm/mother.prg?v="+sgVersionStr+"&h="+GetEnv("HTTP_HOST"))
	end

	if GetIdent(sgConfigFile, "CreateStaticIndex") then
		bgCreateStaticIndex := Val(GetIdent(sgConfigFile, "CreateStaticIndex"))
	end

endproc

procedure formatStamp(iStamp : INTEGER) : STRING
/*
Converts a unix datetimestamp into the wanted date time format yyyy-mm-dd hh:mm
*/
		var o : String = unixtime_to_str(iStamp)

		var Y,M,D,h,m,t,s : string
		Y := o[7,4]
		M := o[4,2]
		D := o[1,2]
		t := o[12,8]
		h := t[1,2]
		m := t[4,2]
		s := t[7,2]


		o := sgDateTimeFormat
		o := Exchange(o, "%Y", Y)
		o := Exchange(o, "%M", M)
		o := Exchange(o, "%D", D)
		o := Exchange(o, "%t", t)
		o := Exchange(o, "%h", h)
		o := Exchange(o, "%m", m)
		o := Exchange(o, "%s", s)

		return o
endproc

procedure buildWikiLink(sName,sText,sAction : STRING;bNotWorking, bStatic,iProtection : INTEGER) : String
//builds a valid link within then wiki (static or dynamic)
	var sRamReturn : STRING = "ramtext:~wikilink"
	var sClass	: STRING
	var f 			: INTEGER
	if bNotWorking=1 then
		sClass := "notworking"
	elsif bNotWorking=0 then
		sClass := "working"
	elsif bNotWorking=2 then
		sClass := "auto"
	end

	if iProtection then
		sClass := "protected"
	end
	if sName[1]=":" then sName := sName[2,255] end

	Ramtext(sRamReturn,8192)
	f := Rewrite(sRamReturn)
	write(f, "<a class='"+sClass+"' href='")
	if bgStaticMode,bStatic, !sName[1,5] LIKE "gebo:", bNotWorking#1, !iProtection, sAction IN ["", "show"] then // create it for the static target?
		write(f, sgRelPath + sgStaticDir+cleanName(sName)+".html'>")
	else
		if sAction then
			sAction := "&amp;action="+sAction
		end
		if sgOverWriteURL then
			write(f, sgOverWriteURL+"?name="+cleanName(sName))
			write(f, sAction)
			write(f, "'>")
		else
			if sgModRewrite then
				write(f, sgModRewrite+cleanName(sName))
				write(f, sAction)
				write(f, "'>")
			else
				write(f, sgSelf+"?name="+cleanName(sName))
				write(f, sAction)
				write(f, "'>")
			end
		end
	end
	write(f, sText)
	write(f,"</a>")
	if iProtection then

		//write(f, "<img src='"+sgRelPath+ "/images/key1.png' border='0' wxidth='12' hxeight='12'>")
	end
	close(f)
CopyFile(sRamReturn,"test.txt")
	return sRamReturn
endproc

procedure writeText(f : INTEGER; sText : STRING)

	var fSrc : INTEGER
if GetSize(sText) then
	fSrc := Reset(sText)
	while !eot(fSrc) do
		write(f,read(fSrc,1))
	end
	close(fSrc)
end

endproc

procedure getPart(sSource : STRING; iPart : integer) : string
/*
substract a certain part of sSource
*/
		var fs,ft			: integer
		var sTarget 	: STRING = "ramtext:thepart"
		var sLine			: String
		var iCntPrt		: INTEGER
		var bLoop			: INTEGER
		var iLevel		: INTEGER

		ramtext(sTarget,8192)
		fs := reset(sSource)
		ft := rewrite(sTarget)
		while !eot(fs), iCntPrt<iPart do
			sLine := readln(fs)
			if sLine[1,2]="==" then
				iLevel := 0
				while iLevel <= 4, sLine[2 + iLevel++]="=" do end
				iCntPrt++
				bLoop := 1
			end
		end
		if bLoop then
			writeln(ft,sLine)
		end
		while !eot(fs), bLoop do
			sLine := readln(fs)
			if Pos("======"[1,1+iLevel],sLine)=1 then
				bLoop:=0
			else
				writeln(ft,sLine)
			end
		end
		close(fs)
		close(ft)
		return sTarget
endproc

procedure insertPart(sPart,sSource : STRING; iPart : integer) : string
/*
substract a certain part of sSource
*/
		var fs,ft,fp	: integer
		var sTarget 	: STRING = "ramtext:resultpage"
		var sLine			: String
		var iCntPrt		: INTEGER
		var bLoop			: INTEGER
		var iLevel		: INTEGER

		ramtext(sTarget,8192)
		fs := reset(sSource,0)
		fp := reset(sPart)
		ft := rewrite(sTarget)

		while !eot(fs), iCntPrt<iPart do
			sLine := readln(fs)
			if sLine[1,2]="==" then
				if iCntPrt++ = iPart then
					bLoop := 1
					iLevel := 0
					while iLevel <= 4, sLine[2 + iLevel++]="=" do end
				end
			end
			if !bLoop then
				writeln(ft,sLine)
			end
		end

		if bLoop then
			while !eot(fp) do
				writeln(ft,readln(fp))
			end
		end

		while !eot(fs), bLoop do // overread the old part
			sLine := readln(fs)
			if Pos("======"[1,1+iLevel],sLine)=1 then
				writeln(ft,sLine)
				bLoop:=0
			end
		end

		while !eot(fs) do // overread the old part
			writeln(ft,readln(fs))
		end
		close(fp)
		close(fs)
		close(ft)
		return sTarget
endproc

procedure getPageType(sName : STRING) : integer

	var iType	: INTEGER

	if sName[1]=":" then sName:=sName[2,255] end

	if sName[1,4] LIKE "img:" then  // special Namespace img: handling
		iType:=cigTypeImg
	elsif sName[1,5] LIKE "file:" then  // special Namespace file: handling
		iType:=cigTypeFile
	elsif sName[1,5] LIKE "user:" then  // special Namespace user: handling
		iType:=cigTypeUser
	elsif sName[1,5] LIKE "gebo:" then
		iType:=cigTypeGebo
	else
		iType:=cigTypePage
	end
	return iType
endproc

procedure extractContext(sName : STRING) : STRING
/*
extracts the context string off a page sName
*/
	var	p					: INTEGER
	var sContext	: STRING

	if sName[1,5] LIKE "gebo:" then
		sContext := ""
		return sContext
	end

	if sName[1,4] LIKE "img:" then
		sName := sName[5,255]
	elsif sName[1,5] LIKE "file:" then
		sName := sName[6,255]
	elsif sName[1,5] LIKE "gebo:" then
		sName := sName[6,255]
	end

	while p:=Pos(":",sName) > 1 do
		sContext := sContext + sName[1,p]
		sName := sName[p +1,255]
	end
	if sContext[p:=Length(sContext)] = ":" then
		sContext := sContext[1,p -1]
	end


	return sContext
endproc

procedure convertHTML(sSource : STRING)
/*
converts all special chars of sSource into HTML equivalents
*/
	var x : integer

	ramtext("ramtext:buffer",8192) //prepare middle text
	x := rewrite("ramtext:buffer")
		writeln(x, "#")
	close(x)

	Ramtext_Subst("ramtext:buffer","#",sSource,1) // substitude and convert from html

	CopyFile("ramtext:buffer", sSource) // copy new converted source into old original ramtext

endproc

procedure intermap(sWiki, sPage : STRING) : string
/*
returns the interwiki link url to sWiki with page sPage
*/
		var sURL : STRING
		if sURL := GetIdent(sgIntermap, Lower(sWiki)) then
			sURL := Exchange(sURL,"{page}",sPage)
			return sURL
		else
			return "Bad wiki"
		end

endproc


procedure isPageProtected(sWiki : STRING) : integer //;var sAuthKey : STRING
/*
Test page sWiki for protection pattern match
*/
	var dbPROTECT	: INTEGER
	var iRec			: INTEGER
	var iReturn		: INTEGER
	dbPROTECT := OpenDB(sgDBDir+"protect.dat")
	if iRec := FindRec(dbPROTECT, sWiki,1,1) then
		ReadRec(dbPROTECT, iRec)
		iReturn := GetRField(dbPROTECT, "ProtectAgainst")
	elsif iRec := FindRec(dbPROTECT, sWiki,1,0) then
		ReadRec(dbPROTECT, iRec)
		if sWiki LIKE GetField(dbPROTECT, "WikiPattern") then
			iReturn := GetRField(dbPROTECT, "ProtectAgainst")
		end
	end
	closedb(dbPROTECT)
	return iReturn
endproc

procedure getAuthKey(sWiki : STRING) : string
	var dbPROTECT	: INTEGER
	var iRec			: INTEGER
	var sAuth			: STRING

	dbPROTECT := OpenDB(sgDBDir+"protect.dat")
	if iRec := FindRec(dbPROTECT, sWiki,1,1) then
		ReadRec(dbPROTECT, iRec)
		if GetRField(dbPROTECT, "AuthenticateBy") = 1 then
			sAuth := "PW:"
		else
			sAuth := "ID:"
		end
		sAuth := sAuth + GetField(dbPROTECT, "AuthKey")
	elsif iRec := FindRec(dbPROTECT, sWiki,1,0) then
		ReadRec(dbPROTECT, iRec)
		sAuth := sWiki
		if sWiki LIKE GetField(dbPROTECT, "WikiPattern") then
			if GetRField(dbPROTECT, "AuthenticateBy") = 1 then
				sAuth := "PW:"
			else
				sAuth := "ID:"
			end
			sAuth := sAuth + GetField(dbPROTECT, "AuthKey")
		end
	end
	closedb(dbPROTECT)
	return sAuth
endproc