module export_mediawiki


procedure export(sName : string; iRev : integer; sSource : STRING; bAsFile : INTEGER) : string

	var fs,ft 			: INTEGER
	var sL					: STRING
	var p						: INTEGER
	var bUnderline	: INTEGER
	var bThrough		: INTEGER
	var bNoWiki			: INTEGER
	var i						: INTEGER
	var bList				: INTEGER

	fs := reset(sSource)
	ft := rewrite("ramtext:temp")
	while	!eot(fs) do
		sL := ReadLn(fs)

		if sL[1,2] = "==" then // Headline
			bList := 0
			p:=2
			while sL[ p++] = "=", p < 7 do end
			writeln(ft, NTIMES("=", 9 - p)+ sL[p+1,255] + NTIMES("=", 9-p))
			sL:=""
		elsif sL[1,2]="* " or sL[1,2]="# " then
			bList := 1
			write(ft, sL[1,2])
			sL := sL[3,255]
		elsif bList, sL[1]=" " then
			i:=0
			while sL[i++]=" " do end
			if sL[i] ="*" then
				write(ft, NTimes("*",i))
				sL := sL[i,255]
			elsif sL[i] ="#" then
				write(ft, NTimes("#",i))
				sL := sL[i,255]
			else //preformatted text
				bList := 0
				writeLn(ft, sL[2,255])
				sL := ""
			end
		elsif bList=0, sL[1,2] = "  " then // Preformatted
			bList := 0
			writeLn(ft, sL[2,255])
			sL := ""
		elsif sL[1,4] = "----" then // Ruler
			bList := 0
			writeLn(ft, sL[1,4])
			sL := ""
		end
		p := 0
		while p++ <= Length(sL) do
			if sL[p,2] = "__" then
				if bUnderline then
					write(ft, "</u>")
					bUnderline :=0
				else
					write(ft, "<u>")
					bUnderline :=1
				end
				p++
			elsif sL[p,2] = "|#" then
				if bNoWiki then
					write(ft, "</nowiki>")
					bNoWiki :=0
				else
					write(ft, "<nowiki>")
					bNoWiki :=1
				end
				p++
			elsif sL[p,2] = "--" then
				if bThrough then
					write(ft, "</del>")
					bThrough :=0
				else
					write(ft, "<del>")
					bThrough :=1
				end
				p++
			elsif sL[p,2] = "//" then
				write(ft, "''")
				p++
			elsif sL[p,2] = "**" then
				write(ft, "'''")
				p++
			else
				write(ft, sL[p])
			end
		end
		writeln(ft,"")
	end
	Close(ft)
	Close(fs)

	CopyFile("ramtext:temp",sSource)
	if bAsFile = 1 then
		return "txt"
	else
		return "text/plain"
	end

endproc