module gebogebo
/***************************************************************************
                        gebo.mod  -  description
                             -------------------
    begin                : 2005
    copyright            : (C) 2004 by tdb Software Service
    email                : tf@tdb.de

		$Id: gebo.mod,v 1.3 2005/09/08 08:26:33 path Exp $
 ***************************************************************************

 ***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

uses ../lib/fulltext

var sStaticPage			: STRING = "ramtext:static"
var sgMyABC					: STRING = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789@.Ũ"
var sgCookiePath		:	STRING
uses common
uses rss
uses macros


procedure getUserID(sName : STRING) : INTEGER
//finds out a users unique ID
	var dbUSER			: INTEGER
	var iRet				: INTEGER

	dbUSER := OpenDB(sgDBDir+"user.dat")
	readrec(dbUSER, FindRec(dbUSER,sName,1,1))
	iRet := GetRField(dbUSER,"ID")
	closedb(dbUSER)
	return iRet
endproc

procedure isWikiLocked4Anonymous(db :INTEGER; sName : STRING) : INTEGER

	var dbWIKI	: INTEGER
	var iRet		: INTEGER

	if db then
		dbWIKI := SetAlias(db, "clone")
	else
		dbWIKI := OpenDB(sgDBDir+"wiki.dat")
	end

	ReadRec(dbWIKI, FindRec(dbWIKI, cleanName(sName), 1, 1))
	iRet := GetRField(dbWIKI, "AnonymousLock")
	closedb(dbWIKI)
	return iRet
endproc

procedure inBlackList(sName : STRING) : INTEGER
//If the name matches one of the patterns in black.list it may not be edited
	var f 		: INTEGER
	var sLine : STRING
	sName := cleanName(sName)

	if IsFile(sgBlacklist)=0 then //no black.list, then return immediately
		return 0
	else

	f := Reset(sgBlacklist)
		while !eot(f) do
			sLine := LTrim(RTrim(readln(f)))
			if !Pos(sLine[1],"#;") then
				if sName LIKE cleanName(sLine) then
					return 1
				end
			end
		end
		close(f)
	end
	return 0
endproc

procedure isSubscribed(iUserID : integer; sName : string) : integer
/*
Checks for existance of a subscribtion of iUserID to sName and returns the ID
*/
		var dbWIKI		:	INTEGER
		var dbSUBSCR	:	INTEGER
		var iID				: INTEGER
		var iRet			: INTEGER

		dbWIKI := OpenDB(sgDBDir+"wiki.dat")
		dbSUBSCR := OpenDB(sgDBDir+"subscrib.dat")

		iRet := 0
		if sName, ReadRec(dbWIKI, FindRec(dbWIKI, cleanName(sName), 1,1)) then
			iID := GetRField(dbWIKI, "ID")
		end
		if FindRec(dbSUBSCR, Str(iID)+","+Str(iUserID),1,1) then
			iRet := GetRField(dbSUBSCR,"ID")
		end
		closedb(dbSUBSCR)
		closedb(dbWIKI)
		return iRet
endproc

procedure subscribe(iUserID : INTEGER; sName : STRING)
		var dbWIKI		:	INTEGER
		var dbSUBSCR	:	INTEGER
		var iID				: INTEGER
		var iRet			: INTEGER
		var iSema			: INTEGER

		if !isSubscribed(iUserID,sName) then	// no matching subscribtion
			dbWIKI := OpenDB(sgDBDir+"wiki.dat")
			if ReadRec(dbWIKI, FindRec(dbWIKI, cleanName(sName), 1,1)) then
				iID := GetRField(dbWIKI, "ID")
			end
			closedb(dbWIKI)
			if iSema := WaitSema(sgLockDir+"subscrib.sema",10000) then
				dbSUBSCR := OpenDB(sgDBDir+"subscrib.dat","",0,15)
				ReadRec(dbSUBSCR,0)
					SetRField(dbSUBSCR, "Wiki", iID)
					SetRField(dbSUBSCR, "User", iUserID)
				WriteRec(dbSUBSCR, FileSize(dbSUBSCR) +1)
				closedb(dbSUBSCR)
				EndSema(iSema)
			end
		end
		return iRet

endproc

procedure unsubscribe(iSubscribID : INTEGER)
		var iSema				: INTEGER
		var dbSUBSCR		: INTEGER
		var iRec				: INTEGER

		if iSema := WaitSema(sgLockDir+"subscrib.sema",10000) then
			dbSUBSCR := OpenDB(sgDBDir+"subscrib.dat","",0,15)
			if iRec := FindAuto(dbSUBSCR, iSubscribID) then
				DelRec(dbSUBSCR, iRec)
			end
			CloseDB(dbSUBSCR)
			EndSema(iSema)
		end
endproc

procedure showRoute : STRING

	var f				: INTEGER
	var sRoute	: STRING = "ramtext:route"
	var sPages	: STRING
	var p				: INTEGER
	if !sgSession then
		return ""
	end
	Ramtext(sRoute,8192)

	f := Rewrite(sRoute)
	sPages := sgRoute
	while p := Pos("|",sPages) do
		write(f, "[[")
		writeText(f, buildWikiLink(sPages[1,p-1],sPages[1,p-1],"",0,1,isPageProtected(sPages[1,p-1])))
		writeLn(f, "]]")
		sPages := sPages[p+1,255]
	end
	close(f)
	return sRoute

endproc


procedure makeNotifications(iWikiID : INTEGER; sSource : STRING)

		var dbWIKI			: INTEGER
		var dbSUBSCR		: INTEGER
		var dbUSER			: INTEGER
		var f						: INTEGER
		var iRec				: INTEGER
		var sEditorName	: STRING

		dbWIKI := OpenDB(sgDBDir+"wiki.dat")
		dbSUBSCR := OpenDB(sgDBDir+"subscrib.dat")
		dbUSER := OpenDB(sgDBDir+"user.dat")
		RELATION

		ReadRec(dbWIKI, FindAuto(dbWIKI, iWikiID))

		ReadRec(dbUSER, FindAuto(dbUSER,GetRField(dbWIKI,"Editor")))
		sEditorName := GetField(dbUSER, "Name")

		if FindAndMark(dbUSER, "!ID="+Str(igUserID)+", Exists($subscrib.Wiki="+Str(iWikiID)+" OR $subscrib.Wiki=0)") then
			iRec := FirstMark(dbUSER)
			while ReadRec(dbUSER, iRec) do
				f := rewrite(sgMailDir+Str(iWikiID)+"_"+GetField(dbUSER,"ID")+".msg")
				writeln(f, "From: "+sgSendFrom)
				writeln(f, "To: "+GetField(dbUSER,"EMail"))
				writeln(f, "Subject: Changes on page '"+GetField(dbWIKI,"Name")+"' at "+sgWikiName)
				writeln(f, "")
				writeln(f, "Hello "+GetField(dbUSER,"Name")+"!")
				writeln(f, "")
				write(f, "The page '"+GetField(dbWIKI,"Name")+"' at "+sgWikiName+" has been changed")
				if sEditorName then
					write(f, " by "+sEditorName)
				end
				writeln(f, ".")
				if GetField(dbWIKI, "ChangeLog") then
					writeln(f, "Change description:")
					writeln(f, "'"+GetField(dbWIKI, "ChangeLog")+"'")
				end
				writeln(f, "")
				writeln(f, "Follow this link:")
				if sgModRewrite then
					writeln(f, sgGeboURL+sgModRewrite+cleanName(GetField(dbWIKI,"Name")))
				else
					writeln(f, sgGeboURL+"programm/gebo.prg?name="+cleanName(GetField(dbWIKI,"Name")))
				end
				writeln(f, "")
				writeln(f, "You receive this email because you subscribed to the page '"+GetField(dbWIKI,"Name")+"' or to all pages.")
				writeln(f, "This email was auto-generated, please don't reply to it.")
				writeln(f, "")
				writeln(f, ".")
				writeln(f, "")
				close(f)
				iRec := NextMark(dbUSER,iRec)
			end
		end

		closedb(dbUSER)
		closedb(dbSUBSCR)
		closedb(dbWIKI)
		sendmails
endproc

procedure isWikiLockedBySession(sName : STRING) : INTEGER
		var dbLOCK : INTEGER
		var dbWIKI : INTEGER
		var iSema	 : INTEGER
		var iID		 : INTEGER
		var iRec	 : INTEGER
		var iResult : INTEGER

		dbWIKI := OpenDB(sgDBDir+"wiki.dat")
		if ReadRec(dbWIKI, FindRec(dbWIKI, cleanName(sName),1,1)) then
			iID := GetRField(dbWIKI,"ID")
		end
		closedb(dbWIKI)
		if iID then
			dbLOCK := OpenDB(sgDBDir+"lock.dat","",0,15)
			if iRec := ReadRec(dbLOCK, FindRec(dbLOCK,Str(iID),"lock.in1",1)) then
				if GetField(dbLOCK, "Session") = sgSession then
					iResult := 1
				else
					iResult := 0
				end
			else
				iResult := 0
			end
			CloseDB(dbLOCK)
		else
			iResult := 0
		end
		return iResult
endproc

procedure lockWiki(sName : STRING) : INTEGER
		var dbLOCK : INTEGER
		var dbWIKI : INTEGER
		var iSema	 : INTEGER
		var iID		 : INTEGER
		var iRec	 : INTEGER
		var iReturn : INTEGER

		dbWIKI := OpenDB(sgDBDir+"wiki.dat")
		if ReadRec(dbWIKI, FindRec(dbWIKI, cleanName(sName),1,1)) then
			iID := GetRField(dbWIKI,"ID")
		end
		closedb(dbWIKI)
		if iID, iSema := WaitSema(sgLockDir+"lock.sema",10000) then
			dbLOCK := OpenDB(sgDBDir+"lock.dat","",0,15)
			if iRec := ReadRec(dbLOCK, FindRec(dbLOCK,Str(iID),"lock.in1",1)) then
				if GetField(dbLOCK, "Session") = sgSession then
					SetRField(dbLOCK, "Expires", UNIX_NOW + igLockTimeout)
					WriteRec(dbLOCK, iRec)
					iReturn := 1
				elsif GetField(dbLOCK, "Session") # sgSession then //foreign lock
					if GetRField(dbLOCK, "Expires") < UNIX_NOW then //expired? then hijack
						SetRField(dbLOCK, "Expires", UNIX_NOW + igLockTimeout)
						SetField(dbLOCK, "Session", sgSession)
						WriteRec(dbLOCK, iRec)
						iReturn := 1
					else
						iReturn := 0
					end
				else
					iReturn := 0
				end
			else
				SetRField(dbLOCK, "Wiki",iID)
				SetRField(dbLOCK, "Expires", UNIX_NOW + igLockTimeout)
				SetField(dbLOCK, "Session", sgSession)
				WriteRec(dbLOCK, FileSize(dbLOCK) +1)
				iReturn := 1
			end
			CloseDB(dbLOCK)
			EndSema(iSema)
		else
			iReturn := 1
		end
		return iReturn
endproc

procedure unlockWiki(sName : STRING) : INTEGER
		var dbLOCK : INTEGER
		var dbWIKI : INTEGER
		var iSema	 : INTEGER
		var iID		 : INTEGER
		var iRec	 : INTEGER
		var iReturn : INTEGER

		dbWIKI := OpenDB(sgDBDir+"wiki.dat")
		if ReadRec(dbWIKI, FindRec(dbWIKI, cleanName(sName),1,1)) then
			iID := GetRField(dbWIKI,"ID")
		end
		closedb(dbWIKI)
		if iSema := WaitSema(sgLockDir+"lock.sema",10000) then
			dbLOCK := OpenDB(sgDBDir+"lock.dat","",0,15)

			if iRec := ReadRec(dbLOCK, FindRec(dbLOCK,Str(iID),"lock.in1",1)) then
				if GetField(dbLOCK, "Session") = sgSession then // have a lock? kill it
					DelRec(dbLOCK, iRec)
					iReturn := 1
				else
					iReturn := 0
				end
			end
			CloseDB(dbLOCK)
			EndSema(iSema)
		end
		return iReturn
endproc

procedure unlockWikisBySession(sSession : STRING) : INTEGER
		var dbLOCK : INTEGER
		var dbWIKI : INTEGER
		var iSema	 : INTEGER
		var iID		 : INTEGER
		var iRec	 : INTEGER
		var iReturn : INTEGER

		if iSema := WaitSema(sgLockDir+"lock.sema",10000) then
			dbLOCK := OpenDB(sgDBDir+"lock.dat","",0,15)

			if FindAndMark(dbLOCK, "$Session='"+sSession+"'") > 0 then
				DelMarkedRecords(dbLOCK)
			end
			CloseDB(dbLOCK)
			EndSema(iSema)
			iReturn := 1
		end
		return iReturn
endproc

procedure login(sUser : string; sPassword : STRING) : INTEGER

	var dbUSER		: INTEGER
	var dbSESSION	: INTEGER
	var iRec			: INTEGER
	var sSession	: STRING
	var iRes			: INTEGER
	var iRecS			: INTEGER
	var iSema			: INTEGER
	var iSemaSes	: INTEGER
	var sAdminList: STRING

	if iSemaSes := WaitSema(sgLockDir+"sessions.sema",10000) then
		dbUSER := OpenDB(sgDBDir+"user.dat")
		dbSESSION := OpenDB(sgDBDir+"sessions.dat","",0,15)
		if iRec := FindRec(dbUSER, sUser, 1,1) then
			ReadRec(dbUSER,iRec)
			if TestPW(sPassword, GetField(dbUSER, "Password")), (bgAdminEnables, GetRField(dbUSER, "EnabledStamp") OR !bgAdminEnables) then //MakePW(sPassword)
				if ReadRec(dbSESSION, iRecS := FindRec(dbSESSION, sgSession,1,1)) then
					SetRField(dbSESSION, "User", GetRField(dbUSER,"ID"))
					SetRField(dbSESSION, "Start",UNIX_NOW)
					SetRField(dbSESSION, "Expires",UNIX_NOW + igTimeout)
					if sAdminList := GetIdent(sgConfigFile,"Admin") then
						sAdminList := ";"+sAdminList+";"
						if Pos(";"+sUser+";",sAdminList)>0 then
							SetRField(dbSESSION, "Admin",1)
							bgAdminUser := 1
						end
					end
					WriteRec(dbSESSION, iRec)
				else
					//error
				end
				igUserID := GetRField(dbUSER,"ID")
				iRes := 1
				if GP("autologin") then
					iRes := 2
				end

				if iSema := WaitSema(sgLockDir+"user.sema",10000) then
					//try to get a semaphore and save the login timestamp. if no sema, no matter because of unimportance
					ReOpenDB(dbUSER, 15)
					ReadRec(dbUSER, iRec)
						SetRField(dbUSER, "LoginStamp", UNIX_NOW)
					WriteRec(dbUSER, iRec)
					ReOpenDB(dbUSER, 0)
					EndSema(iSema)
				end
			else
				sgSession := ""
				if bgAdminEnables, GetRField(dbUSER, "EnabledStamp")=0 then //account not yet activated
					iRes := -1
				else
					iRes := 0
				end

			end
		else

			iRes := 0
		end
		closedb(dbSESSION)
		EndSema(iSemaSes)
		closedb(dbUSER)
	end
	return iRes
endproc

procedure recoverPassword(sUsername, sEMail : STRING) : string

		var dbUSER : INTEGER
		var iSema		: INTEGER
		var iRec 		: INTEGER
		var f				: INTEGER
		var sPW		 	: STRING

		if sUsername="",sEMail="" then
			return "Enter either your username or your email address"
		end

		if iSema := WaitSema("user.sema",10000) then
			dbUSER := OpenDB(sgDBDir+"user.dat","",0,15)

			if sUsername then
				iRec := FindRec(dbUSER, sUsername,1,1)
			end

			if sEMail, iRec = 0 then
				iRec := FindRec(dbUSER, sEMail,"user.ind",1)
			end

			if ReadRec(dbUSER, iRec) then
				sPW := MakePW(CGIGetSession)
				SetField(dbUSER, "Password", MakePW(sPW))
				writerec(dbUSER, iRec)
				f := rewrite(sgMailDir+"recover_"+GetField(dbUSER, "ID")+".msg")
				writeln(f, "From: "+sgSendFrom)
				writeln(f, "To: "+GetField(dbUSER,"EMail"))
				writeln(f, "Subject: Account data for wiki "+sgWikiName)
				writeln(f, "")
				writeln(f, "Hello "+GetField(dbUSER,"Name")+"!")
				writeln(f, "")
				writeln(f, "Your password is:")
				writeln(f, "")
				writeln(f, sPW)
				writeln(f, "")
				writeln(f, "We ask you to change it immediately after you logged in again.")
				writeln(f, "Follow this link to the "+sgWikiName+" login page:")
				writeln(f, "")
				if sgModRewrite then
					writeln(f, sgGeboURL+sgModRewrite+"gebo:login")
				else
					writeln(f, sgGeboURL+"programm/gebo.prg?name=gebo:login")
				end
				writeln(f, "")
				writeln(f, "This email was auto-generated, please don't reply to it.")
				writeln(f, "")
				writeln(f, ".")
				writeln(f, "")
				close(f)
				sendmails
			end
			CloseDB(dbUSER)
			EndSema(iSema)
		End

endproc

procedure register : integer
	var dbUSER	: INTEGER
	var iSema		: INTEGER
	var iRet		: INTEGER
	var f				: INTEGER
	var iUserID	: INTEGER

	if !(GP("user"), GP("Password"),  GP("Password") = GP("Password2")) then
		iRet := 0
	else
		if iSema := WaitSema(sgLockDir+"user.sema",10000) then
			dbUSER := OpenDB(sgDBDir+"user.dat","",0,15)
			if FindRec(dbUSER, GP("user"), 1,1) then
				iRet := -1
			else
				ReadRec(dbUSER, 0)
					SetField(dbUSER, "Name", GP("user"))
					SetField(dbUSER, "EMail", GP("EMail"))
					SetField(dbUSER, "Password", MakePW(GP("Password")))
					SetRField(dbUSER, "Stamp", UNIX_NOW)
					if !bgAdminEnables then
						SetRField(dbUSER, "EnabledStamp", UNIX_NOW)
					end
				WriteRec(dbUSER, FileSize(dbUSER)+1)
				iUserID := GetRField(dbUSER,"ID")
				iRet:=1
				if bgNotifyOnNewUsers then
					f := rewrite(sgMailDir+"register_"+Str(iUserID)+".msg")
						writeln(f, "From: "+sgSendFrom)
						writeln(f, "To: "+sgAdminEMail)
						writeln(f, "Subject: New user "+GP("user")+" just registered to your wiki "+sgWikiName)
						writeln(f, "")
						writeln(f, "Hello!")
						writeln(f, "")
						writeln(f, "You receive this email because a new user just registered to your wiki "+sgWikiName+".")
						writeln(f, "")
						writeln(f, "User : "+GP("user"))
						writeln(f, "EMail: "+GP("EMail"))
						writeln(f, "")
						if bgAdminEnables then
							writeln(f, "This user's account needs to be reviewed and activated by an administrative user before he/she can login.")
							writeln(f, "Visit the following address and activate the account:")
							writeln(f, "")
							if sgModRewrite then
								writeln(f, sgGeboURL+sgModRewrite+"gebo:userlist")
							else
								writeln(f, sgGeboURL+"programm/gebo.prg?name=gebo:userlist")
							end
						end
						writeln(f, "")
						writeln(f, "Your GeboGebo informer")
						writeln(f, "")
						writeln(f, ".")
						writeln(f, "")
					close(f)
				end
			end
			EndSema(iSema)
			CloseDB(dbUSER)
		end
	end
	sendmails
	return iRet
endproc

procedure changeUserState(iUserID, ibStamp : INTEGER) : integer

	var dbUSER	: INTEGER
	var iSema		:	INTEGER
	var iRec		: INTEGER
	var iResult	: INTEGER
	var f				: INTEGER
	var sTO			: STRING
	var sName		: STRING

	if iSema := WaitSema(sgLockDir+"user.sema",10000) then
		dbUSER := OpenDB(sgDBDir+"user.dat","",0,15)
		if iResult := ReadRec(dbUSER, iRec := FindAuto(dbUSER, iUserID)) then
			sName := GetField(dbUSER, "Name")
			sTO :=  GetField(dbUSER, "EMail")
			SetRField(dbUSER, "EnabledStamp", ibStamp)
			WriteRec(dbUSER, iRec)
		end
		EndSema(iSema)
		CloseDB(dbUSER)

		if bgInformOnAdminEnables then
			f := rewrite(sgMailDir+"state_"+Str(iUserID)+".msg")
			writeln(f, "From: "+sgSendFrom)
			writeln(f, "To: "+sTO)
			if ibStamp then
				writeln(f, "Subject: Your "+sgWikiName+" account has been activated")
			else
				writeln(f, "Subject: Your "+sgWikiName+" account has been de-activated")
			end
			writeln(f, "")
			writeln(f, "Hello "+sName+"!")
			writeln(f, "")
			write(f, "Your user account for "+sgWikiName+" was ")
			if ibStamp then
				writeln(f, "enabled.")
				writeln(f, "")
				writeln(f, "You now can login at ")
				writeln(f, "")
				if sgModRewrite then
					writeln(f, sgGeboURL+sgModRewrite+cleanName("gebo:login"))
				else
					writeln(f, sgGeboURL+"programm/gebo.prg?name="+cleanName("gebo:login"))
				end
				writeln(f, "")
			else
				writeln(f, "disabled by an administator.")
				writeln(f, "")
			end
			writeln(f, "This email was auto-generated, please don't reply to it.")
			writeln(f, "")
			writeln(f, "Your GeboGebo informer")
			writeln(f, "")
			writeln(f, ".")
			writeln(f, "")

			close(f)
		end
	end
	sendmails
	return iResult
endproc

//
// include the render engine
// --------------------------------------------
//
uses render2c


procedure getWikiLinks(sWikiSource,sWikiContext : STRING; VAR aNames : STRING[]) : INTEGER

	var iOffset				:	INTEGER
	var iBeg, iEnd		: INTEGER
	var f							: INTEGER
	var sURL, sText		: STRING
	var sTarget				: STRING
	var p							: INTEGER
	var iNames				: INTEGER
	var iType					: INTEGER

	InitArray(aNames[igMaxLinksPerPage])
//get all [[ name ]] Tags
	while iBeg := RAMTEXT_Find(sWikiSource, sLinkOpen,iOffset) do
		iOffset := iBeg + Length(sLinkOpen)
		if iEnd := RAMTEXT_Find(sWikiSource,sLinkClose,iOffset + Length(sLinkOpen)) then
			RAMTEXT_Copy(sWikiSource, iBeg, iEnd - iBeg + Length(sLinkClose))
			iOffset := iEnd +Length(sLinkClose)
			sTarget := RAMTEXT_Part("ramtext:~clip", Length(sLinkOpen)+1,GetSize("ramtext:~clip")-Length(sLinkOpen)-Length(sLinkClose))
			if p := Pos("|",sTarget) > 0 then
				sText := RTrim(LTrim(sTarget[p+1,255]))
				sURL := RTrim(LTrim(sTarget[1,p-1]))
			else
				sText := sURL := RTrim(LTrim(sTarget))
			end

			if !(sURL IN ["http://*","https://*","ftp://*","gebo:*","*>*"]) then
				if sURL[1]=":" then			//NULL-Context
					sURL:=sURL[2,255]
				elsif iType:=getPageType(sURL) = cigTypePage then	//current or other context
					if Pos(":",sURL)=0, sWikiContext then // =current context
						sURL := sWikiContext+":"+sURL
					end
				end
				aNames[iNames]:=cleanName(sURL)
				iNames++
			end
		end
	end

//get all {{ name }} Tags
	iOffset:=1
	while iBeg := RAMTEXT_Find(sWikiSource, sImgOpen,iOffset) do
		iOffset := iBeg + Length(sImgOpen)
		if iEnd := RAMTEXT_Find(sWikiSource,sImgClose,iOffset + Length(sImgOpen)) then
			RAMTEXT_Copy(sWikiSource, iBeg, iEnd - iBeg + Length(sImgClose))
			iOffset := iEnd +Length(sImgClose)
			sTarget := RAMTEXT_Part("ramtext:~clip", Length(sImgOpen)+1,GetSize("ramtext:~clip")-Length(sImgOpen)-Length(sImgClose))
			if p := Pos("|",sTarget) > 0 then
				sText := sTarget[p+1,255]
				sURL := sTarget[1,p-1]
			else
				sText := sURL := sTarget
			end

			if !sURL IN ["http://*","https://*","ftp://*","gebo:*"] then
				aNames[iNames]:=cleanName(sURL)
				iNames++
			end
		end
	end

//get all (( name )) Tags
	iOffset:=1
	while iBeg := RAMTEXT_Find(sWikiSource, sFileOpen,iOffset) do
		iOffset := iBeg + Length(sFileOpen)
		if iEnd := RAMTEXT_Find(sWikiSource,sFileClose,iOffset + Length(sFileOpen)) then
			RAMTEXT_Copy(sWikiSource, iBeg, iEnd - iBeg + Length(sFileClose))
			iOffset := iEnd +Length(sFileClose)
			sTarget := RAMTEXT_Part("ramtext:~clip", Length(sFileOpen)+1,GetSize("ramtext:~clip")-Length(sFileOpen)-Length(sFileClose))
			if p := Pos("|",sTarget) > 0 then
				sText := sTarget[p+1,255]
				sURL := sTarget[1,p-1]
			else
				sText := sURL := sTarget
			end

			if !sURL IN ["http://*","https://*","ftp://*","gebo:*"] then
				aNames[iNames]:=cleanName(sURL)
				iNames++
			end
		end
	end
	return iNames

endproc

procedure interconnect(sName : STRING)
/*
refreshes the connections between the wiki pages
*/
	var dbWIKI2WIKI	:	INTEGER
	var dbWIKI			:	INTEGER
	var iRefs				: INTEGER
	var aIDs				: INTEGER[]
	var aReferences	: STRING[]
	var iRec				: INTEGER
	var i						: INTEGER
	var iSema				: INTEGER
	var iID					: INTEGER
	var sContext		: STRING
	var sSourceFile : STRING = "ramtext:source"
	var iType				: INTEGER
	var p						: INTEGER

	Ramtext(sSourceFile,8192)

	if sName[1]=":" then
		sName := sName[2,255]
	elsif iType := getPageType(sName)=cigTypePage then
		sContext := extractContext(sName)
	end

		if iSema := WaitSema(sgLockDir+"wiki.sema",10000) then
			dbWIKI := OpenDB(sgDBDir+"wiki.dat","",0,15)
			InitArray(aIDs[FileSize(dbWIKI)])
			GetAuto(dbWIKI, aIDs)
			if ReadRec(dbWIKI, FindRec(dbWIKI, sName,1,1)) then
				iID := AutoRecNo(dbWIKI)
				CopyMemo(dbWIKI, "Content", sSourceFile,1)
				dbWIKI2WIKI := OpenDB(sgDBDir+"wiki2wiki.dat","",0,15)
				iRefs := getWikiLinks(sSourceFile,sContext,aReferences)	//get all links off the page
				//Remove all connections FROM this page to others
				if iType IN [cigTypePage,cigTypeUser], FindAndMark(dbWIKI2WIKI, "$WikiFrom="+Str(iID)) > 0 then
					DelMarkedRecords(dbWIKI2WIKI)
				end
				i:= 0
				PrimTable(dbWIKI2WIKI)
				while i<iRefs do
					iRec := FindRec(dbWIKI, aReferences[i],1,1)
					if !FindRec(dbWIKI2WIKI, Str(iID)+","+Str(aIDs[iRec])+","+aReferences[i], "w2fromto.ind",1) then
						ReadRec(dbWIKI2WIKI,0)
						SetRField(dbWIKI2WIKI, "WikiFrom", iID)
						SetRField(dbWIKI2WIKI, "WikiTo", aIDs[iRec])
						SetField(dbWIKI2WIKI, "ToName", aReferences[i])
						WriteRec(dbWIKI2WIKI, FileSize(dbWIKI2WIKI) +1)
					end
					i++
				end
				//Update all (and those not yet) connections to pages linking TO this page
				if FindAndMark(dbWIKI2WIKI, "$ToName='"+sName+"'") then
					iRec := FirstMark(dbWIKI2WIKI)
					while ReadRec(dbWIKI2WIKI, iRec) do
						SetRField(dbWIKI2WIKI, "WikiTo", iID)
						writerec(dbWIKI2WIKI, iRec)
						iRec := NextMark(dbWIKI2WIKI,iRec)
					end
				end
				CloseDB(dbWIKI2WIKI)
			end
			CloseDB(dbWIKI)
			EndSema(iSema)
		end
endproc


procedure buildStatic(sName : string; bIndexPage : INTEGER)
//builds a static version of a page
		var dbWIKI				: INTEGER
		var sMainTemplate	: STRING = "ramtext:main"
		var sWikiTemplate	: STRING = "ramtext:wiki"
		var sWikiSource		: STRING = "ramtext:wikisource"
		var iType					: INTEGER
		var f							: INTEGER
		var sContext			: STRING
		var p							: INTEGER
		var bOldMode			: INTEGER
		var sOnClickStr		: STRING
		iType:=getPageType(sName)

		if !bgUplImages,iType=cigTypeImg then
			iType:=cigTypePage
		elsif !bgUplFiles, iType=cigTypeFile then
			iType:=cigTypePage
		end

		if iType = cigTypePage then
			sContext := extractContext(sName)
		end

		Ramtext(sStaticPage,8192)
		Ramtext(sWikiTemplate,8192)
		Ramtext(sMainTemplate,8192)
		dbWIKI := OpenDB(sgDBDir+"wiki.dat")

		if ReadRec(dbWIKI, FindRec(dbWIKI, cleanName(sName),1,1)) then
			if iType IN [cigTypePage,cigTypeUser], MemoLen(dbWIKI, "Content") then
				CopyMemo(dbWIKI,"Content",sWikiSource)
			elsif iType=cigTypeImg then
				f:=rewrite(sWikiSource := "ramtext:text:content",0)
				writeln(f,"{{"+sName+"}}")
				close(f)
			elsif iType=cigTypeFile then
				f:=rewrite(sWikiSource := "ramtext:text:content",0)
				writeln(f,"  * (("+sName+"|"+sName[6,255]+"))")
				close(f)
			else
				f:=rewrite(sWikiSource := "ramtext:text:content",0)
				close(f)
			end

			bOldMode := bgStaticMode
			if !bIndexPage then
				bgStaticMode := 1
			end
			sStaticPage := processWiki(dbWIKI, cleanName(sName), sWikiSource,sContext,1)
			bgStaticMode := bOldMode
			CopyFile(sgTempMain, sMainTemplate)
			CopyFile(sgTempWiki, sWikiTemplate)
			RAMTEXT_Subst(sWikiTemplate,"{_changed_}",lang("changed"),2)
			RAMTEXT_Subst(sWikiTemplate,"{_rev_}",lang("rev"),2)
			RAMTEXT_Subst(sWikiTemplate, "{pagehits/}","")
			while RAMTEXT_Subst(sMainTemplate, "{_activities_}",lang("activities"),2) do end
			while RAMTEXT_Subst(sMainTemplate, "{_allpages_}",lang("allpages"),2) do end
			RAMTEXT_Subst(sMainTemplate, "{_route_}",lang("route"),2)
			RAMTEXT_Subst(sMainTemplate, "{static/}","",2)
			RAMTEXT_Subst(sMainTemplate, "{_seconds_}",lang("seconds"),2)
			RAMTEXT_Subst(sMainTemplate, "{_losechanges_}",lang("losechanges"),2)
			RAMTEXT_Subst(sMainTemplate, "{_search_}",lang("search"),2)

			RAMTEXT_Subst(sMainTemplate, "{content/}",sWikiTemplate)
			RAMTEXT_Subst(sMainTemplate, "{content/}",AnsiToOem(sStaticPage),2)
			RAMTEXT_Subst(sMainTemplate, "{Revision}",dbWIKI,"Revision",4)
			RAMTEXT_Subst(sMainTemplate, "{Stamp}",formatStamp(GetRField(dbWIKI,"Stamp")))
				while RAMTEXT_Subst(sMainTemplate, "{route/}",lang("noroute")+" <a href='"+sgSelf+"?&amp;name={name}&amp;stay=dyn'>"+lang("todynamic")+"</a>",2) do end
// 			if bgStaticMode then
// 			else
// 				while RAMTEXT_Subst(sMainTemplate,"{route/}",showRoute,2) do end
// 			end
			while RAMTEXT_Subst(sMainTemplate, "{user/}","") do end
			while RAMTEXT_Subst(sMainTemplate, "{message/}","") do end
			if iType # cigTypeUser then
				sOnClickStr := "location.href='"+sgSelf+"?name={name}&amp;action=edit'"
				while RAMTEXT_Subst(sMainTemplate, "{buttons/}","<input type='button' onclick="+'"'+sOnClickStr+'"'+" value='"+lang("btn_editpg")+"'/> {morebutton/}") do end
  			sOnClickStr := "location.href='"+sgSelf+"?name={name}&amp;action=history'"
				while RAMTEXT_Subst(sMainTemplate, "{morebutton/}","<input type='button' onclick="+'"'+sOnClickStr+'"'+" value='"+lang("btn_history")+"'/>") do end
			end
			while RAMTEXT_Subst(sMainTemplate, "{buttons/}",'') do end
			while RAMTEXT_Subst(sMainTemplate, "{sessionbutton/}",'') do end
			While RAMTEXT_Subst(sMainTemplate, "{name}", sName,2) do end
			while RAMTEXT_Subst(sMainTemplate, "{DefaultPage}",sgDefault,2) do end
			if !bIndexPage then
				while RAMTEXT_Subst(sMainTemplate, "{DefaultPageURL}",sgRelPath + sgStaticDir+cleanName(sgDefault)+".html",2) do end
			else
				while RAMTEXT_Subst(sMainTemplate, "{DefaultPageURL}",sgSelf +"?name="+cleanName(sgDefault),2) do end
			end
			while RAMTEXT_Subst(sMainTemplate, "{WikiName}",sgWikiName,2) do end
			while RAMTEXT_Subst(sMainTemplate, "{headline/}",buildWikiLink(sName,sName,"backlinks",0,0,isPageProtected(sName)),2) do end
			while RAMTEXT_Subst(sMainTemplate,"{relpath}",sgRelPath,2) do end
			while RAMTEXT_Subst(sMainTemplate, "{self}",sgSelf,2) do end
			while RAMTEXT_Subst(sMainTemplate, "{duration}", "0") do end
			while RAMTEXT_Subst(sMainTemplate, "{version}",sgVersionStr) do end
			while RAMTEXT_Subst(sMainTemplate, "{subscription/}","") do end

			closedb(dbWIKI)

			macros.substMacros(sMainTemplate)
			RAMTEXT_Subst(sMainTemplate, "{timestamp}",formatStamp(UNIX_NOW))
			if !bIndexPage then
				CopyFile(sMainTemplate, sgRelPath + sgStaticDir+cleanName(sName)+".html")
			else
				CopyFile(sMainTemplate, "../index.html")
			end
		else
			closedb(dbWIKI)
		end
endproc

procedure rebuildAllStatic
//special function to rebuild all pages static
	var dbWIKI	: INTEGER
	var aNames	: STRING[]
	var iRec		: INTEGER
	if bgStaticEnabled OR bgStaticCreation then
		dbWIKI := OpenDB(sgDBDir+"wiki.dat")
		InitArray(aNames[FileSize(dbWIKI)+1])
		iRec := FirstRec(dbWIKI)
		while ReadRec(dbWIKI, iRec) do
			aNames[iRec]	:= GetField(dbWIKI, "Name")
			iRec := NextRec(dbWIKI)
		end
		closedb(dbWIKI)

		iRec := 0
		while aNames[iRec++] do
			cgiwriteln(Str(iRec)+" "+aNames[iRec]+"<br/>")
			if !isPageProtected(aNames[iRec]) then
				buildStatic(aNames[iRec],0)
			end
		end
	end
endproc

procedure showWiki(sName : STRING;bPreview, iRevision, bCountPagehits : INTEGER) : STRING

	var iRec					:	INTEGER
	var dbWIKI				: INTEGER
	var db						: INTEGER
	var sWikiSource		: STRING = "ramtext:wikisource"
	var sWikiPage			: STRING
	var sMain					:	STRING = "ramtext:main"
	var iType					: INTEGER
	var f							: INTEGER
	var iID						: INTEGER
	var sIDField			: STRING
	var iSubscribID 	: INTEGER
	var iSema					: INTEGER
	var iHits					: INTEGER
	var sContext			: STRING
	var p							: INTEGER
	var iProtection		: INTEGER
	var sAuth					: STRING
	var bDisplayProtectForm : INTEGER

	Ramtext(sWikiSource,8192)
	Ramtext(sMain,8192)
	CopyFile(sgTempWiki,sMain)

	if iProtection := isPageProtected(sName) = 2 then //this page is protected against reading, too?
		sAuth := getAuthKey(sName)
	end
	if sAuth[1,3] = "PW:" then
			if GP("auth") then	//password protection
				if GP("password") # sAuth[4,255] then
					bDisplayProtectForm := 1
				end
			else
				bDisplayProtectForm := 1
			end
			if bDisplayProtectForm = 1 then
				CopyFile(sgTempWikiProtected, sWikiSource)
				while ramtext_subst(sWikiSource, "{name}",sName) do end
				while ramtext_subst(sWikiSource, "{revision}",Str(iRevision)) do end
				RAMTEXT_Subst(sMain,"{content/}",sWikiSource)
				return sMain
			end
	elsif sAuth[1,3] = "ID:" then
		if !Scan(" "+Str(igUserID)+" ",sAuth) then
			CopyFile(sgTempWikiProtectedByID, sWikiSource)
			RAMTEXT_Subst(sMain,"{content/}",sWikiSource)
			return sMain
		end
	end

		iType:=getPageType(sName)

		if !bgUplImages,iType=cigTypeImg then
			iType:=cigTypePage
		elsif !bgUplFiles, iType=cigTypeFile then
			iType:=cigTypePage
		end

		if iType = cigTypePage then
			sContext := extractContext(sName)
		end

		if !bPreview then
			if iRevision > 0 then //load it from history
				dbWIKI := OpenDB(sgDBDir+"wiki.dat")
				ReadRec(dbWIKI, FindRec(dbWIKI, sName,1,1))
				iID := AutoRecNo(dbWIKI)
				CloseDB(dbWIKI)
				db := OpenDB(sgDBDir+"history.dat")
				iRec := FindRec(db, Str(iID)+","+Str(iRevision), "history.ind",1)
				sIDField := "WikiID"
			else
				db := OpenDB(sgDBDir+"wiki.dat")
				Access(db, 1)
				iRec := FindRec(db, sName, 1,1)

				if iRec, bCountPagehits, iSema := WaitSema(sgLockDir+"wiki.sema",1000) then //try to increment the Hits field
					//this has low priority and it does not really matter if it fails for any reason.
					ReOpenDB(db,15)
					Access(db, 1)
					ReadRec(db,iRec)
						IncrField(db, "Hits")
						iHits := GetRField(db, "Hits")
					WriteRec(db,iRec)
					ReOpenDB(db,0)
					Access(db, 1)
					EndSema(iSema)
				end

				sIDField := "ID"
			end
			if iRec > 0 then
				ReadRec(db, iRec)
				if iType IN [cigTypePage,cigTypeUser], MemoLen(db, "Content") then
					CopyMemo(db,"Content",sWikiSource)
				elsif iType=cigTypeImg then
					f:=rewrite(sWikiSource := "ramtext:text:content",0)
					if iRevision>1 then
						writeln(f,"{{"+sName+","+GetField(db, "Revision")+"}}")
					else
						writeln(f,"{{"+sName+"}}")
					end
					close(f)
				elsif iType=cigTypeFile then
					f:=rewrite(sWikiSource := "ramtext:text:content",0)
					writeln(f,"(("+sName+"|"+sName[6,255]+"))")
					close(f)
				else
					iRec := 0
				end
				RAMTEXT_Subst(sMain,"{Revision}",db, "Revision")
				RAMTEXT_Subst(sMain,"{Stamp}",formatStamp(GetRField(db,"Stamp")))
				iID := GetRField(db,sIDField)
			end
			if iRec <= 0 then
				RAMTEXT_Subst(sMain,"{Revision}","-")
				RAMTEXT_Subst(sMain,"{Stamp}","-")
			//not existing
			end

			CloseDb(db)
		else
			sWikiSource := "ramtext:text:content"
			RAMTEXT_Subst(sMain,"{Revision}","-")
			RAMTEXT_Subst(sMain,"{Stamp}","-")
		end

		if bgNoHTML then
			convertHTML(sWikiSource)
		end

		if bPreview OR iRevision > 0 then
			sWikiPage := processWiki(0,sgName, sWikiSource,sContext,0)
		elsif iRec > 0 then
			sWikiPage := processWiki(0,sgName,sWikiSource,sContext,1)
		else
			sWikiPage := "extern:../template/pagedoesnotexist.template"
		end
		if iID, igUserID then
			if iSubscribID := isSubscribed(igUserID,sName) then
				RAMTEXT_Subst(sMain,"{subscription/}","<a href='"+sgSelf+"?action=unsubscribe&amp;id="+Str(iSubscribID)+"&amp;name="+sName+"'>"+lang("unsubscribe")+"</a>")
			else
				RAMTEXT_Subst(sMain,"{subscription/}","<a href='"+sgSelf+"?action=subscribe&amp;name="+sName+"'>"+lang("subscribe")+"</a>")
			end
		else
			RAMTEXT_Subst(sMain,"{subscription/}","")
		end
		if bCountPagehits then
			RAMTEXT_Subst(sMain,"{pagehits/}",Str(iHits) +" "+ lang("pagehits"),2)
		else
			RAMTEXT_Subst(sMain,"{pagehits/}","")
		end
		RAMTEXT_Subst(sMain,"{_changed_}",lang("changed"),2)
		RAMTEXT_Subst(sMain,"{_rev_}",lang("rev"),2)
		if bPreview then
			RAMTEXT_Subst(sMain,"{content/}","<div class='preview'>{content/}</div>")
		end
		RAMTEXT_Subst(sMain,"{content/}",AnsiToOem(sWikiPage),2)
	return sMain
endproc



procedure editWiki(sName : STRING;bPreview : Integer;var sHeadline : STRING; iRevision,iPart,bViewOnly : INTEGER) : STRING
	var iRec					:	INTEGER
	var dbWIKI				: INTEGER
	var db						: INTEGER
	var iID						: INTEGER
	var sWikiSource		: STRING = "ramtext:wikisource"
	var sEditCtrls		: STRING = "ramtext:editctrls"
	var sMain					:	STRING = "ramtext:main"
	var iType					: INTEGER

	Ramtext(sWikiSource,8192)
	Ramtext(sEditCtrls,8192)
	Ramtext(sMain,8192)

	if bgUplImages, sName[1,4] LIKE "img:" then
		CopyFile(sgTempImgEdit,sMain)
		iType := cigTypeImg
		bPreview := 0
	elsif bgUplFiles, sName[1,5] LIKE "file:" then
		CopyFile(sgTempFileEdit,sMain)
		iType := cigTypeFile
		bPreview := 0
	else
		CopyFile(sgTempEdit,sMain)
		CopyFile(sgTempEditCtrls,sEditCtrls)
		iType := cigTypePage
	end

	if sName[1,5] LIKE "gebo:" then	//page names MUST NOT start with 'gebo:'
		sName := sName[6,255]
	end

	if bViewOnly then
		RAMTEXT_Subst(sMain, "{controls/}", "")
	else
		RAMTEXT_Subst(sMain, "{controls/}", sEditCtrls)
	end
	while RAMTEXT_Subst(sMain, "{_makelink_}",lang("makelink"),2) do end
	while RAMTEXT_Subst(sMain, "{_makebold_}",lang("makebold"),2) do end
	while RAMTEXT_Subst(sMain, "{_makeitalic_}",lang("makeitalic"),2) do end
	while RAMTEXT_Subst(sMain, "{_makeunderline_}",lang("makeunderline"),2) do end
	while RAMTEXT_Subst(sMain, "{_makestrike_}",lang("makestrike"),2) do end
	while RAMTEXT_Subst(sMain, "{_makemonospaced_}",lang("makemonospaced"),2) do end
	while RAMTEXT_Subst(sMain, "{_makeheadline_}",lang("makeheadline"),2) do end
	while RAMTEXT_Subst(sMain, "{_makehl1_}",lang("makehl1"),2) do end
	while RAMTEXT_Subst(sMain, "{_makehl2_}",lang("makehl2"),2) do end
	while RAMTEXT_Subst(sMain, "{_makehl3_}",lang("makehl3"),2) do end
	while RAMTEXT_Subst(sMain, "{_makehl4_}",lang("makehl4"),2) do end
	while RAMTEXT_Subst(sMain, "{_makehl5_}",lang("makehl5"),2) do end
	while RAMTEXT_Subst(sMain, "{_makeorderedlist_}",lang("makeorderedlist"),2) do end
	while RAMTEXT_Subst(sMain, "{_makeunorderedlist_}",lang("makeunorderedlist"),2) do end
	while RAMTEXT_Subst(sMain, "{_makecomment_}",lang("makecomment"),2) do end


	RAMTEXT_Subst(sMain, "{_keywords4page_}",lang("keywords4page"),2)
	RAMTEXT_Subst(sMain, "{_minorchanges_}",lang("minorchanges"),2)
	RAMTEXT_Subst(sMain, "{_log_}",lang("log"),2)
	RAMTEXT_Subst(sMain, "{_btn_savepg_}",lang("btn_savepg"),2)
	RAMTEXT_Subst(sMain, "{_btn_preview_}",lang("btn_preview"),2)
	RAMTEXT_Subst(sMain, "{_btn_cancel_}",lang("btn_cancel"),2)
	RAMTEXT_Subst(sMain, "{_btn_rename_}",lang("btn_rename"),2)
	RAMTEXT_Subst(sMain, "{_renameto_}",lang("renameto"),2)
	RAMTEXT_Subst(sMain, "{_reallyrename_}",lang("reallyrename"),2)

	if !bPreview then
		if iRevision > 0 then // editing an old version
			db := OpenDB(sgDBDir+"history.dat")
			dbWIKI := OpenDB(sgDBDir+"wiki.dat")
			ReadRec(dbWIKI, FindRec(dbWIKI, sName, 1,1))
			iID := AutoRecNo(dbWIKI)
			iRec := FindRec(db, Str(iID)+","+Str(iRevision), "history.ind",1)

		else
			db := dbWIKI := OpenDB(sgDBDir+"wiki.dat")
			iRec := FindRec(db, sName, 1,1)
		end
		if ReadRec(db, iRec) then
			sHeadline := lang("editing")+" "+sgName
			if iRevision > 0, iType=cigTypeImg  then
				sWikiSource := sgRelPath + sgDataImgDir+sgName[5,255]+","+Str(iRevision)
			elsif iType=cigTypeImg then
				sWikiSource := sgRelPath + sgDataImgDir + MemoStr(db,"Content")
			else
				CopyMemo(db,"Content",sWikiSource,0)
			end

			if iPart > 0 then
				sHeadline := sHeadline+" (Part "+Str(iPart)+")"
				sWikiSource := getPart(sWikiSource,iPart)
			end

		else
		//not existing
			sHeadline := lang("creating")+" "+sgName
			sWikiSource := ""
		end
		if igUserID then
			if GetRField(dbWIKI, "AnonymousLock") then
				RAMTEXT_Subst(sMain,"{anonymouslock/}", "<input type='checkbox' name='AnonymousLock' value='1' checked='checked'/> "+lang("lock4anonymous"))
			else
				RAMTEXT_Subst(sMain,"{anonymouslock/}", "<input type='checkbox' name='AnonymousLock' value='1'/> "+lang("lock4anonymous"))
			end
		else
			RAMTEXT_Subst(sMain,"{anonymouslock/}", "")
		end
		RAMTEXT_Subst(sMain,"{minorchanges/}", "")
		RAMTEXT_Subst(sMain,"{keywords}", db, "Keywords",1)
		RAMTEXT_Subst(sMain,"{ChangeLog}", "")
		if db # dbWIKI then
			CloseDb(dbWIKI)
		end
		CloseDb(db)
	else
		sHeadline := lang("preview") +" "+sgName
		if igUserID then
			if GP("AnonymousLock") then
				RAMTEXT_Subst(sMain,"{anonymouslock/}", "<input type='checkbox' name='AnonymousLock' value='1' checked='checked'/> "+lang("lock4anonymous"))
			else
				RAMTEXT_Subst(sMain,"{anonymouslock/}", "<input type='checkbox' name='AnonymousLock' value='1'/> "+lang("lock4anonymous"))
			end
		else
			RAMTEXT_Subst(sMain,"{anonymouslock/}", "")
		end
		if GP("minorchanges") then
			RAMTEXT_Subst(sMain,"{minorchanges/}", "checked='checked'")
		else
			RAMTEXT_Subst(sMain,"{minorchanges/}", "")
		end
		RAMTEXT_Subst(sMain,"{keywords}", GP("keywords"),1)
		RAMTEXT_Subst(sMain,"{ChangeLog}", GP("ChangeLog"),1)
		sWikiSource := "ramtext:text:content"
	end
	RAMTEXT_Subst(sMain,"{part}", Str(iPart))
	RAMTEXT_Subst(sMain,"{key}",ToHTML(MakePW(sgSession)))
	RAMTEXT_Subst(sMain,"{revision}", Str(iRevision),1)
	while RAMTEXT_Subst(sMain,"{content/}", sWikiSource) do end

	return sMain
endproc

procedure intoHistory(dbWIKI : INTEGER; iType : INTEGER)
	var dbHISTORY	: INTEGER
	var sName			: STRING
	sName := GetField(dbWIKI,"Name")
		dbHISTORY := OpenDB(sgDBDir+"history.dat","",0,15)
		ReadRec(dbHISTORY, 0)
		SetRecord(dbWIKI, dbHISTORY)
		SetRField(dbHISTORY, "WikiID", GetRField(dbWIKI, "ID"))
		if iType = cigTypeImg then
			CopyFile(sgRelPath + sgDataImgDir+MemoStr(dbWIKI,"Content"),sgRelPath + sgDataImgDir+sName[5,255]+","+GetField(dbHISTORY,"Revision"))
		end
		WriteRec(dbHISTORY, FileSize(dbHISTORY) +1)
		closedb(dbHISTORY)

endproc

procedure saveWiki(sName : STRING; iPart : integer)

	var iSema					: INTEGER
	var iRec					: INTEGER
	var dbWIKI				: INTEGER
	var dbHISTORY			: INTEGER
	var dbUSER				: INTEGER
	var i							: INTEGER
	var iID						: INTEGER
	var f 						: INTEGER
	var iType					: INTEGER
	var cFilename 		: String
	var p							:	Integer
	var iRec2					: INTEGER
	var iRecWiki			: INTEGER
	var bMinorChange	: INTEGER
	var bAnonymousLock: INTEGER
	var sContent			: STRING = "ramtext:text:content"
	var sOldSelf			: STRING

	iType := getPageType(sName)

	if sName[1,5] LIKE "gebo:" then	//page names MUST NOT start with 'gebo:'
		sName := sName[6,255]
	end

	if GP("minorchanges") then
		bMinorChange := 1
	end
	if igUserID, GP("AnonymousLock") then
		bAnonymousLock := 1
	end
	if iSema := WaitSema(sgLockDir+"wiki.sema",10000)	 then
		dbWIKI := OpenDB(sgDBDir+"wiki.dat","",0,15)
		iRecWiki := FindRec(dbWIKI, sName, 1,1)

		if  ReadRec(dbWIKI, iRecWiki) > 0 then	//save of an existing page
			if !iType IN [cigTypeUser,cigTypeFile], MemoLen(dbWIKI, "Content")>0 then // doing a backup into history? (not for files!)
				intoHistory(dbWIKI,iType)
			end
			Fulltext_UnScanRec(dbWIKI)
		else
			iRecWiki := FileSize(dbWIKI) +1
			SetField(dbWIKI, "Name", sName)
		end

		if iType=cigTypeImg then
			if GP("image"), GetSize(GP("image"))>0 then // image upload included?
				cFilename := lower(GP("image"))
				while p:=Pos("/",cFilename) do
					cFilename := cFilename[p+1,255]
				end
				CopyFile(GP("image"), sgRelPath + sgDataImgDir+cleanName(cFilename))
			elsif GP("restore") then //restore old image
				cFilename := MemoStr(dbWIKI,"Content")
				CopyFile(sgRelPath + sgDataImgDir+cleanName(sName[5,255])+","+GP("restore"),sgRelPath + sgDataImgDir+cleanName(cFilename))
			end
			f:=Rewrite(sContent)
			write(f, cFilename)
			close(f)
		elsif iType=cigTypeFile then
			if GP("file"), GetSize(GP("file"))>0 then // file upload included?
				cFilename := GP("file")
				while p:=Pos("/",cFilename) do
					cFilename := cFilename[p+1,255]
				end
				CopyFile(GP("file"), sgRelPath + sgDataFileDir+cFilename)
				f:=Rewrite(sContent)
				write(f, cFilename)
				close(f)
			END
		end

		SetRField(dbWIKI, "Stamp", UNIX_NOW)
		SetRField(dbWIKI, "Editor",igUserID)
		IncrField(dbWIKI, "Revision")

		SetRField(dbWIKI, "MinorChange",bMinorChange)
		if Val(GP("revision")) > 0 then
			SetField(dbWIKI, "ChangeLog", lang("restoredrevision")+" "+GP("revision")+"/"+GP("ChangeLog"))
		else
			SetField(dbWIKI, "ChangeLog",GP("ChangeLog"))
		end

		if iType = cigTypeUser then
			SetRField(dbWIKI, "AnonymousLock", 1)
		elsif igUserID then	// this is only possible for logged in users
			SetRField(dbWIKI, "AnonymousLock", bAnonymousLock)
		end
		SetField(dbWIKI, "Keywords",GP("keywords"))
		SetField(dbWIKI, "IP",sgIP)
		WriteRec(dbWIKI, iRecWiki)
		if iPart > 0 then
			Ramtext("ramtext:fullsource",8192)
			CopyMemo(dbWIKI, "Content", "ramtext:fullsource")
			sContent := insertPart(sContent,"ramtext:fullsource",iPart)
		end
		ReadMemo(dbWIKI, "Content", sContent,1,1)
		Fulltext_ScanRec(dbWIKI)

		iID := GetRField(dbWIKI, "ID")
		CloseDb(dbWIKI)
		EndSema(iSema)

		//refresh all connections from and to this wiki page
		interconnect(sName)

		if !bgConsoleMode then
			if igUserID, iSema := WaitSema(sgLockDir+"user.sema",10000) then
				//try to get a semaphore and save the edit name and timestamp. if no sema, no matter because of unimportance
				dbUSER := OpenDB(sgDBDir+"user.dat","",0, 15)
				iRec := FindAuto(dbUSER, igUserID)
				ReadRec(dbUSER, iRec)
					SetField(dbUSER, "LastEdit", sName)
					SetRField(dbUSER, "LastEditStamp", UNIX_NOW)
				WriteRec(dbUSER, iRec)
				CloseDB(dbUSER)
				EndSema(iSema)
			end

			if bgCreateStaticIndex, sName LIKE sgDefault then
				sOldSelf := sgSelf
				sgSelf := "./programm/gebo.prg"
				sgRelPath := "."
				if !isPageProtected(sName) then
					buildStatic(sName,1)
				end
				sgRelPath := ".."
				sgSelf := sOldSelf

			end

			if bgStaticEnabled OR bgStaticCreation then
				if !isPageProtected(sName) then
					buildStatic(sName,0)
				end
			end


			if bgEMailNotes, !igUserID OR !bMinorChange then //send allways when anonymous change or when major change
				makeNotifications(iID, sContent)
			end
		end
	end

endproc

procedure showBacklinks(sName : STRING) : STRING

	var iRec					:	INTEGER
	var dbWIKI				: INTEGER
	var dbWIKI2WIKI		: INTEGER
	var sMain					:	STRING = "ramtext:main"
	var iID						: INTEGER
	var f							: INTEGER
	var sTable				: STRING = "ramtext:backlinks"
	var iCnt					: INTEGER

	Ramtext(sMain,8192)
	Ramtext(sTable,8192)

	CopyFile(sgTempList,sMain)

	RAMTEXT_Subst(sMain, "{listHeadline/}",lang("backlinks"))
	RAMTEXT_Subst(sMain, "{listDescription/}","",4)
	dbWIKI := OpenDB(sgDBDir+"wiki.dat")
	dbWIKI2WIKI := OpenDB(sgDBDir+"wiki2wiki.dat")
	RELATION
	iRec := FindRec(dbWIKI, sName, 1,1)
	ReadRec(dbWIKI,iRec)
	iID := GetRField(dbWIKI, "ID")

	f := Rewrite(sTable)
	write(f, "<tr><td>#</td><td>"+lang("name")+"</td>")
	if FindAndMark(dbWIKI, "Exists($wiki2wiki.WikiTo="+Str(iID)+")") then
		SortMark(dbWIKI, "$Name")
		iRec := FirstMark(dbWIKI)
		while ReadRec(dbWIKI, iRec) do
			write(f, "<tr><td>"+Str(iCnt++)+"</td><td>")
			writeText(f, buildWikiLink(GetField(dbWIKI, "Name"),GetField(dbWIKI, "Name"),"",0,1,isPageProtected(GetField(dbWIKI, "Name"))))
			writeln(f, "</td></tr>")
			iRec := NextMark(dbWIKI, iRec)
		end
	else
		write(f, "<tr><td colspan='2'>"+lang("noreferences")+"</td></tr>")
	end
	close(f)

	CloseDB(dbWIKI2WIKI)
	CloseDb(dbWIKI)

	RAMTEXT_Subst(sMain,"{content/}", sTable)

	return sMain

endproc

procedure showAll(sSelection : STRING) : STRING

	var iRec					:	INTEGER
	var dbUSER				: INTEGER
	var dbWIKI				: INTEGER
	var dbWIKI2WIKI		: INTEGER
	var sMain					:	STRING = "ramtext:main"
	var iID						: INTEGER
	var f							: INTEGER
	var sTable				: STRING = "ramtext:allnames"
	var iCnt					: INTEGER
	var sFirstWord		: STRING
	var bShort 				: INTEGER
	var i							: INTEGER
	var sPart					: STRING
	var iPos					: INTEGER

	Ramtext(sMain,8192)
	Ramtext(sTable,8192)

	CopyFile(sgTempList,sMain)
	RAMTEXT_Subst(sMain, "{listHeadline/}",lang("allpages"),2)
	RAMTEXT_Subst(sMain, "{listDescription/}","",4)

	dbWIKI := OpenDB(sgDBDir+"wiki.dat")
	dbUSER := OpenDB(sgDBDir+"user.dat")
	if sSelection then
		Fulltext_MarkTable(dbWIKI, sSelection)
		SortMark(dbWIKI, "$Name")
		Access(dbWIKI, -2)
	else
		Access(dbWIKI,1)
	end
	iRec := FirstRec(dbWIKI)
	f := Rewrite(sTable)

	if NMarks(dbWIKI) > igDetailedResultMax OR NMarks(dbWIKI) = 0 then
				write(f, "<tr><td>#</td><td>"+lang("name")+"</td>")
				write(f, "<td>"+lang("rev")+"</td>")
				write(f, "<td>"+lang("lastedit")+"</td><td>"+lang("lasteditor"))
				write(f, "</td>")
				write(f, "<td>"+lang("keywords4page")+"</td>")
				writeln(f, "</tr>")
		bShort := 1
	else
				write(f, "<tr><td>#</td><td>"+lang("name")+"</td>")
				write(f, "<td>"+lang("rev")+"</td>")
				write(f, "<td>"+lang("lastedit")+"</td><td>"+lang("lasteditor"))
				write(f, "</td>")
				write(f, "<td>"+lang("contentmatch")+"</td>")
				writeln(f, "</tr>")
		bShort := 0
		i:=0
		while Pos(sSelection[i++],sgMyABC) do
			sFirstWord := sFirstWord + sSelection[i]
		end
		sFirstWord := OEMTOANSI(sFirstWord)
	end
	while ReadRec(dbWIKI,iRec), iCnt < igNaturalLimit do
		If MemoLen(dbWIKI,"Content") > 0 then
			iCnt++
			if bShort then
				write(f, "<tr><td>"+Str(iCnt)+"</td><td>")
				writeText(f, buildWikiLink(GetField(dbWIKI, "Name"),GetField(dbWIKI, "Name"),"",0,1,isPageProtected(GetField(dbWIKI, "Name"))))
				write(f, "</td>")
				write(f, "<td>"+GetField(dbWIKI, "Revision")+"</td>")
				write(f, "<td>"+formatStamp(GetRField(dbWIKI, "Stamp"))+ "</td><td>"+GetField(dbWIKI, "IP"))
				if GetRField(dbWIKI, "Editor") then
					ReadRec(dbUSER, FindAuto(dbUSER, GetRField(dbWIKI, "Editor")))
					write(f, " ("+ GetField(dbUSER, "Name")+")")
				end
				write(f, "</td>")
				write(f, "<td>"+GetField(dbWIKI, "Keywords")+"</td>")
				writeln(f, "</tr>")
			else
				write(f, "<tr><td>"+Str(iCnt)+"</td><td>")
				writeText(f, buildWikiLink(GetField(dbWIKI, "Name"),GetField(dbWIKI, "Name"),"",0,1,isPageProtected(GetField(dbWIKI, "Name"))))
				write(f, "</td>")
				write(f, "<td>"+GetField(dbWIKI, "Revision")+"</td>")
				write(f, "<td>"+formatStamp(GetRField(dbWIKI, "Stamp"))+ "</td><td>"+GetField(dbWIKI, "IP"))
				if GetRField(dbWIKI, "Editor") then
					ReadRec(dbUSER, FindAuto(dbUSER, GetRField(dbWIKI, "Editor")))
					write(f, " ("+ GetField(dbUSER, "Name")+")")
				end
				write(f, "</td>")
				CopyMemo(dbWIKI, "Content", "ramtext:hitcontent",1)
				if iPos := RAMTEXT_Find("ramtext:hitcontent", sFirstWord,1,1) then
					write(f, "</td><td>...")
					if iPos := iPos -100 <= 0 then iPos := 1 end
					sPart := Lower(RAMTEXT_Part("ramtext:hitcontent", iPos, 200))
					sFirstWord := Lower(sFirstWord)
					writeln(f, Exchange(sPart, sFirstWord,"<b>"+sFirstWord+"</b>"))
					write(f, "...")
				else
					write(f, "</td><td>")
				end
				writeln(f, "</td></tr>")
			end
		end
		iRec := NextRec(dbWIKI)
	end
	close(f)

	CloseDb(dbWIKI)

	RAMTEXT_Subst(sMain,"{content/}", sTable)

	return sMain

endproc

procedure showHistory(sName : STRING) : STRING

	var dbUSER		: INTEGER
	var dbWIKI		: INTEGER
	var dbHISTORY	: INTEGER
	var sHistory	: STRING = "ramtext:history"
	var iID				: INTEGER
	var sTable		: STRING = "ramtext:table"
	var f					: INTEGER
	var iRec			: INTEGER
	var iCnt			: INTEGER
	var bFirst		: INTEGER = 1
	var sNewerName: STRING

	Ramtext(sHistory,8192)
	Ramtext(sTable,8192)
	CopyFile(sgTempHistory,sHistory)
	RAMTEXT_Subst(sHistory, "{listHeadline/}",lang("history"))
	RAMTEXT_Subst(sHistory, "{listDescription/}",lang("listhistory")+"[[{name}]]",4)

	dbWIKI := OpenDB(sgDBDir+"wiki.dat")
	dbHISTORY := OpenDB(sgDBDir+"history.dat")
	dbUSER := OpenDB(sgDBDir+"user.dat")

	ReadRec(dbWIKI, FindRec(dbWIKI, sName, 1,1 ))
	iID := GetRField(dbWIKI, "ID")
	f:=Rewrite(sTable,0)
	write(f, "<tr><td nowrap='nowrap' valign='top'>Timestamp</td><td>Editor</td><td>Revision</td><td colspan='2'><input type='submit' value='"+lang("diff")+"'/></td><td>Log</td></tr>")
	ReadRec(dbUSER, FindRec(dbUSER, GetField(dbWIKI, "Editor"),"user.inr",1))
	write(f, "<tr><td nowrap='nowrap' valign='top'>"+formatStamp(GetRField(dbWIKI, "Stamp"))+"</td><td nowrap='nowrap' valign='top'>"+GetField(dbWIKI, "IP")+" "+GetField(dbUSER, "Name")+"</td>")
	if GetRField(dbWIKI, "MinorChange") then
		write(f, "<td nowrap='nowrap' valign='top'>")
		writeText(f, buildWikiLink(GetField(dbWIKI, "Name"), lang("current")+" ("+lang("rev")+" "+GetField(dbWIKI, "Revision")+")","",0,1,isPageProtected(GetField(dbWIKI, "Name"))))
		write(f, "</td><td valign='top'>")
	else
		write(f, "<td nowrap='nowrap' valign='top'>")
		writeText(f, buildWikiLink(GetField(dbWIKI, "Name"), lang("current")+ " "+lang("rev")+" "+GetField(dbWIKI, "Revision"),"",0,1,isPageProtected(GetField(dbWIKI, "Name"))))
		write(f, "</td><td valign='top'>")
	end
	write(f, "<input type='radio' name='revision1' value='"+GetField(dbWIKI, "Revision")+"' checked='checked'/></td><td valign='top'>")
	write(f, "<input type='radio' name='revision2' value='"+GetField(dbWIKI, "Revision")+"'/></td><td valign='top'>")
	write(f, ToHTML(GetField(dbWIKI, "ChangeLog")))
	sNewerName := GetField(dbWIKI,"Name")
	if FindAndMark(dbHISTORY, "$WikiID="+Str(iID)) then
		SortMark(dbHISTORY, "-$Stamp")
		iRec := FirstMark(dbHISTORY)
		//page history has no limit

		while ReadRec(dbHISTORY, iRec) do
			if sNewerName # GetField(dbHISTORY,"Name") then
				write(f, " "+lang("renamedfrom")+" "+GetField(dbHISTORY,"Name"))
				sNewerName :=GetField(dbHISTORY,"Name")
			end
			writeln(f, "</td></tr>")
			ReadRec(dbUSER, FindRec(dbUSER, GetField(dbHISTORY, "Editor"),"user.inr",1))
			write(f, "<tr><td nowrap='nowrap' valign='top'>"+formatStamp(GetRField(dbHISTORY, "Stamp"))+"</td><td nowrap='nowrap'  valign='top'>"+GetField(dbHISTORY, "IP")+" "+GetField(dbUSER, "Name")+"</td>")
			if GetRField(dbHISTORY, "MinorChange") then
				write(f, "<td nowrap='nowrap'  valign='top'>")
				writeText(f, buildWikiLink(GetField(dbWIKI, "Name"),"("+lang("rev")+" "+GetField(dbHISTORY, "Revision")+")","show&amp;revision="+GetField(dbHISTORY, "Revision"),0,0,isPageProtected(GetField(dbWIKI, "Name"))))
				write(f, "</td><td  valign='top'>")
			else
				write(f, "<td nowrap='nowrap'  valign='top'>")
				writeText(f, buildWikiLink(GetField(dbWIKI, "Name"),lang("rev")+" "+GetField(dbHISTORY, "Revision"),"show&amp;revision="+GetField(dbHISTORY, "Revision"),0,0,isPageProtected(GetField(dbWIKI, "Name"))))
				write(f, "</td><td  valign='top'>")
			end
			write(f, "<input type='radio' name='revision1' value='"+GetField(dbHISTORY, "Revision")+")'/></td><td valign='top'>")
			if bFirst then
				bFirst := 0
				write(f, "<input type='radio' name='revision2' value='"+GetField(dbHISTORY, "Revision")+"' checked='checked'/></td><td valign='top'>")
			else
				write(f, "<input type='radio' name='revision2' value='"+GetField(dbHISTORY, "Revision")+"'/></td><td valign='top'>")
			end
			write(f, ToHTML(GetField(dbHISTORY, "ChangeLog")))
			iRec := NextMark(dbHISTORY,iRec)
		end
	end
	write(f, "</td></tr>")
	close(f)
	closedb(dbHISTORY)
	closedb(dbWIKI)

	RAMTEXT_Subst(sHistory,"{content/}", sTable,2)
	return sHistory

endproc

procedure showFullActivity(sUser : STRING) : STRING
	var dbWIKI		:	INTEGER
	var dbHISTORY	: INTEGER
	var dbUSER		: INTEGER
	var sMain			: STRING = "ramtext:main"
	var sTable		: STRING = "ramtext:table"
	var iRec			: INTEGER
	var f					: INTEGER
	var iCnt			: INTEGER
	var aHistory	: STRING[,]
	var iUserID		: INTEGER

	Ramtext(sMain,8192)
	Ramtext(sTable,8192)
	CopyFile(sgTempList,sMain)
	RAMTEXT_Subst(sMain, "{listHeadline/}","{switchmode/}",2)
	RAMTEXT_Subst(sMain, "{listDescription/}",lang("listactivities"))

	if sUser then
		iUserID := getUserID(sUser)
	end

	dbWIKI := OpenDB(sgDBDir+"wiki.dat")
	dbHISTORY := OpenDB(sgDBDir+"history.dat")
	dbUSER := OpenDB(sgDBDir+"user.dat")

	InitArray(aHistory[FileSize(dbWIKI)+FileSize(dbHISTORY),6]) // Stamp, Name, Action, IP, Editor, Working, ChangeLog


	if sUser then
		FindAndMark(dbWIKI, "$Editor="+Str(iUserID))
		Access(dbWIKI, -2)
	end
	iCnt:=0
	iRec:=FirstRec(dbWIKI)
	while ReadRec(dbWIKI, iRec), iCnt<igNaturalLimit do
		ReadRec(dbUSER, FindRec(dbUSER, GetField(dbWIKI, "Editor"),"user.inr",1))
		aHistory[iCnt,0]:=Str(GetRField(dbWIKI, "Stamp"))
		aHistory[iCnt,1]:=GetField(dbWIKI, "Name")
		aHistory[iCnt,5]:="0"
		aHistory[iCnt,6]:=GetField(dbWIKI, "ChangeLog")
		if MemoLen(dbWIKI,"Content")=0 then
			aHistory[iCnt,2]:=lang("removed")
			aHistory[iCnt,5]:="1"
		elsif GetRField(dbWIKI, "Revision") = 1 then
			aHistory[iCnt,2]:=lang("created")
		else
			aHistory[iCnt,2]:=lang("rev")+" "+GetField(dbWIKI, "Revision")
		end
		aHistory[iCnt,3]:=GetField(dbWIKI, "IP")
		aHistory[iCnt,4]:=GetField(dbUSER, "Name")
		iRec := NextRec(dbWIKI)

		iCnt++
	end

	if sUser then
		FindAndMark(dbHISTORY, "$Editor="+Str(iUserID))
		Access(dbHISTORY, -2)
	end

	iRec:=FirstRec(dbHISTORY)
	while ReadRec(dbHISTORY, iRec) do
		ReadRec(dbUSER, FindRec(dbUSER, GetField(dbHISTORY, "Editor"),"user.inr",1))
		aHistory[iCnt,0]:=Str(GetRField(dbHISTORY, "Stamp"))
		aHistory[iCnt,1]:=GetField(dbHISTORY, "Name")
		aHistory[iCnt,5]:="0"
		aHistory[iCnt,6]:=GetField(dbHISTORY, "ChangeLog")
		if MemoLen(dbHISTORY,"Content")=0 then
			aHistory[iCnt,2]:=lang("removed")
			aHistory[iCnt,5]:="1"
		elsif GetRField(dbHISTORY, "Revision") = 1 then
			aHistory[iCnt,2]:=lang("created")
		else
			aHistory[iCnt,2]:=lang("rev")+" "+GetField(dbHISTORY, "Revision")
		end
		aHistory[iCnt,3]:=GetField(dbHISTORY, "IP")
		aHistory[iCnt,4]:=GetField(dbUSER, "Name")
		iRec := NextRec(dbHISTORY)
		iCnt++
	end

	closedb(dbHISTORY)
	closedb(dbWIKI)

	StrSort(aHistory,iCnt,0,"-%0")


	f:=Rewrite(sTable)
	writeln(f, "<tr><td>Time</td><td>Editor</td><td>Page</td><td>Changed</td><td>Log</td></tr>")
	iCnt := 0
	while iCnt < igNaturalLimit, iCnt < High(1,aHistory), aHistory[iCnt,1] do
		write(f, "<tr><td nowrap='nowrap' valign='top'>"+formatStamp(Val(aHistory[iCnt,0]))+"</td><td nowrap='nowrap' valign='top'>"+aHistory[iCnt,3]+" "+aHistory[iCnt,4]+"</td>")
		write(f, "<td nowrap='nowrap' valign='top'>")
		writeText(f, buildWikiLink(aHistory[iCnt,1],aHistory[iCnt,1],"",Val(aHistory[iCnt,5]),1,isPageProtected(aHistory[iCnt,1])))
		write(f, "</td><td nowrap='nowrap' valign='top'>")
		write(f, aHistory[iCnt,2])
		write(f, "</td><td valign='top'>")
		write(f, ToHTML(aHistory[iCnt,6][1,128]))
		write(f, ToHTML(aHistory[iCnt,6][129,255]))
		writeln(f, "</td></tr>")
		iCnt++
	end

	close(f)

	RAMTEXT_Subst(sMain,"{content/}", sTable)
	return sMain
endproc

procedure showActivity(sUser: STRING) : STRING
	var dbWIKI		:	INTEGER
	var dbHISTORY	: INTEGER
	var dbUSER		: INTEGER
	var sMain			: STRING = "ramtext:main"
	var sTable		: STRING = "ramtext:table"
	var iRec			: INTEGER
	var f					: INTEGER
	var iCnt			: INTEGER
	var iUserID		: INTEGER


	Ramtext(sMain,8192)
	Ramtext(sTable,8192)
	CopyFile(sgTempList,sMain)
	RAMTEXT_Subst(sMain, "{listHeadline/}","{switchmode/}",2)
	RAMTEXT_Subst(sMain, "{listDescription/}",lang("listactivities"))

	if sUser then
		iUserID := getUserID(sUser)
	end


	dbWIKI := OpenDB(sgDBDir+"wiki.dat")
	dbHISTORY := OpenDB(sgDBDir+"history.dat")
	dbUSER := OpenDB(sgDBDir+"user.dat")

	f:=Rewrite(sTable)

	if sUser, FindAndMark(dbWIKI, "$Editor="+Str(iUserID))>=0 then
		SortMark(dbWIKI, "-$Stamp")
		Access(dbWIKI, -2)
	else
		Access(dbWIKI,"wikistmp.ind")
	end

	writeln(f, "<tr><td>Time</td><td>Editor</td><td>Page</td><td>Changed</td></tr>")

	iRec:=FirstRec(dbWIKI)
	while ReadRec(dbWIKI, iRec), iCnt++ <= igNaturalLimit do
		ReadRec(dbUSER, FindRec(dbUSER, GetField(dbWIKI, "Editor"),"user.inr",1))
		writeln(f, "<tr><td>"+formatStamp(GetRField(dbWIKI, "Stamp"))+"</td><td>"+GetField(dbWIKI, "IP")+" "+GetField(dbUSER, "Name")+"</td>")
		if MemoLen(dbWIKI,"Content")=0 then
			write(f, "<td>")
			writeText(f, buildWikiLink(GetField(dbWIKI, "Name"),GetField(dbWIKI, "Name"),"",1,1,isPageProtected(GetField(dbWIKI, "Name"))))
			writeLn(f, "</td><td>")
			write(f, lang("removed"))
		else
			write(f, "<td>")
			writeText(f, buildWikiLink(GetField(dbWIKI, "Name"),GetField(dbWIKI, "Name"),"",0,1,isPageProtected(GetField(dbWIKI, "Name"))))
			writeLn(f, "</td><td>")
			if GetRField(dbWIKI, "Revision") = 1 then
				write(f, lang("created"))
			end
		end
		write(f, "</td></tr>")
		iRec := NextRec(dbWIKI)
	end
	close(f)

	closedb(dbHISTORY)
	closedb(dbWIKI)

	RAMTEXT_Subst(sMain,"{content/}", sTable)
	return sMain
endproc

procedure showLogin(sUser : STRING) : STRING

	var sMain			: STRING = "ramtext:main"

	Ramtext(sMain,8192)
	CopyFile(sgTempLogin,sMain)
	RAMTEXT_Subst(sMain, "{user}",sUser)
	RAMTEXT_Subst(sMain, "{_havecookies_}",lang("havecookies"))
	RAMTEXT_Subst(sMain, "{_haveaccount_}",lang("haveaccount"))
	while RAMTEXT_Subst(sMain, "{_user_}",lang("user")) do end
	RAMTEXT_Subst(sMain, "{_password_}",lang("password"))
	RAMTEXT_Subst(sMain, "{_email_}",lang("email"))
	RAMTEXT_Subst(sMain, "{_recovery_}",lang("recovery"))
	RAMTEXT_Subst(sMain, "{_recoveryinstructions_}",lang("recoveryinstructions"))
	RAMTEXT_Subst(sMain, "{_recover_}",lang("recover"))
	while RAMTEXT_Subst(sMain, "{_login_}",lang("login")) do end
	RAMTEXT_Subst(sMain, "{_setcookie_}",lang("setcookie"))
	if bgEnableRegistration then
		RAMTEXT_Subst(sMain, "{registration/}",lang("youcan")+' <a href="'+sgSelf+'?name=gebo:register">'+lang("registerhere")+'</a>.')
	else
		RAMTEXT_Subst(sMain, "{registration/}","")
	end
	return sMain

endproc

procedure showRegistration(sUsername, sEMail : STRING) : STRING

	var sRegForm : STRING = "ramtext:registration"

	Ramtext(sRegForm,8192)

	CopyFile(sgTempRegister,sRegForm)
	RAMTEXT_Subst(sRegForm, "{_userregistration_}",lang("userregistration"))
	RAMTEXT_Subst(sRegForm, "{_username_}",lang("username"))
	RAMTEXT_Subst(sRegForm, "{_password_}",lang("password"))
	RAMTEXT_Subst(sRegForm, "{_repeatpassword_}",lang("repeatpassword"))
	RAMTEXT_Subst(sRegForm, "{_registernow_}",lang("registernow"))
	RAMTEXT_Subst(sRegForm, "{_email_}",lang("email"),2)

	RAMTEXT_Subst(sRegForm, "{Username}",sUsername)
	RAMTEXT_Subst(sRegForm, "{EMail}",sEMail)

	return sRegForm

endproc


procedure showUnreferenced : string

	var iRec					:	INTEGER
	var dbWIKI				: INTEGER
	var dbWIKI2WIKI		: INTEGER
	var sMain					:	STRING = "ramtext:main"
	var iID						: INTEGER
	var f							: INTEGER
	var sTable				: STRING = "ramtext:unreferenced"
	var iCnt					: INTEGER
	var aIDs					: INTEGER[]
	Ramtext(sMain,8192)
	Ramtext(sTable,8192)

	CopyFile(sgTempList,sMain)
	RAMTEXT_Subst(sMain, "{listHeadline/}",lang("unreferencedpages"),2)
	RAMTEXT_Subst(sMain, "{listDescription/}",lang("listunreferenced"),4)

	dbWIKI := OpenDB(sgDBDir+"wiki.dat")
	dbWIKI2WIKI := OpenDB(sgDBDir+"wiki2wiki.dat")
	RELATION

	PrimTable(dbWIKI)
	Access(dbWIKI,1)
	InitArray(aIDs[FileSize(dbWIKI)])
	GetAuto(dbWIKI, aIDs)

	iRec := 0
	while iRec < FileSize(dbWIKI) do
		iRec++
		if !FindRec(dbWIKI2WIKI, Str(aIDs[iRec]),"wiki2wiki.in2",1) then
			SetMark(dbWIKI,iRec)
		end
	end
	f := Rewrite(sTable)
	write(f,"<tr><td>#</td><td>"+lang("name")+"</td></tr>")
	if NMarks(dbWIKI) then
		SortMark(dbWIKI, "$Name")
		iRec := FirstMark(dbWIKI)
		while ReadRec(dbWIKI, iRec) do
			if MemoLen(dbWIKI,"Content") > 0 then
				write(f, "<tr><td>"+Str(iCnt++)+"</td><td>")
				writeText(f, buildWikiLink(GetField(dbWIKI, "Name"),GetField(dbWIKI, "Name"),"",0,1,isPageProtected(GetField(dbWIKI, "Name"))))
				writeLn(f, "</td>")
				writeln(f, "</tr>")
			end
			iRec := NextMark(dbWIKI, iRec)
		end
	else
		write(f,"<tr><td colspan='2'>"+lang("nounreferenced")+"</td></tr>")
	end
	close(f)
	CloseDB(dbWIKI2WIKI)
	CloseDb(dbWIKI)

	RAMTEXT_Subst(sMain,"{content/}", sTable)

	return sMain

endproc

procedure showUsers : STRING
/*
builds a list of all users in alphabetical order
*/
	var sMain				: STRING = "ramtext:main"
	var sUserTable	: STRING = "ramtext:usertable"
	var iRec				: INTEGER
	var dbUSER			: INTEGER
	var f						: INTEGER
	var iCnt				: INTEGER

	Ramtext(sMain,8192)
	Ramtext(sUserTable,8192)
	CopyFile(sgTempList,sMain)
	RAMTEXT_Subst(sMain, "{listHeadline/}",lang("users"),2)
	RAMTEXT_Subst(sMain, "{listDescription/}",lang("listusers"),4)

	dbUSER := OpenDB(sgDBDir+"user.dat")
	PrimTable(dbUSER)
	Access(dbUSER, 1)
	f := Rewrite(sUserTable)
	write(f,"<tr><td>#</td>")
	write(f,"<td>"+lang("name")+"</td>")
	write(f,"<td>"+lang("usersince")+"</td>")
	write(f,"<td>"+lang("lastvisit")+"</td>")
	write(f,"<td colspan='2'>"+lang("lastedit")+"</td>")
	if bgAdminEnables,bgAdminUser then
		write(f,"<td>"+lang("StateActivation")+"</td>")
	end
	write(f,"</tr>")

	if FileSize(dbUSER) > 0 then
		iRec := FirstRec(dbUSER)
		while ReadRec(dbUSER, iRec) do
			write(f,"<tr><td>"+Str(iCnt++)+"</td><td>")
			writeText(f,buildWikiLink("user:"+cleanName(GetField(dbUSER,"Name")),GetField(dbUSER,"Name"),"",0,0,isPageProtected("user:"+cleanName(GetField(dbUSER, "Name")))))
			write(f,"</td><td>")
			write(f,formatStamp(GetRField(dbUSER,"Stamp")))
			write(f,"</td><td>")
			write(f,formatStamp(GetRField(dbUSER,"LoginStamp")))
			write(f,"</td><td>")
			writeText(f,buildWikiLink(GetField(dbUSER,"LastEdit"),GetField(dbUSER,"LastEdit"),"",0,0,isPageProtected(GetField(dbUSER, "LastEdit"))))
			write(f,"</td><td>")
			write(f,formatStamp(GetRField(dbUSER,"LastEditStamp")))
			if bgAdminEnables, bgAdminUser then
				write(f,"</td>")
				write(f,"<td>")
				if !GetRField(dbUSER, "EnabledStamp") then
					write(f,"<a href='{self}?action=activateuser&amp;user="+GetField(dbUSER, "ID")+"'>"+lang("EnableUser")+"</a>")
				else
					write(f,"<a href='{self}?action=deactivateuser&amp;user="+GetField(dbUSER, "ID")+"'>"+lang("DisableUser")+"</a>")
				end
			end
			write(f,"</td></tr>")
			iRec := NextRec(dbUSER)
		end
	else
		write(f,"<tr><td colspan='2'>"+lang("nousers")+"</td><td>")
	end
	close(f)
	closedb(dbUSER)
	RAMTEXT_Subst(sMain, "{content/}", sUserTable,4)
	return sMain
endproc

procedure editUser(iID, bAdminMode, iRevision : INTEGER) : STRING
	var sMain				: STRING = "ramtext:main"
	var iRec				: INTEGER
	var dbUSER			: INTEGER
	var db					: INTEGER
	var dbSUBSCR		: INTEGER

	Ramtext(sMain,8192)
	CopyFile(sgTempUserEdit,sMain)

	ramtext_subst(sMain, "{_user_}",lang("user"),4)
	ramtext_subst(sMain, "{_email_}",lang("email"),4)
	ramtext_subst(sMain, "{_fullsubscription_}",lang("fullsubscription"),4)
	ramtext_subst(sMain, "{_newpassword_}",lang("newpassword"),4)
	ramtext_subst(sMain, "{_repeatpassword_}",lang("repeatpassword"),4)
	ramtext_subst(sMain, "{_btn_saveuser_}",lang("btn_saveuser"),4)

	dbUSER := OpenDB(sgDBDir+"user.dat")
	ReadRec(dbUSER, FindAuto(dbUSER, iID))
	db := OpenDB(sgDBDir+"wiki.dat")
	ReadRec(db, FindRec(db, cleanName("user:"+GetField(dbUSER, "Name")),1,1))


	while ramtext_subst(sMain, "{id}",dbUSER, "ID") do end
	while ramtext_subst(sMain, "{name}","user:"+GetField(dbUSER, "Name")) do end
	while ramtext_subst(sMain, "{email}",dbUSER, "EMail") do end

	while ramtext_subst(sMain, "{content/}",db, "Content") do end
	closedb(db)
	closedb(dbUSER)

	dbSUBSCR := OpenDB(sgDBDir+"subscrib.dat")
	if FindRec(dbSUBSCR, "0,"+Str(iID),1,1) then
		ramtext_subst(sMain, "{fullsubscribe}","checked")
	else
		ramtext_subst(sMain, "{fullsubscribe}","")
	end
	closedb(dbSUBSCR)
	if bAdminMode then
		ramtext_subst(sMain, "{drop/}","<input type='button' value='"+lang("dropuser")+"' onclick="+'"'+"dropUser('"+sgSelf+"?action=dropuser&amp;id="+Str(iID)+"');"+'"'+"/>")
	else
		ramtext_subst(sMain, "{drop/}","")
	end
	RAMTEXT_Subst(sMain,"{key}",ToHTML(MakePW(sgSession)))
	return sMain
endproc

procedure saveUser(iID, bAdminMode : INTEGER)

	var iRec				: INTEGER
	var dbUSER			: INTEGER
	var iSema				: INTEGER
	var iUserID			: INTEGER
	var iSubscribID	: INTEGER

	if iSema := WaitSema(sgLockDir+"user.sema",10000) then
		dbUSER := OpenDB(sgDBDir+"user.dat","",0,15)
		ReadRec(dbUSER, iRec := FindAuto(dbUSER, iID))
		if iRec = 0 then
			iRec := FileSize(dbUSER) +1
		end
			SetField(dbUSER, "EMail", GP("email"))
			if GP("pw"), GP("pw") = GP("pw2") then
				SetField(dbUSER, "Password", MakePW(GP("pw")))
			end
			WriteRec(dbUSER, iRec)
			iUserID := GetRField(dbUSER,"ID")
		CloseDB(dbUSER)
		EndSema(iSema)
	else

	end
	if !GP("fullsubscribe") then
		if iSubscribID := isSubscribed(iUserID,"") then
			unsubscribe(iSubscribID)
		end
	else
		if !iSubscribID := isSubscribed(iUserID,"") then
			subscribe(iUserID,"")
		end
	end

endproc

procedure dropUser(iID, bAdminMode : INTEGER)

	var iRec				: INTEGER
	var dbUSER			: INTEGER
	var iSema				: INTEGER


	if iSema := WaitSema(sgLockDir+"user.sema",10000) then
		dbUSER := OpenDB(sgDBDir+"user.dat","",0,15)
		iRec := FindAuto(dbUSER, iID)
		if iRec, bAdminMode, GP("drop") then
			DelRec(dbUSER, iRec)
		end
		CloseDB(dbUSER)
		EndSema(iSema)
	else

	end

endproc


procedure showMissing : string

	var iRec					:	INTEGER
	var dbWIKI				: INTEGER
	var dbWIKI2WIKI		: INTEGER
	var sMain					:	STRING = "ramtext:main"
	var f							: INTEGER
	var sTable				: STRING = "ramtext:unreferenced"
	var iCnt					: INTEGER
	var sName					: STRING
	var sOldName 			: STRING
	Ramtext(sMain,8192)
	Ramtext(sTable,8192)

	CopyFile(sgTempList,sMain)
	RAMTEXT_Subst(sMain, "{listHeadline/}",lang("missingpages"),2)
	RAMTEXT_Subst(sMain, "{listDescription/}",lang("listmissing"),4)

	dbWIKI := OpenDB(sgDBDir+"wiki.dat")
	dbWIKI2WIKI := OpenDB(sgDBDir+"wiki2wiki.dat")

	PrimTable(dbWIKI2WIKI)
	Access(dbWIKI2WIKI,1)
	f := Rewrite(sTable)
	write(f,"<tr><td>#</td><td>"+lang("name")+"</td></tr>")
	if FindAndMark(dbWIKI2WIKI, "$WikiTo = 0") then
		SortMark(dbWIKI2WIKI, "$ToName")
		iRec := FirstMark(dbWIKI2WIKI)
		sOldName := ""
		while ReadRec(dbWIKI2WIKI, iRec) do
			sName := cleanName(GetField(dbWIKI2WIKI, "ToName"))
			if sName # sOldName then
				If !FindRec(dbWIKI, sName,1,1) then
					write(f, "<tr><td>"+Str(iCnt++)+"</td><td>")
					writeText(f, buildWikiLink(sName,sName,"",1,0,0))
					write(f, "</td>")
					writeln(f, "</tr>")
				end
				sOldName := sName
			end
			iRec := NextMark(dbWIKI2WIKI, iRec)
		end
	else
		write(f,"<tr><td colspan='2'>"+lang("nomissing")+"</td></tr>")
	end
	close(f)

	CloseDB(dbWIKI2WIKI)
	CloseDb(dbWIKI)

	RAMTEXT_Subst(sMain,"{content/}", sTable)

	return sMain

endproc

procedure showSubscriptions(sUser	: STRING) : string

		var dbSUBSCR	: INTEGER
		var dbWIKI		: INTEGER
		var dbUSER		: INTEGER
		var iUserID		: INTEGER
		var iRec			: INTEGER
		var aResult		: STRING[,1]
		var iCnt			: INTEGER
		var iMax			: INTEGER
		var sMain			:	STRING = "ramtext:main"
		var f					: INTEGER
		var sTable		: STRING = "ramtext:subscriptions"


		Ramtext(sMain,8192)
		Ramtext(sTable,8192)

		CopyFile(sgTempList,sMain)
		RAMTEXT_Subst(sMain, "{listHeadline/}",lang("subscribedpages"),2)
		RAMTEXT_Subst(sMain, "{listDescription/}",lang("listsubscriptions"),4)


		dbWIKI := OpenDB(sgDBDir+"wiki.dat")
		dbSUBSCR := OpenDB(sgDBDir+"subscrib.dat")
		RELATION

		dbUSER := OpenDB(sgDBDir+"user.dat")
		if ReadRec(dbUSER, FindRec(dbUSER, sUser, 1,1)) then
			iUserID := GetRField(dbUSER,"ID")
		end
		closedb(dbUSER)

		f := rewrite(sTable)
		write(f, "<tr><td>#</td><td>"+lang("name")+"</td>")
		write(f, "<td></tr>")
		if findandmark(dbSUBSCR, "$User="+Str(iUserID)+",$Wiki>0") then
			InitArray(aResult[NMarks(dbSUBSCR),1])
			iRec := FirstMark(dbSUBSCR)
			iCnt:=0
			while ReadRec(dbSUBSCR, iRec) do
				do _"aResult[iCnt,0]:=$subscrib.Wiki.Name"
				aResult[iCnt,1]:= GetField(dbSUBSCR,"ID")
				iRec := NextMark(dbSUBSCR, iRec)
				iCnt++
			end
			iMax := iCnt
			StrSort(aResult,iMax,0,"0")

			iCnt := 0
			while iCnt < iMax do
				iCnt++
				write(f, "<tr><td>"+Str(iCnt)+"</td><td>")
				writeText(f, buildWikiLink(aResult[iCnt,0],aResult[iCnt,0],"",0,1,isPageProtected(aResult[iCnt,0])))
				write(f, "</td><td><a href='"+sgSelf+"?action=unsubscribe&amp;id="+aResult[iCnt,1]+"&amp;name="+sgName+"'>"+lang("unsubscribe")+"</a></td></tr>")
			end
		else
			write(f, "<tr><td colspan='3'>"+lang("nosubscriptions")+"</td></tr>")
		end
		close(f)
		closedb(dbSUBSCR)
		closedb(dbWIKI)

		RAMTEXT_Subst(sMain,"{content/}", sTable)

		return sMain

endproc

procedure diff(so, sn, st : string)

	CGIExec(sgPathToDiff+ " "+so + " "+sn +" > "+st)

endproc

procedure showDiff : string
	var sDiff			: STRING = "ramtext:diffview")
	var ft, fs		: INTEGER
	var iRevision1 : INTEGER = VAL(GP("revision1"))
	var iRevision2 : INTEGER = VAL(GP("revision2"))
	var sL					: STRING
	var dbHISTORY	: INTEGER
	var dbWIKI		: INTEGER
	var iID				: INTEGER
	var iLine			: INTEGER
	var iLineNew			: INTEGER
	var sLineNo		: STRING
	var p						: INTEGER
	var sDifference	: STRING
	var bFirstTime	: INTEGER =1
	Ramtext(sDiff, 8192)
	Ramtext("ramtext:new", 8192)
	Ramtext("ramtext:old", 8192)
	Ramtext("ramtext:diff", 8192)
	CopyFile(sgTempDiff,sDiff)
	RAMTEXT_Subst(sDiff,"{_differences_}",lang("differences"))
	RAMTEXT_Subst(sDiff,"{_diffadded_}",lang("diffadded"))
	RAMTEXT_Subst(sDiff,"{_diffchanged_}",lang("diffchanged"))
	RAMTEXT_Subst(sDiff,"{_diffdeleted_}",lang("diffdeleted"))
	dbWIKI := OpenDB(sgDBDir+"wiki.dat")
	dbHISTORY := OpenDB(sgDBDir+"history.dat")

	ReadRec(dbWIKI, FindRec(dbWIKI, sgName, 1,1))
	iID := AutoRecNo(dbWIKI)

	if iRevision1 = 0 OR iRevision1 = GetRField(dbWIKI, "Revision") then
		iRevision1 := GetRField(dbWIKI, "Revision")
		CopyMemo(dbWIKI, "Content", sgTempDir +sgSession+".new")
	else
		ReadRec(dbHISTORY, FindRec(dbHISTORY, Str(iID)+","+Str(iRevision1), "history.ind",1))
		CopyMemo(dbHISTORY, "Content", sgTempDir +sgSession+".new")
	end

	if iRevision2 = 0 then
		ReadRec(dbHISTORY, FindRec(dbHISTORY, Str(iID)+","+Str(GetRField(dbWIKI, "Revision") -1), "history.ind",1))
		CopyMemo(dbHISTORY, "Content", sgTempDir +sgSession+".old")
	else
		ReadRec(dbHISTORY, FindRec(dbHISTORY, Str(iID)+","+Str(iRevision2), "history.ind",1))
		CopyMemo(dbHISTORY, "Content", sgTempDir +sgSession+".old")
	end
	closedb(dbHISTORY)
	closedb(dbWIKI)

	diff(sgTempDir +sgSession+".old",sgTempDir +sgSession+".new",sgTempDir +sgSession+".diff")
	ft := rewrite("ramtext:diff")
	fs := reset(sgTempDir +sgSession+".diff",0)
	while !eot(fs) do
		sL := ReadLn(fs)
		if sL[1]=">" then
			write(ft, "<tr class='"+sDifference+"'><td width='30'>"+Str(iLine++)+"</td><td>")
			write(ft,ToHTML(sL[3,128]))
			write(ft,ToHTML(sL[131,255])+"&nbsp;")
			writeln(ft,"</td></tr>")
		elsif sL[1]="<" then
			write(ft, "<tr class='"+sDifference+"'><td width='30'>"+Str(iLine++)+"</td><td>")
			write(ft,ToHTML(sL[3,128]))
			write(ft,ToHTML(sL[131,255])+"&nbsp;")
			writeln(ft,"</td></tr>")
		elsif sL[1]="\" then

		elsif sL[1]="-" then
			iLine := iLineNew
			write(ft, "<tr class='diffspace'><td colspan='2'><hr>")
			writeln(ft,"</td></tr>")
			// ignore the rest
		else
			if bFirstTime then
				bFirstTime:=0
			else
				write(ft, "</table><br/><br/><table class='diff'>")
				write(ft, "<tr class='diffspace'><td colspan='2'>")
				writeln(ft,"</td></tr>")
			end
			sLineNo := ""
			p:=0
			while Pos(sL[p++],"0123456789") do
				sLineNo := sLineNo + sL[p]
			end
			iLine := Val(sLineNo) -1
			sLineNo := ""
			if sL[p]="," then
				while Pos(sL[p++],"0123456789") do end
			end
			if sL[p] = "c" then
				sDifference := "changed"
			elsif sL[p] = "d" then
				sDifference := "deleted"
			elsif sL[p] = "a" then
				sDifference := "added"
			end
			while Pos(sL[p++],"0123456789") do
				sLineNo := sLineNo + sL[p]
			end
			iLineNew := Val(sLineNo) -1
		end
	end
	close(fs)
	close(ft)
	delfile(sgTempDir +sgSession+".old")
	delfile(sgTempDir +sgSession+".new")
	delfile(sgTempDir +sgSession+".diff")
	RAMTEXT_Subst(sDiff, "{content/}", "ramtext:diff")
	return sDiff


endproc

procedure renameWiki(sName, sTargetName : STRING) : integer

		var dbWIKI, dbHISTORY	: INTEGER
		var iSema							: INTEGER
		var iRec							: INTEGER

		if iSema := WaitSema(sgLockDir+"wiki.sema",10000) then
			dbWIKI := OpenDB(sgDBDir+"wiki.dat","",0,15)
			if !FindRec(dbWIKI, sTargetName, 1,1) then //name still free for use
				ReadRec(dbWIKI, iRec:= FindRec(dbWIKI, sName, 1,1))

				intoHistory(dbWIKI,cigTypePage)

				Fulltext_UnScanRec(dbWIKI)
				SetField(dbWIKI, "Name", sTargetName)
				SetRField(dbWIKI, "Stamp", UNIX_NOW)
				IncrField(dbWIKI, "Revision")
				SetRField(dbWIKI, "Editor",igUserID)
				SetField(dbWIKI, "ChangeLog",GP("ChangeLog"))
				SetField(dbWIKI, "IP",sgIP)
				writerec(dbWIKI, iRec)
				Fulltext_ScanRec(dbWIKI)
			else
				CloseDB(dbWIKI)
				EndSema(iSema)
				return 0
			end
			CloseDB(dbWIKI)
			EndSema(iSema)
		else
			return 0
		end
		interconnect(sTargetName)
		return 1
endproc

procedure randomPage : string
/*
Displays a random page (that was not deleted before)
*/
		var dbWIKI : INTEGER
		var iMax	 : INTEGER
		var sName	 : STRING

		dbWIKI := OpenDB(sgDBDir+"wiki.dat")
		iMax := FileSize(dbWIKI)

		while iMax # 0 do
			ReadRec(dbWIKI, Random(iMax) +1)
			if MemoLen(dbWIKI, "Content") > 0 then
				iMax := 0
				sName := GetField(dbWIKI,"Name")
			end
		end
		CloseDB(dbWIKI)
		return sName
endproc

procedure experiment : string

	var dbWIKI				: INTEGER
	var dbWIKI2WIKI		: INTEGER
	var aIDs					: INTEGER[]
	var aScores				: STRING[,2]
	var i,x						: INTEGER
	var f							: INTEGER
	var sMain					: STRING = "ramtext:main"


	dbWIKI := OpenDB(sgDBDir+"wiki.dat")
	dbWIKI2WIKI := OpenDB(sgDBDir+"wiki2wiki.dat")
	InitArray(aIDs[FileSize(dbWIKI)])
	InitArray(aScores[FileSize(dbWIKI),2])
	GetAuto(dbWIKI,aIDs)

	while i < FileSize(dbWIKI) do
		i++
		aScores[i,2] := Str(aIDs[i])
		x := FindAndMark(dbWIKI2WIKI, "$WikiTo="+Str(aIDs[i])) *10
		aScores[i,1] := Str(x + FindAndMark(dbWIKI2WIKI, "$WikiFrom="+Str(aIDs[i])+", $WikiTo>0"))
	end

	StrSort(aScores,FileSize(dbWIKI),1,"-%1")

	f := rewrite(sMain)
	i:=0
	while i < FileSize(dbWIKI) do
		i++
		readrec(dbWIKI, FindAuto(dbWIKI, Val(aScores[i,2])))
		writeText(f,buildWikiLink(getField(dbWIKI, "Name"),getField(dbWIKI, "Name"),"",0,1,0))
		writeln(f," : ")
		writeln(f,aScores[i,1]+"<br/>")
	end
	close(f)
	closedb(dbWIKI2WIKI)
	closedb(dbWIKI)

	return sMain

endproc

procedure exportWiki(sName, sFormat : STRING; bComplete : INTEGER) : integer
/*
	exports a Wiki page in the given format
*/
	var dbWIKI				: INTEGER
	var sRev					: STRING
	var sContentType	: STRING
	var sRamExport		: string = "ramtext:exportsource"

	Ramtext(sRamExport,8192)
	if isPageProtected(sName) then					//don't export protected pages
		return 0
	end
	dbWIKI := OpenDB(sgDBDir+"wiki.dat")

	ReadRec(dbWIKI, FindRec(dbWIKI, sName, 1,1))
	CopyMemo(dbWIKI, "Content", sRamExport)
	sRev := GetField(dbWIKI, "Revision")
	closedb(dbWIKI)

	if sFormat = "" then
		sFormat := "raw"
	end
	SetPara("ec 1")
	// the export-Module MUST return the content-type specifier for the result
	DO _"sContentType := ExecMacro(export_"+sFormat+",export('"+sName+"',"+sRev+",'"+sRamExport+"',"+Str(bComplete)+"))"
	SetPara("ec 0")

	if TDB_LastError then
		return 0
	else
		if bComplete then
			CopyFile(sRamExport, sgTempExportDir+sName+"."+sContentType)
		else
			CGIClearBuffer
			CGIWriteln("content-type: "+sContentType)
			CGIWriteln("")
			CGICloseBuffer
			CopyFile(sRamExport,"con")
		end
		return 1
	end

endproc

procedure fullexport(sFormat : STRING)
/*
exports all (not deleted) wiki pages into a archive and sends this to the web browser
*/
	var dbWIKI	: INTEGER
	var aPages	: STRING[]
	var i				: INTEGER
	var iMarks	: INTEGER
	var iSema		: INTEGER
	var sBefore	: STRING
	var sExec		: STRING
	var p				: INTEGER
	dbWIKI := OpenDB(sgDBDir+"wiki.dat")
	if iMarks := FindAndMark(dbWIKI, "MemoLen($wiki, 'Content') > 0") then
		InitArray(aPages[NMarks(dbWIKI)+1])
		SortMark(dbWIKI, "$Name")
		Access(dbWIKI, -2)
		SUB _DBName(dbWIKI)
			aPages[i++]:=GetField(dbWIKI,"Name")
		ENDSUB
	end
	CloseDB(dbWIKI)
	i := 0
	if iSema := WaitSema(sgLockDir+"export.sema",10000) then
		while i++ <= iMarks do
			exportWiki(aPages[i],sFormat,1)
		end
		sBefore := getdir(0)
		chdir(sgTempExportDir)
		sExec := Exchange(sgExportExecute, "$WikiName", cleanName(sgWikiName))
		sFile := sExec[p:=Pos("[",sExec) +1, Pos("]",sExec) - p]
		sExec := Exchange(Exchange(sExec,"[",""),"]","")
		setcgilog(sFile + " # "+sExec)
		CGIExec(sExec)
		chdir(sBefore)
		CGIClearBuffer

 		CGIWriteln("content-type: application/octet-stream")
  	CGIWriteln("content-disposition: filename="+sFile+";")
		CGIWriteln("")
		cgiclosebuffer
		CopyFile(sgTempExportDir+sFile, "con")

		rDelFile(sgTempExportDir+"*")

		EndSema(iSema)
		halt
	end
endproc

procedure expires(iSeconds  : INTEGER) : string
/*
Builds a TimeString like this
Sunday, 01-Dec-2099 12:00:00
*/
	var s 			:	STRING
	Var sD, sM 	:	STRING
	var iD			: INTEGER

	iD := UNIX_Date(iSeconds)
	s := Choice( 1+(iD+5) MOD 7,"Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday")+", "
	s := s + Str(Day(iD),2,0,"","0") +"-"
	s := s + Choice(Month(iD)+1,"Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec") + "-"
	s := s + Str(Year(iD)) +" "+TimeStr(UNIX_Time(iSeconds),0)
	return s

endproc

procedure smartlink(sGebo : STRING)

	var sMain			: STRING = "ramtext:content"
	var f					: INTEGER
	var dbWIKI		: INTEGER
	var sSelection: STRING = GP("lookup")

	Ramtext(sMain,8192)
	CopyFile(sgTempSmartLink,sGebo)

	CGIClearBuffer
	CGIWriteln("content-type: text/html")
	CGIWriteln("")

	dbWIKI := OpenDB(sgDBDir+"wiki.dat")
	if sSelection then
		Fulltext_MarkTable(dbWIKI, sSelection)
		SortMark(dbWIKI, "$Name")
		Access(dbWIKI, -2)
	else
		Access(dbWIKI, 1)
	end
	f := rewrite(sMain,0)
	SUB _DBName(dbWIKI)
		writeln(f,"<option>"+GetField(dbWIKI, "Name")+"</option>")
	ENDSUB
	close(f)
	closedb(dbWIKI)


	RAMTEXT_Subst(sGebo, "{lookup}",sSelection)
	RAMTEXT_Subst(sGebo, "{options/}",sMain)

	RAMTEXT_Subst(sGebo, "{_lookup_}",lang("lookup"),2)
	RAMTEXT_Subst(sGebo, "{_dblclickpage_}",lang("dblclickpage"),2)

endproc

procedure Main

	var rBegin		:	REAL = NOW
	var sHeadline	: STRING
	var sPW				: STRING
	var bAuto			: INTEGER
	var justLoggedOff : INTEGER
	var iStatus		: INTEGER
	var sSelection: STRING
	var sUserName : STRING
	var f					: INTEGER
	var sButtons	: STRING = "ramtext:buttons"
	var iSema			: INTEGER
	var sRename		: STRING
	var bViewOnly	: INTEGER
	var sGebo						: STRING = "ramtext:gebogebo"
	var sSessionButtons : STRING
	var sOnClickStr : STRING


	SetPara("nb 1")
	initGebo

	sgCookiePath := GetEnv("PATH_INFO") //GetEnv("SCRIPT_NAME"); "/"+Exchange(sgWikiName," ","")+"/"

	sgAction := GP("action")

	if sgAction LIKE "rss" then
		RSS
	end

	if sgName := cleanName(GP("name")) = "" then
		sgName := sgDefault
	end

	Ramtext(sButtons,8192)
	Ramtext(sGebo,8192)
	CopyFile(sgTempMain,sGebo)

	while RAMTEXT_Subst(sGebo,"{_activities_}",lang("activities"),2) do end
	while RAMTEXT_Subst(sGebo,"{_allpages_}",lang("allpages"),2) do end
	RAMTEXT_Subst(sGebo,"{_route_}",lang("route"),2)
	RAMTEXT_Subst(sGebo,"{_seconds_}",lang("seconds"),2)
	RAMTEXT_Subst(sGebo,"{_losechanges_}",lang("losechanges"),2)
	RAMTEXT_Subst(sGebo,"{_search_}",lang("search"),2)

	sgSession:=GP("cookie.session")

	isValidSession
	CGIWriteln("Set-Cookie: session="+sgSession+"; expires="+expires(UNIX_NOW + igTimeout)+" GMT; path="+sgCookiePath+";")
	CGIWriteln("content-type: text/html")
	CGIWriteln("")


	if igUserID, sgAction LIKE "logout" then
		dropSession(sgSession)
		igUserID:=0
		bgAdminUser := 0

		sgAction := ""
		sgName := "gebo:login"
		justLoggedOff := 1
		CGIClearBuffer
		CGIWriteln("Set-Cookie: noauto=on; path="+sgCookiePath+";")
		CGIWriteln("content-type: text/html")
		CGIWriteln("")

	elsif !igUserID then
		if GP("cookie.user"),GP("cookie.password"), !GP("cookie.noauto") then
			bAuto := 1
		end
	end


	if sgAction LIKE "register" then
		bAuto := 0
		if iStatus := register >0 then
			sgAction := ""
			sgName := "gebo:login"
		elsif iStatus = 0 then
			igUserID:=0
			sgName := "gebo:register"
			sgAction := ""
			sgError := lang("invalidusername")
		elsif iStatus = -1 then
			igUserID:=0
			sgName := "gebo:register"
			sgAction := ""
			sgError := "'"+GP("user")+"': "+ lang("userexists")
		end
	end

	if sgAction LIKE "login" OR (bAuto, !sgAction LIKE "logout") then //(!igUserID, sgAction LIKE "login") OR
		sHeadline := lang("login")
		if !sgUser := GP("user") then
			if !justLoggedOff then
				sgUser := GP("cookie.user")
				sPW := GP("cookie.password")
			end
		else
			sPW := GP("password")
		end
		if !justLoggedOff, sgUser then
			if bAuto := login(sgUser,sPW) > 0 then
				if bAuto = 2 then
					CGIClearBuffer
					CGIWriteln("Set-Cookie: session="+sgSession+"; expires="+expires(UNIX_NOW + igTimeout)+" GMT; path="+sgCookiePath+";")
					CGIWriteln("Set-Cookie: user="+sgUser+"; expires=Sunday, 01-Dec-2099 12:00:00 GMT; path="+sgCookiePath+";")
					CGIWriteln("Set-Cookie: password="+sPW+"; expires=Sunday, 01-Dec-2099 12:00:00 GMT; path="+sgCookiePath+";")
					CGIWriteln("Set-Cookie: noauto=; expires=Sunday, 01-Dec-2000 12:00:00 GMT; path="+sgCookiePath+";")
					CGIWriteln("content-type: text/html")
					CGIWriteln("")
				end
				sgAction := ""
				if !sgName then
					sgName := sgDefault
				end
			else
				sgUser:=""
				if bAuto = -1  then
					sgError := lang("loginfailednotactivated")
				else
					sgError := lang("loginfailed")
				end
				sgAction := ""
				sgName := "gebo:login"
			end
		elsif sgUser = "" then
				sgAction := ""
				sgName := "gebo:login"
		end
	end

	if sgAction LIKE "saveuser" then
		if TestPW(sgSession,GP("key")) then
			if igUserID OR (bgAnonymousEdit, !isWikiLocked4Anonymous(0, sgName)) then
					saveUser(Val(GP("id")),bgAdminUser)
					sgAction := "save"
			else
				sgAction:="show"
				sgError := lang("savingfailed")
			end
		else
			sgAction:="show"
			sgError := lang("savingfailed")
		end
	elsif sgAction LIKE "dropuser" then
		if TestPW(sgSession,GP("key")) then
			dropUser(Val(GP("id")),bgAdminUser)
			sgName:=sgDefault
			sgAction := ""
		else
			sgAction:="show"
			sgError := lang("savingfailed")
		end
	end

	if sgAction LIKE "save" then
		if TestPW(sgSession,GP("key")) then
			if igUserID OR (bgAnonymousEdit, !isWikiLocked4Anonymous(0, sgName)) then
				saveWiki(sgName, Val(GP("part")))
				sgAction := ""
				unlockWiki(sgName)
			else
				sgAction:="show"
				sgError := lang("savingfailed")
			end
		else
			sgAction:="show"
			sgError := lang("savingfailed")
		end
	end

	if sgAction LIKE "export" then
		if !exportWiki(sgName, GP("format"),0) then
			sgAction:="show"
			sgError := lang("exportfailed")
		else
			halt // get off
		end
	elsif sgAction LIKE "fullexport" then
		fullexport(GP("format"))
	end

	if sgAction LIKE "preview" then
		if lockWiki(sgName) then
			OemToAnsi("ramtext:text:content")
			RAMTEXT_Subst(sGebo,"{content/}","{content/}<hr>{content/}")
			RAMTEXT_Subst(sGebo,"{content/}",showWiki(sgName,1,Val(GP("revision")),0))
			RAMTEXT_Subst(sGebo,"{content/}",editWiki(sgName,1,sHeadline,Val(GP("revision")),Val(GP("part")),0))
			RAMTEXT_Subst(sGebo,"{ifpreviewsettotrue/}","*/ bWikiInEdit=true; /*")
		else
			sgError := lang("pageinedit")
			sgAction := "show"
		end
	end


	if sgAction LIKE "edit" then
		if igUserID OR (bgAnonymousEdit, !isWikiLocked4Anonymous(0, sgName)) then
			if lockWiki(sgName) then
				bViewOnly := 0
			else
				bViewOnly := 1
				sgError := lang("pageinedit")
// 				sgAction := "show"
			end
			if sRename := GP("rename"), sRename := cleanName(sRename) # sgName, !sRename[1,5] LIKE "gebo:" then
				if renameWiki(sgName,sRename) then
					sgName := sRename
				else
					sgError := lang("invalidrename")
				end
			elsif sRename then
				sgError := lang("invalidrename")
			end
			RAMTEXT_Subst(sGebo,"{content/}",editWiki(sgName,0,sHeadline,Val(GP("revision")),Val(GP("part")),bViewOnly))
			//sHeadline := sgName
			while RAMTEXT_Subst(sGebo,"{buttons/}","<input type='button' onclick="+'"'+"inEdit('"+sgSelf+"?name={name}');"+'"'+" value='"+lang("btn_view")+"'/>") do end
		else
			sgError := lang("noanonymous")
			sgAction := "show"
		end
	end

	if igUserID, sgAction IN ["subscribe","unsubscribe"] then
		if sgAction LIKE "subscribe" then
			subscribe(igUserID, sgName)
		else
			unsubscribe(Val(GP("id")))
		end
		sgAction := ""
	end

	if bgAdminUser, bgAdminEnables, sgAction IN ["activateuser", "deactivateuser"], GP("user") then
		if sgAction LIKE "activateuser" then
			if changeUserState(Val(GP("user")),UNIX_NOW) <= 0 then
				sgError := "User could not be activated"
			end
		else
			if changeUserState(Val(GP("user")),0) <= 0 then
				sgError := "User could not be deactivated"
			end
		end

		sgAction := ""
		sgName := "gebo:userlist"
	elsif sgAction IN ["activateuser", "deactivateuser"] then
		sgError := "invalidaction"
		sgAction := ""
		sgName := "gebo:userlist"
	end

	if sgAction LIKE "recover" then
		recoverPassword(GP("user"), GP("email"))
		sgName := "gebo:login"
		sgAction := ""
	end

	if sgAction IN ["show",""] then
		unlockWikisBySession(sgSession)

		if sgName[1,5] LIKE "gebo:" then
			if sgName IN [cleanName("gebo:activity"),cleanName("gebo:activity:")+"*"] then
				if sgName LIKE cleanName("gebo:activity:")+"*" then
					sUserName := GP("name")[Length("gebo:activity:")+1,255]
					sHeadline := sUserName+ lang("usersacitivies")
				else
					sUserName := ""
					sHeadline := lang("activities")
				end

				RAMTEXT_Subst(sGebo,"{content/}",showActivity(sUserName),2)
				RAMTEXT_Subst(sGebo,"{switchmode/}",buildWikiLink("gebo:activityfull:"+sUserName,lang("bigbrother"),"",0,0,0))

			elsif sgName IN [cleanName("gebo:activityfull"),cleanName("gebo:activityfull:")+"*"] then//big brother?
				if sgName LIKE cleanName("gebo:activityfull:")+"*" then
					sUserName := GP("name")[Length("gebo:activityfull:")+1,255]
					sHeadline := sUserName+ lang("usersacitivies")
				else
					sUserName := ""
					sHeadline := lang("activities")
				end


				RAMTEXT_Subst(sGebo,"{content/}",showFullActivity(sUserName),2)
				RAMTEXT_Subst(sGebo,"{switchmode/}",buildWikiLink("gebo:activity:"+sUserName,lang("normallist"),"",0,0,0))

			elsif sgName LIKE cleanName("gebo:register") then
				RAMTEXT_Subst(sGebo,"{content/}",showRegistration(GP("user"),GP("EMail")),2)
				sHeadline := lang("registration")

			elsif sgName LIKE cleanName("gebo:login") then
					RAMTEXT_Subst(sGebo,"{content/}",showLogin(GP("user")),2)
					sHeadline := lang("login")

			elsif sgName LIKE cleanName("gebo:userlist") then
				RAMTEXT_Subst(sGebo,"{content/}",showUsers,2)
				sHeadline := lang("users")

			elsif sgName LIKE cleanName("gebo:missing")then
				RAMTEXT_Subst(sGebo,"{content/}",showMissing,2)
				sHeadline := lang("missingpages")

			elsif sgName LIKE cleanName("gebo:unreferenced")then
				RAMTEXT_Subst(sGebo,"{content/}",showUnreferenced,2)
				sHeadline := lang("unreferencedpages")

			elsif sgName LIKE cleanName("gebo:allpages") then
				RAMTEXT_Subst(sGebo,"{content/}",showAll(""),2)
				sHeadline := lang("allpages")

			elsif sgName LIKE cleanName("gebo:findpages*") then
				// by link or by form?
				if !sSelection := GP("name")[Length("gebo:findpages:")+1,255] then
					sSelection := GP("selection")
					sgName := sgName + ":"+sSelection
				end
				RAMTEXT_Subst(sGebo,"{content/}",showAll(sSelection),2)
				if !sSelection then
					sHeadline := lang("allpages")
				else
					sHeadline := lang("allpagesmatching")+" '"+sSelection+"'"
				end

			elsif sgName LIKE cleanName("gebo:subscriptions*") then
				if !sUserName := sgName[Length("gebo:subscriptions:")+1,255] then
					sUserName := sgUser
				end
				RAMTEXT_Subst(sGebo,"{content/}",showSubscriptions(sUserName),2)
				sHeadline := lang("subscribedpages")

			elsif sgName LIKE cleanName("gebo:randompage") then
				sgName := randomPage
				sgAction := "show"
			end

		end
		if !sgName LIKE "gebo:*" then //show normal page
			RAMTEXT_Subst(sGebo,"{content/}",showWiki(sgName,0,Val(GP("revision")),Sel(bgCountHits,!bgStaticMode)))
			if (igUserID OR bgAnonymousEdit), !inBlackList(sgName) then
				if sgName[1,5] = "user:" then
					var iID : INTEGER
					iID := getUserID(sgName[6,255])
					if iID, bgAdminUser or iID = igUserID then
						f := rewrite(sButtons)
						sOnClickStr := "location.href='"+sgSelf+"?id="+Str(iID)+"&amp;action=edituser'"
						write(f, "<input type='button' onclick="+'"'+sOnClickStr+'"'+" value='"+lang("edituser")+"' accesskey='e'/> ")
						sOnClickStr := "location.href='"+sgSelf+"?name=gebo:activityfull:"+sgName[6,255]+"'"
						write(f, "<input type='button' onclick="+'"'+sOnClickStr+'"'+" value='"+lang("activities")+"' accesskey='r'/> ")
						sOnClickStr := "location.href='"+sgSelf+"?name=gebo:subscriptions:"+sgName[6,255]+"'"
						write(f, "<input type='button' onclick="+'"'+sOnClickStr+'"'+" value='"+lang("subscriptions")+"' accesskey='s'/>")
						close(f)
						while RAMTEXT_Subst(sGebo,"{buttons/}",sButtons,2) do end
					end
				else
					sOnClickStr := "location.href='"+sgSelf+"?name={name}&amp;action=edit&amp;revision="+GP("revision")+"'"
					while RAMTEXT_Subst(sGebo,"{buttons/}","<input type='button' onclick="+'"'+sOnClickStr+'"'+"  value='"+lang("btn_editpg") +"' accesskey='e'/> {morebutton/}") do end
				end
				sOnClickStr := "location.href='"+sgSelf+"?name={name}&amp;action=history'"
				while RAMTEXT_Subst(sGebo,"{morebutton/}","<input type='button' onclick="+'"'+sOnClickStr+'"'+" value='"+lang("btn_history")+"' accesskey='h'/>") do end
			else //hide edit buttons
				sOnClickStr := "location.href='"+sgSelf+"?name={name}&amp;action=history'"
				while RAMTEXT_Subst(sGebo,"{buttons/}","<input type='button' onclick="+'"'+sOnClickStr+'"'+" value='"+lang("btn_history")+"' accesskey='h'/>") do end
			end
			CopyFile(buildWikiLink(sgName,sgName,"backlinks",0,0,0), sHeadline := "ramtext:~headline")
		end

	elsif sgAction LIKE "diff" then
			RAMTEXT_Subst(sGebo,"{content/}",showDiff,2)
			CopyFile(buildWikiLink(sgName,sgName,"history",0,1,0), sHeadline := "ramtext:~headline")
			while RAMTEXT_Subst(sGebo,"{buttons/}","<input type='button' onclick="+'"'+"inEdit('"+sgSelf+"?name="+sgName+"&amp;action=history');"+'"'+" value='"+lang("btn_history")+"' accesskey='h'/>") do end

	elsif sgAction LIKE "edituser" then
		if igUserID = Val(GP("id")) or bgAdminUser then
			RAMTEXT_Subst(sGebo,"{content/}",editUser(Val(GP("id")),bgAdminUser,Val(GP("revision"))),2)
		end
		sHeadline := lang("edituser")
	elsif sgAction LIKE "backlinks" then
		unlockWikisBySession(sgSession)
		RAMTEXT_Subst(sGebo,"{content/}",showBacklinks(sgName))
		CopyFile(buildWikiLink(sgName,sgName,"",0,1,0), sHeadline := "ramtext:~headline")
	elsif sgAction LIKE "history" then
		unlockWikisBySession(sgSession)
		RAMTEXT_Subst(sGebo,"{content/}",showHistory(sgName),2)
		while RAMTEXT_Subst(sGebo,"{buttons/}","<input type='button' onclick="+'"'+"inEdit('"+sgSelf+"?name="+sgName+"');"+'"'+" value='"+lang("btn_view")+"' accesskey='v'/>") do end
		CopyFile(buildWikiLink(sgName,sgName,"",0,1,0), sHeadline := "ramtext:~headline")
	elsif sgAction = "rebuildallstaticpages"
		rebuildAllStatic
		RAMTEXT_Subst(sGebo,"{content/}","done")
	elsif sgAction ="smartlink" then
		smartlink(sGebo)
	elsif sgAction ="experiment" then
		RAMTEXT_Subst(sGebo,"{content/}",experiment,2)
	end

	if bgStaticEnabled,bgStaticMode then
		while RAMTEXT_Subst(sGebo,"{route/}",lang("noroute")+" <a href='"+sgSelf+"?&amp;name={name}&amp;stay=dyn'>"+lang("todynamic")+"</a>",2) do end
		while RAMTEXT_Subst(sGebo,"{static/}","",2) do end
	elsif bgStaticEnabled,!bgStaticMode then
		while RAMTEXT_Subst(sGebo,"{route/}",showRoute,2) do end
		while RAMTEXT_Subst(sGebo,"{static/}","<a href='"+sgSelf+"?&amp;name={name}&amp;stay=static'>"+lang("tostatic")+"</a>",2) do end
	else
		while RAMTEXT_Subst(sGebo,"{route/}",showRoute,2) do end
		while RAMTEXT_Subst(sGebo,"{static/}","",2) do end
	end
	while RAMTEXT_Subst(sGebo,"{user/}",sgUser) do end
	if sgError then
		sgError := '<div class="message2user">'+sgError+'</div>'
	end
	while RAMTEXT_Subst(sGebo,"{message/}",sgError,2) do end
	while RAMTEXT_Subst(sGebo,"{buttons/}",'') do end

	if bgUserBase then
		if igUserID > 0 then
			sSessionButtons := '<input type="button" onclick="inEdit('+"'"+sgSelf+'?name=user:'+sgUser+"'"+');" value="user:'+sgUser+'" accesskey="u"/>'
			sSessionButtons := sSessionButtons + '<input type="button" onclick="inEdit('+"'"+sgSelf+'?action=logout'+"'"+');" value="'+lang("logout")+'" accesskey="l"/>'
		else
			sSessionButtons := '<input type="button" onclick="inEdit('+"'"+sgSelf+'?name=gebo:login'+"'"+');" value="'+lang("login")+'" accesskey="l"/>'
		end
		while RAMTEXT_Subst(sGebo,"{sessionbutton/}",sSessionButtons) do end
	else // no login possibility
			while RAMTEXT_Subst(sGebo,"{sessionbutton/}",'') do end
	end

	While RAMTEXT_Subst(sGebo,"{name}", sgName,2) do end
	while RAMTEXT_Subst(sGebo,"{DefaultPage}",sgDefault,2) do end
	while RAMTEXT_Subst(sGebo,"{DefaultPageURL}",sgSelf,2) do end
	while RAMTEXT_Subst(sGebo,"{self}",sgSelf,2) do end
	while RAMTEXT_Subst(sGebo,"{relpath}",sgRelPath,2) do end
	while RAMTEXT_Subst(sGebo,"{WikiName}",sgWikiName,2) do end
	while RAMTEXT_Subst(sGebo,"{version}",sgVersionStr) do end
	RAMTEXT_Subst(sGebo,"{headline/}",sHeadline,2)
	RAMTEXT_Subst(sGebo,"{timestamp}",formatStamp(UNIX_NOW))

	macros.substMacros(sGebo)
	RAMTEXT_Subst(sGebo,"{duration}",RightStr(TimeSTR(NOW-rBegin,3),6))

	CopyFile(sGebo,"con")

Endproc