#!../bin/tdbengine

module make

uses db_maintain

Procedure install
/*
Creates the database files and directories needed and sets up an initial state
*/

		var db				: Integer
		var	sDef			: String
		var	x					: INteger
		var sTable		: String
		var sNextDef	: String
		var aDefs			: String[9]
		var iDefs			: Integer
		var iAdminID	: Integer
		var iAdmGrpID : Integer
		var iDevGrpID	: Integer
		var	iBrowsGrpID: Integer
		var	iOSGrpID	: Integer
		var sWebPort, sWebAdmin, sWebPass : STRING

//create tables in database
		MakeDir("../database")
		MakeDir("../workdef")
		iDefs:=0
		sDef := FirstDir("../def/*.def","")
		while sDef do
			aDefs[iDefs++]:=LTrim(RTrim(sDef[1,63]))
			sDef := NextDir
		end
		iDefs:=0
		while aDefs[iDefs++] do
			sDef := aDefs[iDefs]
			CGIWrite("../database/"+Exchange(Lower(sDef),".def",".dat")+" ...")
			Db_Maintain_LinkDefs("../workdef/"+sDef,"../def/"+sDef,"")

			sTable := "../database/"+Exchange(Lower(sDef),".def",".dat")
			Db_Maintain_Restrukt(Exchange(Lower(sDef),".def",""),"../workdef/","../database/")

			CGIWriteLn(" done")

			if Fulltext_Test(Exchange(sDef,".def","")) then
				CGIWrite("    generating fulltext index ...")
				if Db_Maintain_GenerateFulltext(Exchange(sDef,".def",""),"../workdef/"+sDef,"../database/"+Exchange(sDef,".def","")+"_vt") then
					CGIWriteLn(" done")
				else
					CGIWriteLn(" failed!!!")
				end
			end
		end

endproc

procedure Main

		if ParamStr(2) like "regen" then
			CGIWriteLn("")
			CGIWriteLn("Generating databases and indexes...")
			install
			halt
		end

	MakeDir("../var/")
	MakeDir("../var/gebo/")	
	MakeDir("../var/gebo/log/")	

		CGICloseBuffer
		CGIWrite("Compiling GeboGebo ")
		if Compile("gebo.mod") = 0 then
			CGIWriteLn("- successful")
		else
			CGIWriteLn("- failed")
		end
		CGIWrite("Compiling RSS ")
		if Compile("rss.mod") = 0 then
			CGIWriteLn("- successful")
		else
			CGIWriteLn("- failed")
		end

		if ParamStr(2) like "install" then
			CGIWriteLn("")
			CGIWriteLn("Generating databases and indexes...")
			install
		end

		CGIWrite("Compiling export_raw ")
		if Compile("export_raw.mod") = 0 then
			CGIWriteLn("- successful")
		else
			CGIWriteLn("- failed")
		end

		CGIWrite("Compiling export_mediawiki ")
		if Compile("export_mediawiki.mod") = 0 then
			CGIWriteLn("- successful")
		else
			CGIWriteLn("- failed")
		end

		CGIWriteLn("")
		CGIWriteLn("Make-Script finished.")

endproc