Module HTTP-Server
//adapted for the use with GeboGebo on 2005-06-17


Uses packer

Var ini_dir : String    := '../conf/' //GetDir (0)
Var ini : String        := ini_dir+'/minihttp.conf'
Var host, url, file, prot, port, method, querystring, contenttype, contentlength, cookie, useragent, acceptencoding  : String
Var cgidir, a_dir       : String
Var scriptalias         : String := GetIdent (ini,'ScriptAlias')
Var scriptdir           : String := GetIdent (ini,'ScriptDir')
Var serverport          : Integer = Val (GetIdent (ini,'ServerPort'))
Var documentroot        : String := GetIdent (ini,'DocumentRoot')
Var documentroot_packed : String := GetIdent (ini,'DocumentRoot_packed')
Var notfound            : String := GetIdent (ini,'NotFound')
Var hh                  : String := '0123456789ABCDEF'

Var nDate : Integer
Var nTime : Real
Var cGMT  : String

Procedure hexchar (s : String) : String
Var h1 : Integer := Pos (s[1], hh) - 1
Var h2 : Integer := Pos (s[2], hh) - 1
  Return Chr (h1 * 16 + h2)
EndProc

Procedure url_decode (s : String) : String
Var i, m : Integer;
Var c    : Char;
Var l, h : String
  m := Length (s)
  While i++ <= m Do
    If c := s[i] = '%' then
      h := s [i + 1, 2]
      l := l + ANSIToOEM (hexchar (h))
      i := i + 2
    Else
      l := l + c
    End
  End
  Return l
EndProc

Procedure send_file  // bertrgt eine binre Datei
Var b : BYTE[]
Var t, s, fc, f : Integer
  t := F_Open (file,0)
  s := F_Size (t)
  InitArray (b[1024]);
  While fc := F_Read (t,b,1024) > 0
    PutSock (128, b, fc)
  End
  // writeln(0,str(fc)+' bytes read')
	F_Close (t)

EndProc

Procedure html_request  // bertrgt eine HTML-Datei
  GetEnv ('set:HTTP_HOST=' + host)
  send_file
EndProc

Procedure parse_header  // ohne Cookies etc.
  Var l : String
  Var p : Integer

  contentlength := '';
  contenttype   := '';
  querystring   := '';
  cookie        := '';  //RS 01.11.2004 17:15
  useragent     := '';  //RS 01.11.2004 17:15
  acceptencoding := ''; //ST 18.03.2005 21:34

  method        := '';
  host          := '';
  url           := ''


  Repeat
    l := ReadLn (128)
//    WriteLn (0, l)

    If l like 'GET *' THEN
      url    := l[5,255];
      method := 'get'

      If p := Pos (' ',url) then
        prot := url [p+1, 255];
        url  := url [1, p-1]
      End
    ElsIf l like 'POST *' then
      url := l[6,255];
      method := 'post'
      If p := Pos (' ', url) then
        prot := url [p+1, 255];
        url  := url [1, p-1]
      End
    ElsIf l like 'host*'              then host := l [7, 255];
    ElsIf l like 'content-length: *'  then contentlength := l [17, 255]
    ElsIf l like 'content-type: *'    then contenttype := l [15, 255]
    ElsIf l like 'User-Agent: *'      then useragent := l [13, 255]           // rs 01.11.2004 17:15
    ElsIf l like 'Cookie: *'          then cookie := l [9, 255]                   // rs 01.11.2004 17:15
    ElsIf l like 'Accept-Encoding: *' then acceptencoding := l [18, 255] // st 18.03.2005
    End
  Until l=''


  If p := Pos ('?', url) then
    querystring := url[p+1,255];
    url := url [1, p-1]
  End
  If host = '' then
    host := 'localhost:3444'
  End
  url := url_decode (url)

EndProc

Procedure get_filename (Var cName : String)
Var n : Integer

While n := Pos ('/', cName)>0
  cName := cName [n + 1, 255]
End

EndProc

Procedure get_local_filename
Var p : Integer = Pos (scriptalias, url)
  If p then
     url  := url [p + Length (scriptalias), 255];
     file := scriptdir + '/' + url
     Return
  End
  If Pos ('.', url) = 0 then
    url := url + '/index.html'
  End
  file := documentroot + url
EndProc

Procedure write_header (type : String)  // Erfolg
  WriteLn (128, 'HTTP/1.0 200 OK')
  WriteLn (128, 'Date: ' + cGMT)
  //WriteLn (128, 'Last-Modified: ' + cGMT)
  WriteLn (128, 'Accept-Ranges: bytes')
  WriteLn (128, 'Content-Length: ' + Str (GetSize (file)))
  WriteLn (128, 'Connection: close')
  WriteLn (128, 'Content-Type: ' + type)
  If type <> 'text/html' then

  End
  WriteLn (128, '')
EndProc

Procedure http_error (code, msg : String) // Fehler
  WriteLn (128, 'HTTP/1.0 ' + code + ' ')
  WriteLn (128, 'Connection: close')
  WriteLn (128, '')
EndProc

Procedure get_dir : String  // extrahiert das Verzeichnis aus einem Pfad
Var fn : String  := file
Var i  : Integer := Length (fn)
  While i, fn [i] <> '/' Do i-- End
  Return fn [1, i]
EndProc

Procedure cgi_request
Var command, l : String
Var fc, b             : Integer
Var t0                : Real = Now
Var cFileName         : String

  cgidir := get_dir
  ChDir (cgidir)

  GetEnv ('set:REQUEST_URI='     + url)
  GetEnv ('set:QUERY_STRING='    + querystring)
  GetEnv ('set:CONTENT_TYPE='    + contenttype)
  GetEnv ('set:CONTENT_LENGTH='  + contentlength)
  GetEnv ('set:HTTP_USER_AGENT=' + useragent)  //rs 01.11.2004 17:18
  GetEnv ('set:HTTP_ACCEPT_ENCODING='+acceptencoding) // st 17.03.2004
  GetEnv ('set:HTTP_COOKIE='     + cookie)     //rs 01.11.2004 17:18
  GetEnv ('set:HTTP_HOST=' + host)

  InitCGI (scriptalias + url)
  GetIdent ('', '')

  CGIBuffer (2000000)
  CGIWriteLn ('HTTP/1.1 200 OK')
  CGIWriteLn ('Cache-Control: no-cache')
  CGIWriteLn ('Connection: close')

  cFileName := file
  get_filename (cFileName)
	cFileName := Exchange(cFileName,".prg","")
  command := "ExecMacro(" + cFileName + ",Main)"

  SetPara ('ec 1')
  Do _command

  SetPara ('ec 1')
  If b := Reset ('~cgibuffer')
    While not EOT (b) and l := ReadLn (b)
      If Lower (l) like 'location: *'
        WriteLn (128, 'HTTP/1.0 302 FOUND')
//        WriteLn (128, 'Connection: close')
      End
    End
    Close (b)
  End
  SetPara ('ec 0')

  CGICloseBuffer
  CGIBuffer (1) // st - tdb 01.11.2004 18:21

EndProc

Procedure try

  Var nStart : Real := Now

  nDate  := Today
  nTime  := Now
  cGMT := Choice(1+(nDate+5) MOD 7, 'Sun','Mon','Tue','Wed','Thu','Fri','Sat')+', '+Str (Day (nDate))+' '+Choice(Month(nDate),'Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Nov','Oct','Dec')+' '+Str(Year(nDate))+' '+TimeStr(nTime,0)+' GMT'

  parse_header

  If method = ''
    WriteLn (0, 'Bad request - '+TimeStr (Now - nStart, 4))
    Flush
    Return
  End

  get_local_filename;
  file := Exchange (file, '//', '/');

  ChDir (a_dir)

  If file like '*/index.html', not IsFile (file) then
    file := Exchange (file, 'index.html', 'index.htm')
  End
  If not IsFile (file) then
    Flush
    If notfound then
      file := notfound
      write_header ('text/html')
      send_file
    Else
      http_error ('404','file not found'); Write (128, host + '/' + file + ' not found')
    End
  ElsIf file like '*.htm*' then write_header ('text/html');  html_request
  ElsIf file like '*.jpg'  then write_header ('image/jpeg'); send_file
  ElsIf file like '*.jpeg' then write_header ('image/jpeg'); send_file
  ElsIf file like '*.gif'  then write_header ('image/gif');  send_file
  ElsIf file like '*.css'  then write_header ('text/css');   send_file
  ElsIf file like '*.js'   then write_header ('application/javascript');  send_file
  ElsIf file like '*.prg'
    cgi_request
  Else
    .. 01.11.2004 14:39 st
    write_header ('application/octet-stream')
    send_file
  End
  Flush
  WriteLn (0, method + ': ' + file +' - '+TimeStr (Now - nStart, 4))
EndProc

Procedure Main

Var nErr : Integer
Var c    : String
  If documentroot_packed then
    If not isfile(documentroot_packed) then
      gen_data(documentroot,documentroot_packed);
      Return
    End
    GetEnv ('set:TDB_VDIR='+documentroot_packed)
  End

  CGIBuffer (0);
  SetPara ('nb 1')

  WriteLn (0,'Waiting for connections on port '+Str (serverport))

  CGIBuffer (2000000)

  GetEnv ('set:TDB_SUBST='+ini_dir+'/urls.ini')
  GetEnv ('set:CD_WRITEDIR=c:*')
  GetEnv ('set:CD_ALIASES='+ini_dir+'/aliases.ini')

  GetEnv ('set:SERVER_PORT=' + Str (serverport))

  a_dir := GetDir (0);
  server (serverport,try,150)

EndProc


