module render

Var sLinkOpen		: STRING = "[["
Var sLinkClose	: STRING = "]]"

Var sImgOpen		: STRING = "{{"
Var sImgClose		: STRING = "}}"

Var sFileOpen		: STRING = "(("
Var sFileClose	: STRING = "))"


var sBold						: STRING = "**"
var sHTMLBoldOn			: STRING = "<span class='bold'>"
var sHTMLBoldOff		: STRING = "</span>"

var sItalic					: STRING = "~~"
var sHTMLItalicOn		: STRING = "<span class='italic'>"
var sHTMLItalicOff	: STRING = "</span>"

var sUnderline				: STRING = "__"
var sHTMLUnderlineOn	: STRING = "<span class='underline'>"
var sHTMLUnderlineOff	: STRING = "</span>"

var sStroke						: STRING = "--"
var sHTMLStrokeOn			: STRING = "<s>"
var sHTMLStrokeOff		: STRING = "</s>"

var sHL1							: STRING = "======"
var sHTMLH1On					: STRING = "<div class='head1'>"
var sHTMLH1Off				: STRING = "<hr></div>"

var sHL2							: STRING = "====="
var sHTMLH2On					: STRING = "<div class='head2'>"
var sHTMLH2Off				: STRING = "</div>"

var sHL3							: STRING = "===="
var sHTMLH3On					: STRING = "<div class='head3'>"
var sHTMLH3Off				: STRING = "</div>"

var sHL4							: STRING = "==="
var sHTMLH4On					: STRING = "<div class='head4'>"
var sHTMLH4Off				: STRING = "</div>"

var sHL5							: STRING = "=="
var sHTMLH5On					: STRING = "<div class='head5'>"
var sHTMLH5Off				: STRING = "</div>"

var sParagraph				: STRING = "##"
var sHTMLParaOn				: STRING = "<div class='paragraph'>"
var sHTMLParaOff			: STRING = "</div>"


var sHR								: STRING = "----"
var sHTMLHR						: STRING = "<hr>"

var sListShift				: STRING = "  "
var sNumList					: STRING = "  -"
var sSimpleList				: STRING = "  *"

var sCode							: STRING = "''"
var sHTMLCodeOn			  : STRING = "<span class='monospace'>"
var sHTMLCodeOff		  : STRING = "</span>"

var sBreak						: STRING = "\\"
var sHTMLBR						: STRING = ""

var sHTMLFColorOff		: STRING = "</span>"
var sFColor1					: STRING = "^1^"
var sHTMLFColor1On		: STRING = "<span class='fc1'>"

var sFColor2					: STRING = "^2^"
var sHTMLFColor2On		: STRING = "<span class='fc2'>"

var sFColor3					: STRING = "^3^"
var sHTMLFColor3On		: STRING = "<span class='fc3'>"

var sFColor4					: STRING = "^4^"
var sHTMLFColor4On			: STRING = "<span class='fc4'>"

var sHTMLBColorOff		: STRING = "</span>"
var sBColor1					: STRING = "#1#"
var sHTMLBColor1On		: STRING = "<span class='bc1'>"

var sBColor2					: STRING = "#2#"
var sHTMLBColor2On		: STRING = "<span class='bc2'>"

var sBColor3					: STRING = "#3#"
var sHTMLBColor3On		: STRING = "<span class='bc3'>"

var sBColor4					: STRING = "#4#"
var sHTMLBColor4On			: STRING = "<span class='bc4'>"


procedure substLinks(dbWIKI : INTEGER; sWikiPage : STRING)

	var iOffset				:	INTEGER
	var iBeg, iEnd		: INTEGER
	var f							: INTEGER
	var sURL, sText		: STRING
	var sTarget				: STRING
	var p							: INTEGER
	var bStillOpen		: INTEGER
	var db 						: INTEGER
	var bNotWorking		: INTEGER
	var bClose				: INTEGER

	if dbWIKI = 0 then
		db := OpenDB("../database/wiki.dat")
		bClose := 1
	else
		db := SetAlias(dbWIKI, "clone")
	end

	while iBeg := RAMTEXT_Find(sWikiPage, sLinkOpen,iOffset) do
		bStillOpen := 1
		if iEnd := RAMTEXT_Find(sWikiPage,sLinkClose,iBeg + Length(sLinkOpen)), bStillOpen then
			RAMTEXT_Delete(sWikiPage, iBeg, iEnd - iBeg + Length(sLinkClose))
			//iOffset := iEnd + Length(sLinkClose)
			sTarget := AnsiToOEM(RAMTEXT_Part("ramtext:~clip", Length(sLinkOpen)+1,GetSize("ramtext:~clip")-Length(sLinkOpen)-Length(sLinkClose)))
			if p := Pos("|",sTarget) > 0 then
				sText := sTarget[p+1,255]
				sURL := sTarget[1,p-1]
			else
				sText := sURL := sTarget
			end

			if sURL IN ["http://*","https://*","ftp://*"] then
				sTarget := "<a href='"+sURL+"' target='_blank'>"+ sText +"</a>"
			else //internal link
				if ReadRec(db, FindRec(db, cleanName(sURL),1,1)) then
					bNotWorking := 0
					if MemoLen(db, "Content") = 0 then
						bNotWorking := 1
					end
				else
					bNotWorking := 1
				end
				sTarget := buildWikiLink(sURL,sText,"",bNotWorking)
			end
			RAMTEXT_Insert(sWikiPage, iBeg, sTarget)
			iOffset := iBeg + Length(sTarget)
		end
	end
	if bClose then
		CloseDB(db)
	end
endproc

procedure substImages(dbWIKI : INTEGER; sWikiPage : STRING)

	var iOffset				:	INTEGER
	var iBeg, iEnd		: INTEGER
	var f							: INTEGER
	var sURL, sFormat	: STRING
	var sTarget				: STRING
	var p							: INTEGER
	var bStillOpen		: INTEGER
	var db 						: INTEGER
	var bNotWorking		: INTEGER
	var bClose				: INTEGER
	var sWidth				: STRING
	var sHeight				: STRING
	var bInternal			: INTEGER
	var sName					: STRING

	if dbWIKI = 0 then
		db := OpenDB("../database/wiki.dat")
		bClose := 1
	else
		db := SetAlias(dbWIKI, "clone")
	end

	while iBeg := RAMTEXT_Find(sWikiPage, sImgOpen,iOffset) do
		bStillOpen := 1
		if iEnd := RAMTEXT_Find(sWikiPage,sImgClose,iBeg + Length(sImgOpen)), bStillOpen then
			RAMTEXT_Delete(sWikiPage, iBeg, iEnd - iBeg + Length(sImgClose))
			//iOffset := iEnd + Length(sLinkClose)
			sTarget := AnsiToOEM(RAMTEXT_Part("ramtext:~clip", Length(sImgOpen)+1,GetSize("ramtext:~clip")-Length(sImgOpen)-Length(sImgClose)))
			if p := Pos("|",sTarget) > 0 then
				sFormat := RTrim(LTrim(sTarget[p+1,255]))
				sURL := RTrim(LTrim(sTarget[1,p-1]))
			else
				sFormat := ""
				sURL := RTrim(LTrim(sTarget))
			end

			if !sURL IN ["http://*","https://*"] then
 				bInternal:=1
				sName := sURL
				if ReadRec(db, FindRec(db, cleanName(sURL),1,1)) then
 					bNotWorking := 0
					sURL := "../data/img/"+sURL[5,255]
 					if MemoLen(db, "Content") = 0 then
 						bNotWorking := 1
 					end
 				else
 					bNotWorking := 1
 				end
			else
				bInternal := 0
				bNotWorking:=0
			end
			if p:=Pos("x",sFormat) > 0 then
				if p>1 then
					sWidth := "width:" +sFormat[1,p-1]+";"
				else
					sWidth := "width:;"
				end
				if p<Length(sFormat) then
					sHeight := "height:"+sFormat[p+1,255]+";"
				else
					sHeight := "heigh:;"
				end
				sFormat := sWidth+sHeight
			else
				sFormat:=";"
			end
			if bNotWorking then
				sTarget := sName
			else
				sTarget := "<img src='"+sURL+"' style='"+sFormat+"' border='0'>"
			end
			if bInternal then
				sTarget := sTarget + "</a>"
			end
			RAMTEXT_Insert(sWikiPage, iBeg, sTarget)
			if bInternal then
				RAMTEXT_Insert(sWikiPage, iBeg, "<a class='notworking' href='wiki.prg?name="+sName+"'>")
			end
			iOffset := iBeg + Length(sTarget)
		end
	end
	if bClose then
		CloseDB(db)
	end
endproc

procedure substFiles(dbWIKI : INTEGER; sWikiPage : STRING)

	var iOffset				:	INTEGER
	var iBeg, iEnd		: INTEGER
	var f							: INTEGER
	var sURL, sText		: STRING
	var sTarget				: STRING
	var p							: INTEGER
	var bStillOpen		: INTEGER
	var db 						: INTEGER
	var bNotWorking		: INTEGER
	var bClose				: INTEGER

	if dbWIKI = 0 then
		db := OpenDB("../database/wiki.dat")
		bClose := 1
	else
		db := SetAlias(dbWIKI, "clone")
	end

	while iBeg := RAMTEXT_Find(sWikiPage, sFileOpen,iOffset) do
		bStillOpen := 1
		if iEnd := RAMTEXT_Find(sWikiPage,sFileClose,iBeg + Length(sFileOpen)), bStillOpen then
			RAMTEXT_Delete(sWikiPage, iBeg, iEnd - iBeg + Length(sFileClose))
			//iOffset := iEnd + Length(sFileClose)
			sTarget := AnsiToOEM(RAMTEXT_Part("ramtext:~clip", Length(sFileOpen)+1,GetSize("ramtext:~clip")-Length(sFileOpen)-Length(sFileClose)))
			if p := Pos("|",sTarget) > 0 then
				sText := sTarget[p+1,255]
				sURL := sTarget[1,p-1]
			else
				sURL := sTarget

			end

			if sURL IN ["http://*","https://*","ftp://*"] then
				sTarget := "<a href='"+sURL+"' target='_blank'>"+ sText +"</a>"
			else //internal link
				if ReadRec(db, FindRec(db, cleanName(sURL),1,1)) then
					if sText = "" then
						sText := MemoStr(db, "Content")
					end
					bNotWorking := 0
					if MemoLen(db, "Content") = 0 then
						bNotWorking := 1
					end
					if IsFile("../data/file/"+MemoStr(db, "Content")) then
						bNotWorking := 0
					else
						bNotWorking := 1
					end
				else
					if sText = "" then
						sText := sURL
					end
					bNotWorking := 1
				end
				if bNotWorking then
					sTarget := buildWikiLink(sURL,sText,"",bNotWorking)// "<a class='notworking' href='../data/file/"+MemoStr(db, "Content")+"' target='_blank'>"+sText+"</a>"
				else
					sTarget := "<a class='working' href='../data/file/"+MemoStr(db, "Content")+"' target='_blank'>"+sText+"</a>"
				end
				//sTarget := buildWikiLink(sURL,sText,"",bNotWorking)
			end
			RAMTEXT_Insert(sWikiPage, iBeg, sTarget)
			RAMTEXT_Insert(sWikiPage, iBeg, "<img src='../images/file.png' border='0'> ")
			iOffset := iBeg + Length(sTarget)
		end
	end
	if bClose then
		CloseDB(db)
	end
endproc


procedure substPairs(sWikiPage,sPair,sHTMLOn,sHTMLOff:STRING)
	var sReplace		: STRING
	sReplace := sHTMLOn
	while ramtext_subst(sWikiPage,sPair,sReplace) do
		if sReplace # sHTMLOn then
			sReplace := sHTMLOn
		else
			sReplace := sHTMLOff
		end
	end
endproc

procedure substBold(sWikiPage:STRING)
	substPairs(sWikiPage,sBold,sHTMLBoldOn,sHTMLBoldOff)
endproc

procedure substItalic(sWikiPage:STRING)
	substPairs(sWikiPage,sItalic,sHTMLItalicOn,sHTMLItalicOff)
endproc

procedure substUnderline(sWikiPage:STRING)
	substPairs(sWikiPage,sUnderline,sHTMLUnderlineOn,sHTMLUnderlineOff)
endproc

procedure substStroke(sWikiPage:STRING)
	substPairs(sWikiPage,sStroke,sHTMLStrokeOn,sHTMLStrokeOff)
endproc

procedure substCode(sWikiPage:STRING)
	substPairs(sWikiPage,sCode,sHTMLCodeOn,sHTMLCodeOff)
endproc

procedure substHeadline(sWikiSource,sHL,sHTMLOn,sHTMLOff:STRING)
	var iOffset				:	INTEGER
	var iBeg, iEnd		: INTEGER
	var f							: INTEGER
	var sURL, sText		: STRING
	var sTarget				: STRING
	var p							: INTEGER
	var iNames				: INTEGER

	while iBeg := RAMTEXT_Find(sWikiSource, sHL,iOffset) do
		iOffset := iBeg + Length(sHL)
		if iEnd := RAMTEXT_Find(sWikiSource,Chr(10),iOffset) then
			RAMTEXT_Delete(sWikiSource, iBeg, iEnd - iBeg)
			//iOffset := iEnd + Length(sLinkClose)
			RAMTEXT_Subst("ramtext:~clip",sHL,sHTMLOn)
			RAMTEXT_Insert("ramtext:~clip",GetSize("ramtext:~clip"),sHTMLOff)
			RAMTEXT_Insert(sWikiSource, iBeg, "{hltarget}")
			RAMTEXT_Subst(sWikiSource,"{hltarget}","ramtext:~clip")
			iOffset := iBeg + GetSize("ramtext:~clip")
		end
	end
//	substPairs(sWikiPage,sHL1,sHTMLH1On,sHTMLH1Off)
endproc

procedure substHL1(sWikiPage:STRING)
	substHeadline(sWikiPage,sHL1,sHTMLH1On,sHTMLH1Off)
endproc

procedure substHL2(sWikiPage:STRING)
	substHeadline(sWikiPage,sHL2,sHTMLH2On,sHTMLH2Off)
//	substPairs(sWikiPage,sHL2,sHTMLH2On,sHTMLH2Off)
endproc

procedure substHL3(sWikiPage:STRING)
	substHeadline(sWikiPage,sHL3,sHTMLH3On,sHTMLH3Off)
//	substPairs(sWikiPage,sHL3,sHTMLH3On,sHTMLH3Off)
endproc

procedure substHL4(sWikiPage:STRING)
	substHeadline(sWikiPage,sHL4,sHTMLH4On,sHTMLH4Off)
//	substPairs(sWikiPage,sHL4,sHTMLH4On,sHTMLH4Off)
endproc

procedure substHL5(sWikiPage:STRING)
	substHeadline(sWikiPage,sHL5,sHTMLH5On,sHTMLH5Off)
//	substPairs(sWikiPage,sHL5,sHTMLH5On,sHTMLH5Off)
endproc

procedure substParagraph(sWikiPage:STRING)
	substPairs(sWikiPage,sParagraph,sHTMLParaOn,sHTMLParaOff)
endproc

procedure substHR(sWikiPage:STRING)
	while RAMTEXT_Subst(sWikiPage,chr(13)+chr(10)+sHR+chr(13)+chr(10),sHTMLHR) do end
endproc

procedure substColors(sWikiPage:STRING)
	substPairs(sWikiPage,sFColor1,sHTMLFColor1On,sHTMLFColorOff)
	substPairs(sWikiPage,sFColor2,sHTMLFColor2On,sHTMLFColorOff)
	substPairs(sWikiPage,sFColor3,sHTMLFColor3On,sHTMLFColorOff)
	substPairs(sWikiPage,sFColor4,sHTMLFColor4On,sHTMLFColorOff)
	substPairs(sWikiPage,sBColor1,sHTMLBColor1On,sHTMLBColorOff)
	substPairs(sWikiPage,sBColor2,sHTMLBColor2On,sHTMLBColorOff)
	substPairs(sWikiPage,sBColor3,sHTMLBColor3On,sHTMLBColorOff)
	substPairs(sWikiPage,sBColor4,sHTMLBColor4On,sHTMLBColorOff)
endproc

procedure substExtLinks(sWikiPage:STRING)

	var iOffset				:	INTEGER
	var iBeg, iEnd		: INTEGER
	var f							: INTEGER
	var sURL, sText		: STRING
	var sTarget				: STRING
	var p							: INTEGER
	var bStillOpen		: INTEGER

	var sExtLinkOpen	: STRING = "http://"
	var sExtLinkOpen2	: STRING = "https://"
	iOffset := 1
	while iBeg := RAMTEXT_Find(sWikiPage, sExtLinkOpen,iOffset,0) OR iBeg := RAMTEXT_Find(sWikiPage, sExtLinkOpen2,iOffset,0) do
		sURL := RAMTEXT_Part(sWikiPage,iBeg,255)
		p:=0
		sTarget:=""
		while p++ <= Length(sURL), Pos(sURL[p],"abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789.:/+=-?&%,#") do
			sTarget := sTarget + sURL[p]
		end
		RAMTEXT_Delete(sWikiPage,iBeg,Length(sTarget))
		sTarget := "<a href='"+sTarget+"' target='_blank'>"+sTarget+"</a>"
		RAMTEXT_Insert(sWikiPage,iBeg,sTarget)
		iOffset := iBeg + Length(sTarget)
	end

endproc

procedure substbreak(sWikiPage:STRING)
	while RAMTEXT_Subst(sWikiPage,sBreak,"<br/>") do end
endproc

procedure substListing(sWikiPage,sSymbol, sOn, sOff : STRING)
	var fr,fw			: INTEGER
	var bStarted	: INTEGER
	var sLine			: STRING
	var iLevel		: INTEGER
	var sModified : STRING = "ramtext:modified"
	var bChanged	: INTEGER

	Ramtext(sModified,8192)

	fr := Reset(sWikiPage)
	fw := Rewrite(sModified)
	bStarted := 0
	iLevel:=0
	while !eot(fr) do
		sLine := ReadLn(fr)
		if Pos(NTimes(sListShift, iLevel)+sSymbol,sLine) = 1 then
			bChanged := 1
			if bStarted = 0 then
				bStarted := 1
				write(fw, sOn)
			end
			write(fw, "<li>")
			write(fw, sLine[iLevel*Length(sListShift) + Length(sSymbol)+1,255])
			write(fw, "</li>")
		else
			if bStarted=1 then
				writeln(fw, sOff)
				bStarted := 0
				//iLevel--
			else
				writeln(fw,"")
			end
			write(fw, sLine)
		end
	end
	if bChanged, bStarted then
		writeln(fw, sOff)
	end
	close(fw)
	close(fr)
	If bChanged then
		CopyFile(sModified,sWikiPage)
	end
endproc

procedure processWiki(dbWIKI, sWikiSource : STRING) : string

	var sWikiPage				: STRING = "ramtext:wikipage"
	var sTemp						: STRING = "ramtext:temp"

	Ramtext(sWikiPage,8192)
	Ramtext(sTemp,8192)
	CopyFile(sWikiSource, sWikiPage)
// 	AnsiToOem(sTemp)
// 	RAMTEXT_Insert(sWikiPage,1,"{substme}")
//
// 	RAMTEXT_Subst(sWikiPage,"{substme}",sTemp,4)

	substLinks(dbWIKI,sWikiPage)
	substImages(dbWIKI,sWikiPage)
	substFiles(dbWIKI,sWikiPage)
	substHR(sWikiPage)
	substBold(sWikiPage)
	substItalic(sWikiPage)
	substUnderline(sWikiPage)
	substStroke(sWikiPage)
	substCode(sWikiPage)
	substHL1(sWikiPage)
	substHL2(sWikiPage)
	substHL3(sWikiPage)
	substHL4(sWikiPage)
	substHL5(sWikiPage)
	substParagraph(sWikiPage)
	substListing(sWikiPage,sNumList,"<ol>","</ol>")
	substListing(sWikiPage,sSimpleList,"<ul>","</ul>")
	substbreak(sWikiPage)
	substColors(sWikiPage)
//	substExtLinks(sWikiPage)
	return sWikiPage
endproc
