module render2
/***************************************************************************
                        render2.mod  -  description
                             -------------------
											gebogebo render engine 2nd version
    begin                : 2005
    copyright            : (C) 2004 by tdb Software Service
    email                : tf@tdb.de

		$Id: render2.mod,v 1.1 2005/09/08 07:34:11 path Exp $
 ***************************************************************************

 ***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

var giPartCnt				: INTEGER
var giPartsEnabled	: INTEGER

Var sLinkOpen		: STRING = "[["
Var sLinkClose	: STRING = "]]"

Var sImgOpen		: STRING = "{{"
Var sImgClose		: STRING = "}}"

Var sFileOpen		: STRING = "(("
Var sFileClose	: STRING = "))"


var sBold						: STRING = "**"
var sHTMLBoldOn			: STRING = "<span class='bold'>"
var sHTMLBoldOff		: STRING = "</span>"

var sItalic					: STRING = "~~"
var sHTMLItalicOn		: STRING = "<span class='italic'>"
var sHTMLItalicOff	: STRING = "</span>"

var sUnderline				: STRING = "__"
var sHTMLUnderlineOn	: STRING = "<span class='underline'>"
var sHTMLUnderlineOff	: STRING = "</span>"

var sStroke						: STRING = "--"
var sHTMLStrokeOn			: STRING = "<s>"
var sHTMLStrokeOff		: STRING = "</s>"

var sHL1							: STRING = "======"
var aHTMLHeadOn				: STRING[6]
var aHTMLHeadOff			: STRING[6]

var sHTMLH1On					: STRING = "<div class='head1'>"
var sHTMLH1Off				: STRING = "<hr></div>"

var sHL2							: STRING = "====="
var sHTMLH2On					: STRING = "<div class='head2'>"
var sHTMLH2Off				: STRING = "</div>"

var sHL3							: STRING = "===="
var sHTMLH3On					: STRING = "<div class='head3'>"
var sHTMLH3Off				: STRING = "</div>"

var sHL4							: STRING = "==="
var sHTMLH4On					: STRING = "<div class='head4'>"
var sHTMLH4Off				: STRING = "</div>"

var sHL5							: STRING = "=="
var sHTMLH5On					: STRING = "<div class='head5'>"
var sHTMLH5Off				: STRING = "</div>"

var sParagraph				: STRING //= OemToAnsi("")
var sHTMLParaOn				: STRING = "<div class='paragraph'>"
var sHTMLParaOff			: STRING = "</div>"

var sHR								: STRING = "----"
var sHTMLHR						: STRING = "<hr noshade size=1>"

var sCode							: STRING = "''"
var sHTMLCodeOn			  : STRING = "<span class='monospace'>"
var sHTMLCodeOff		  : STRING = "</span>"

var sBreak						: STRING = "\\ "
var sHTMLBR						: STRING = "<br/>"

/*
var sListShift				: STRING = "  "
var sNumList					: STRING = "  -"
var sSimpleList				: STRING = "  *"


var sHTMLFColorOff		: STRING = "</span>"
var sFColor1					: STRING = "^1^"
var sHTMLFColor1On		: STRING = "<span class='fc1'>"

var sFColor2					: STRING = "^2^"
var sHTMLFColor2On		: STRING = "<span class='fc2'>"

var sFColor3					: STRING = "^3^"
var sHTMLFColor3On		: STRING = "<span class='fc3'>"

var sFColor4					: STRING = "^4^"
var sHTMLFColor4On			: STRING = "<span class='fc4'>"

var sHTMLBColorOff		: STRING = "</span>"
var sBColor1					: STRING = "#1#"
var sHTMLBColor1On		: STRING = "<span class='bc1'>"

var sBColor2					: STRING = "#2#"
var sHTMLBColor2On		: STRING = "<span class='bc2'>"

var sBColor3					: STRING = "#3#"
var sHTMLBColor3On		: STRING = "<span class='bc3'>"

var sBColor4					: STRING = "#4#"
var sHTMLBColor4On			: STRING = "<span class='bc4'>"
*/

var bBoldOn, bUnderlineOn, bStrokeOn, bItalicOn, bCodeOn, bParagraphOn : INTEGER = 0
var iStarted				: INTEGER
var bListOn					: INTEGER
var bTableOn				: INTEGER

procedure firstpass(var aBuffer : CHAR[]; iMaximum, ft,iLevel, dbWIKI : INTEGER)
	var sBuffer					: STRING
	var cBuffer					: CHAR
	var sInner					: STRING
	var sLink, sLinkText: STRING
	var p								: INTEGER
	var bNotWorking			: INTEGER
	var iCnt						: INTEGER
	var iPos						: INTEGER
	var aBuffy 					: CHAR[]
	var iDiff						: INTEGER
	var s								: STRING
	var cSymbol					: CHAR
	var sListOpen				: STRING
	var sListClose			: STRING
	iPos := -1


	while iPos < iMaximum do
			cBuffer := aBuffer[iPos++]
		if cBuffer="?" OR cBuffer = "*" OR cBuffer IN [" ",^J,^M,"-","=","|","+","#"] then
			sBuffer := ""

// no processing (keep the tags inside anyway for second pass!!!)
			if iPos+1<iMaximum,cBuffer + aBuffer[iPos +1] = "|#" then
				iPos --
				//write(ft, cBuffer)
				while iPos++ <= iMaximum, aBuffer[iPos -1] + aBuffer[iPos] # "#|" do
					write(ft, aBuffer[iPos])
				end
				write(ft, aBuffer[iPos])


// Headlines and lists (all linebased formattings)
			elsif iStarted = 1 OR cBuffer =^M then
				if cBuffer = ^M then
					sBuffer := cBuffer
					cBuffer := aBuffer[iPos++] // ^J drop
					sBuffer := sBuffer + cBuffer
					cBuffer := aBuffer[iPos++]
				end
				if cBuffer = "=" then // maybe a headline
					if bListOn then
						write(ft, sListClose)
						bListOn := 0
					end
					iCnt:=0
					sBuffer := cBuffer
					while iPos+1<iMaximum,cBuffer := aBuffer[iPos++] = "=", iCnt++ < 6 do
						sBuffer := sBuffer + cBuffer
					end  //max = 6
					iPos--
					if iCnt > 0 then
						giPartCnt++
//						write(ft, "<div style='width:100%;'>")
						write(ft, aHTMLHeadOn[iCnt])
						sInner := ""
						initarray(aBuffy[iMaximum])
						iDiff:=0
						repeat
							iPos++
							write(ft, aBuffer[iPos])
						until iPos = iMaximum OR (iPos < iMaximum-2 AND aBuffer[iPos +1]+aBuffer[iPos +2]=^M+^J)
						sInner := ""
						write(ft, aHTMLHeadOff[iCnt])
						if giPartsEnabled then
							write(ft, "<span class='partedit'><a href='{self}?name={name}&action=edit&part="+Str(giPartCnt)+"'>edit</a></span></div>")
						else
							write(ft, "</div>")
						end
					else
						write(ft, sBuffer)
					end

 				elsif cBuffer="*" OR cBuffer="#" then // propably a list
 					if (cBuffer = "*" or cBuffer = "#") AND iPos+1 < iMaximum, aBuffer[iPos+1]=" " then
						iPos++
							cSymbol := cBuffer
							if cSymbol = "*" then
								sListOpen := "<ul>"
								sListClose := "</ul>"
							elsif cSymbol = "#" then
								sListOpen := "<ol>"
								sListClose := "</ol>"
							end
							if !bListOn then
								write(ft, sListOpen)
								bListOn := 1
							end
							sInner := ""
							initarray(aBuffy[iMaximum])
							iCnt:=0
							iPos++
							var bOff:integer

							write(ft,"<li>")
							repeat
								write(ft, aBuffer[iPos])
								iPos++
								bOff:=0
								if iPos+2 <= iMaximum then
									s:=aBuffer[iPos]+aBuffer[iPos+1]
								else
									bOff :=1
								end
							until bOff or s+aBuffer[iPos+2]+aBuffer[iPos+3]=^M+^J+^M+^J or s+aBuffer[iPos+2]=^M+^J+cSymbol
							if bOff then // the buffer's end is too close for a new line
								write(ft,aBuffer[iPos]+aBuffer[iPos+1])
								iPos := iPos +2
							elsif s+aBuffer[iPos+2]+aBuffer[iPos+3]=^M+^J+^M+^J then //the list ends here
								iPos:=iPos+1
								bOff:=1
							elsif s+aBuffer[iPos+2]=^M+^J+cSymbol then // another list item follows
								iPos:=iPos-1
							elsif bOff then
							end

							if bListOn then
								write(ft,"</li>")
								if bOff then
									bListOn := 0
									write(ft,sListClose)
								end
							end
							iPos:= iPos -0
// 						end
					else // wrong alert
 						write(ft,sBuffer)
						iPos := iPos -1
 					end
// horizontal ruler
				elsif cBuffer = "-" AND iPos +3 < iMaximum, cBuffer + aBuffer[iPos +1]+ aBuffer[iPos +2] + aBuffer[iPos +3] = sHR then
					iPos := iPos +3
					write(ft, sHTMLHR)

				else
					if bListOn then
						write(ft,sListClose)
						bListOn := 0
					end
					iPos := iPos -1
					write(ft, sBuffer)
				end

			else
				write(ft,cBuffer)
			end
		else
			write(ft,cBuffer)
		end
		iStarted := 0
	end

endproc

procedure nimmersatt(var aBuffer : CHAR[]; iMaximum, ft,iLevel, dbWIKI : INTEGER; sWikiContext : STRING)

	var sBuffer					: STRING
	var cBuffer					: CHAR
	var sInner					: STRING
	var sLink, sLinkText: STRING
	var p								: INTEGER
	var bNotWorking			: INTEGER
	var bInternal				: INTEGER
	var sFormat					: STRING
	var sFreeStyle			: STRING
	var sTarget					: STRING
	var sName						: STRING
	var sWidth,sHeight	: STRING
	var iCnt						: INTEGER
	var iPos						: INTEGER
	var aBuffy 					: CHAR[]
	var iDiff						: INTEGER
	var s								: STRING
	var sRevision				: STRING
	var sContext				: STRING
	var iType						: INTEGER

	iPos := -1


	while iPos < iMaximum do
			cBuffer := aBuffer[iPos++]
// then["[","{","(","-","_","~","|","#","f","h","w",^J,^M,"\",OemToAnsi("")]
		if cBuffer="?" OR cBuffer = "*" OR cBuffer IN ["f","h","w","'","[","{","(","-","_","~","|","#",^J,^M,"\",OemToAnsi("")]
			sBuffer := ""

// no processing
			if iPos+1<iMaximum, cBuffer + aBuffer[iPos +1] = "|#" then
				iPos++
				while iPos++ < iMaximum -2, aBuffer[iPos+1] + aBuffer[iPos +2] # "#|" do
					write(ft, aBuffer[iPos])
				end
				write(ft, aBuffer[iPos])
				iPos:= iPos +2
// Links
			elsif iPos+1<iMaximum, cBuffer+aBuffer[iPos +1] = sLinkOpen then
				sBuffer := cBuffer
				sInner := ""
				iPos++
				while iPos+2<iMaximum, !(aBuffer[iPos++]+aBuffer[iPos +1] = sLinkClose OR aBuffer[iPos]=^M) do
					sInner := sInner +aBuffer[iPos]
				end
				sInner := LTrim(RTrim(sInner))
				iPos:=iPos+1

				if p := Pos("|",sInner) then
					sLink := sInner[1,p-1]
					sLinkText := sInner[p+1,255]
				else
					sLink := sLinkText := sInner
				end

				if sLink IN ["http://*","https://*","ftp://*"] then
					write(ft, "<img src='../images/link.png' border='0'> ")
					write(ft, "<a href='"+sLink+"' target='_blank'>"+sLinkText+"</a>")
				else
					if sLinkText[1]=":" then sLinkText:=sLinkText[2,255] end //remove leading colon, for the display at least
					if sLink[1]=":" then			//NULL-Context
						sLink:=sLink[2,255]
					elsif iType:=getPageType(sLink) = cigTypePage then	//current or other context
						if Pos(":",sLink)=0, sWikiContext then // =current context
							sLink := sWikiContext+":"+sLink
						end
					end
					if iType # cigTypeGebo, ReadRec(dbWIKI, FindRec(dbWIKI, ansitooem(cleanName(sLink)),1,1)) then
						bNotWorking := 0
						if MemoLen(dbWIKI, "Content") = 0 then
							bNotWorking := 1
						end
					elsif sLink LIKE "gebo:*" then
						bNotWorking := 0
					else
						bNotWorking := 1
					end
					write(ft,buildWikiLink(sLink,sLinkText,"",bNotWorking,1))
				end

// External Links
			elsif iPos+1<iMaximum, cBuffer = "h" or cBuffer="f" or cBuffer ="w" then
				sBuffer := cBuffer
				repeat
					sBuffer := sBuffer + aBuffer[iPos++]
				until aBuffer[iPos] = "?" or aBuffer[iPos] = "*"  or Length(sBuffer) >= 6 or iPos = iMaximum

 				// if last char was a * or ? it can not be an URL
				if Pos(aBuffer[iPos],"*?")<1, sBuffer IN ["http:/","https:","ftp://","www.??"] then
					//find the end of the URL
					while iPos < iMaximum, !(cBuffer := aBuffer[iPos++] IN ["<",">","|"," ",^t,^M,^J]) OR cBuffer="?"  do
						sBuffer := sBuffer + cBuffer
					end
					if iPos < iMaximum then //did not reach the end, so set cursor one step back
						iPos:=iPos -1
					end
					if sBuffer LIKE "www.*" then //add http:// before
						sLinkText := sBuffer
						sLink := "http://"+sBuffer
					else
						sLink := sLinkText := sBuffer
					end
					write(ft, "<img src='../images/link.png' border='0'> ")
					write(ft, "<a href='"+sLink+"' target='_blank'>"+sLinkText+"</a>")
				else
 					iPos := iPos - Length(sBuffer)+1
 					write(ft, cBuffer)
				end

// Images
			elsif iPos+1<iMaximum, cBuffer+aBuffer[iPos +1] = sImgOpen then
				sBuffer := cBuffer
				sLink := ""
				sFormat := ""
				iPos++

				while !(aBuffer[iPos++]+aBuffer[iPos +1]=sImgClose) do
					if sFormat="" AND aBuffer[iPos] # "|" then
						sLink := sLink + aBuffer[iPos]
					elsif aBuffer[iPos] = "|" then // switch once to format string
						sFormat := sFormat + aBuffer[iPos]
					else // then fill only format string
						sFormat := sFormat + aBuffer[iPos]
					end
				end
				sLink := LTrim(RTrim(sLink))
				sFormat := sFormat[2,255]
				iPos:=iPos+1

				if !sLink IN ["http://*","https://*","ftp://*"] then
					bInternal:=1
					if p:=Pos(",",sLink) then
						sName := sLink[1,p-1]
						sRevision := sLink[p+1,255]
					else
						sName := sLink
						sRevision := ""
					end

					if ReadRec(dbWIKI, FindRec(dbWIKI, cleanName(sName),1,1)) then
						bNotWorking := 0
						if sRevision="" then
							sLink := sgDataImgDir+MemoStr(dbWIKI, "Content")
							if MemoLen(dbWIKI, "Content") = 0 then
								bNotWorking := 1
							end
						else
							sLink := sgDataImgDir+sName[5,255]+","+sRevision
						end
					else
						bNotWorking := 1
					end
				else
					bInternal := 0
					bNotWorking:=0
				end
				if p := Pos("|",sFormat)>0 then // get additional stylesheet settings
					sFreeStyle := sFormat[p+1,255]
					sFormat := sFormat[1,p-1]
				else
					sFreeStyle := ""
				end
				if p:=Pos("x",sFormat) > 0 then
					if p>1 then
						sWidth := "width:" +sFormat[1,p-1]+";"
					else
						sWidth := "width:;"
					end
					if p<Length(sFormat) then
						sHeight := "height:"+sFormat[p+1,255]+";"
					else
						sHeight := "heigh:;"
					end
					sFormat := sWidth+sHeight
				else
					sFormat:=";"
				end
				sFormat := sFormat + sFreeStyle
				if bNotWorking then
					write(ft, "<img src='../images/image.png' border='0'> ")
					sTarget := sName
				else
					sTarget := "<img src='"+sLink+"' style='"+sFormat+"' border='0'>"
				end
				if bInternal then
					write(ft, "<a class='notworking' href='../programm/gebo.prg?name="+sName+"'>")
					write(ft, sTarget + "</a>")
				else
					write(ft, sTarget)
				end
				cBuffer := ""

// Files
			elsif iPos+1<iMaximum, cBuffer+aBuffer[iPos +1] = sFileOpen then
				sBuffer := cBuffer
				sInner := ""
				iPos++
				while !(aBuffer[iPos++]+aBuffer[iPos +1]=sFileClose) do
					sInner := sInner +aBuffer[iPos]
				end
				sInner := LTrim(RTrim(sInner))
				iPos:=iPos+1

				if p := Pos("|",sInner) then
					sLink := sInner[1,p-1]
					sLinkText := sInner[p+1,255]
				else
					sLink := sInner
				end
				if sLink IN ["http://*","https://*","ftp://*"] then
					sTarget := "<a href='"+sLink+"' target='_blank'>"+ sLinkText +"</a>"
				else //internal link
					if ReadRec(dbWIKI, FindRec(dbWIKI, cleanName(sLink),1,1)) then
						if sLinkText = "" then
							sLinkText := MemoStr(dbWIKI, "Content")
						end
						bNotWorking := 0
						if MemoLen(dbWIKI, "Content") = 0 then
							bNotWorking := 1
						end
						if IsFile(sgDataFileDir+MemoStr(dbWIKI, "Content")) then
							bNotWorking := 0
						else
							bNotWorking := 1
						end
					else
						if sLinkText = "" then
							sLinkText := sLink
						end
						bNotWorking := 1
					end
					if bNotWorking then
						sTarget := buildWikiLink(sLink,sLinkText,"",bNotWorking,1)// "<a class='notworking' href='../data/file/"+MemoStr(db, "Content")+"' target='_blank'>"+sText+"</a>"
					else
						sTarget := "<a class='working' href='"+sgDataFileDir+MemoStr(dbWIKI, "Content")+"' target='_blank'>"+sLinkText+"</a>"
					end
					//sTarget := buildWikiLink(sURL,sText,"",bNotWorking)
				end
				write(ft, "<img src='../images/file.png' border='0'> ")
				write(ft, sTarget)

			elsif cBuffer = "\" AND iPos < iMaximum -2 AND cBuffer + aBuffer[iPos +1]+ aBuffer[iPos +2] = sBreak then
				iPos := iPos +2
				write(ft, sHTMLBR)

// inline text formatting
			elsif cBuffer=sCode[1] or Pos(cBuffer,sBold[1]+sItalic[1]+sUnderline[1]+sStroke[1]+sParagraph[1])>0 then
				sBuffer := cBuffer
				cBuffer := aBuffer[iPos++]
				//sBuffer := sBuffer+cBuffer
					if sBuffer +cBuffer = sBold then
						if !bBoldOn then
							bBoldOn:=1
							write(ft, sHTMLBoldOn)
						else
							bBoldOn:=0
							write(ft, sHTMLBoldOff)
						end
					elsif sBuffer +cBuffer = sItalic then
						if !bItalicOn then
							bItalicOn:=1
							write(ft, sHTMLItalicOn)
						else
							bItalicOn:=0
							write(ft, sHTMLItalicOff)
						end
					elsif sBuffer +cBuffer = sUnderline then
						if !bUnderlineOn then
							bUnderlineOn := 1
							write(ft, sHTMLUnderlineOn)
						else
							bUnderlineOn := 0
							write(ft, sHTMLUnderlineOff)
						end
					elsif sBuffer +cBuffer = sStroke then
						if !bStrokeOn then
							bStrokeOn := 1
							write(ft, sHTMLStrokeOn)
						else
							bStrokeOn := 0
							write(ft, sHTMLStrokeOff)
						end
					elsif sBuffer +cBuffer = sCode then
						if !bCodeOn then
							bCodeOn := 1
							write(ft, sHTMLCodeOn)
						else
							bCodeOn := 0
							write(ft, sHTMLCodeOff)
						end
					elsif sBuffer +cBuffer = sParagraph then
						if !bParagraphOn then
							bParagraphOn := 1
							write(ft, sHTMLParaOn)
						else
							bParagraphOn := 0
							write(ft, sHTMLParaOff)
						end
					else
						write(ft,sBuffer)
						iPos--
					end


			else
				write(ft,cBuffer)
			end
		else
			write(ft,cBuffer)
		end
		iStarted := 0
	end


endproc

procedure processWiki(dbWIKI : INTEGER; sWikiSource, sContext : STRING; bParts : INTEGER) : string

	var sWikiPage				: STRING = "ramtext:wikipage"
	var sTemp						: STRING = "ramtext:temp"
	var aBuffer					: CHAR[]
	var iPos						: INTEGER

	giPartsEnabled := bParts
	giPartCnt	:= 0

	bBoldOn := bUnderlineOn :=bStrokeOn := bItalicOn := bCodeOn := bParagraphOn := 0
	aHTMLHeadOn[1] := "<div  class='head5'><span class='headline'>"
	aHTMLHeadOn[2] := "<div  class='head4'><span class='headline'>"
	aHTMLHeadOn[3] := "<div  class='head3'><span class='headline'>"
	aHTMLHeadOn[4] := "<div  class='head2'><span class='headline'>"
	aHTMLHeadOn[5] := "<div  class='head1'><span class='headline'>"
	aHTMLHeadOff[1] := "</span>"
	aHTMLHeadOff[2] := "</span>"
	aHTMLHeadOff[3] := "</span>"
	aHTMLHeadOff[4] := "</span>"
	aHTMLHeadOff[5] := "<hr></span>"

	Ramtext(sWikiPage,8192)
	Ramtext(sTemp,8192)
	if dbWIKI then
		dbWIKI := SetAlias(dbWIKI,"clone")
	else
		dbWIKI := OpenDB("../database/wiki.dat")
	end
	var r : real = now

	var fs, ft	: INTEGER
	CopyFile(sWikiSource, sgTempDir+sgSession+".bin")
	fs := f_open(sgTempDir+sgSession+".bin")
	InitArray(aBuffer[f_size(fs)])
	f_read(fs,aBuffer)

	ft := Rewrite(sWikiPage)
	iStarted:=1
	firstpass(aBuffer,f_size(fs) -1,ft,0,dbWIKI)
	close(ft)
	close(fs)

	CopyFile(sWikiPage,sgTempDir+sgSession+".bi2")

	fs := f_open(sgTempDir+sgSession+".bi2")
	InitArray(aBuffer[f_size(fs)])
	f_read(fs,aBuffer)
	ft := Rewrite(sWikiPage)
	nimmersatt(aBuffer,f_size(fs) -1,ft,0,dbWIKI, sContext)
	writeln(ft, "")
	f_close(fs)
	close(ft)
		DelFile(sgTempDir+sgSession+".bin")
  	DelFile(sgTempDir+sgSession+".bi2")
	CloseDB(dbWIKI)

	return sWikiPage
endproc
