module render2
/***************************************************************************
                        render2.mod  -  description
                             -------------------
											gebogebo render engine 2nd version
    begin                : 2005
    copyright            : (C) 2004 by tdb Software Service
    email                : tf@tdb.de

		$Id: render2c.mod,v 1.1 2005/09/08 07:34:11 path Exp $
 ***************************************************************************

 ***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

var giPartCnt				: INTEGER
var giPartsEnabled	: INTEGER

Var sLinkOpen		: STRING = "[["
Var sLinkClose	: STRING = "]]"

Var sImgOpen		: STRING = "{{"
Var sImgClose		: STRING = "}}"

Var sFileOpen		: STRING = "(("
Var sFileClose	: STRING = "))"


var sBold						: STRING = "**"
var sHTMLBoldOn			: STRING = "<span class='bold'>"
var sHTMLBoldOff		: STRING = "</span>"

var sItalic					: STRING = "//"
var sHTMLItalicOn		: STRING = "<span class='italic'>"
var sHTMLItalicOff	: STRING = "</span>"

var sUnderline				: STRING = "__"
var sHTMLUnderlineOn	: STRING = "<span class='underline'>"
var sHTMLUnderlineOff	: STRING = "</span>"

var sSup							: STRING = "``"
var sHTMLSupOn				: STRING = "<sup>"
var sHTMLSupOff				: STRING = "</sup>"

var sSub							: STRING = ",,"
var sHTMLSubOn				: STRING = "<sub>"
var sHTMLSubOff				: STRING = "</sub>"

var sStroke						: STRING = "--"
var sHTMLStrokeOn			: STRING = "<s>"
var sHTMLStrokeOff		: STRING = "</s>"

var sMono							: STRING = "~~"
var sHTMLMonoOn				: STRING = "<span class='monospace'>"
var sHTMLMonoOff			: STRING = "</span>"



var sHL1							: STRING = "======"
var aHTMLHeadOn				: STRING[6]
var aHTMLHeadOff			: STRING[6]

var sHTMLH1On					: STRING = "<div class='head1'>"
var sHTMLH1Off				: STRING = "<hr/></div>"

var sHL2							: STRING = "====="
var sHTMLH2On					: STRING = "<div class='head2'>"
var sHTMLH2Off				: STRING = "</div>"

var sHL3							: STRING = "===="
var sHTMLH3On					: STRING = "<div class='head3'>"
var sHTMLH3Off				: STRING = "</div>"

var sHL4							: STRING = "==="
var sHTMLH4On					: STRING = "<div class='head4'>"
var sHTMLH4Off				: STRING = "</div>"

var sHL5							: STRING = "=="
var sHTMLH5On					: STRING = "<div class='head5'>"
var sHTMLH5Off				: STRING = "</div>"


var sHR								: STRING = "----"
var sHTMLHR						: STRING = "<hr noshade size='1'/>"

var sHTMLCodeOn			  : STRING = "<div class='code'>"
var sHTMLCodeOff		  : STRING = "</div>"

var sBreak						: STRING = "\\ "
var sHTMLBR						: STRING = "<br/>"


var giLevelOfRecursion	: INTEGER
var gbListMode					: INTEGER = 0
var gbaLists						: INTEGER[99]
var gbRunThru						: INTEGER = 0
var gbComment						: INTEGER = 0
var gbBoldOn, gbUnderlineOn, gbStrokeOn, gbItalicOn, gbCodeOn, gbSupOn, gbSubOn, gbMonoOn, gbTableOn : INTEGER = 0
var gbNoBreak						: INTEGER
var gbMacroOn						: INTEGER
var sLink, sLinkText		: STRING
var gbLinkOn 						: INTEGER
var gbImageOn						: INTEGER
var sImage,sImageFormat, sImageStyle					: STRING
var gbFileOn						: INTEGER
var sFile, sFileText		: STRING
var gsCurrentContext		: STRING
var giListLevel					: INTEGER
var giListLevelBefore		: INTEGER
var gsWordAtoms					: STRING = OemToAnsi("abcdefghijklmnopqrstuvwxyz1234567890")
var sTableStyle					: STRING
var sgWikiPageName 			: STRING
var sgWikiPageFull			: STRING
var aTOC								: STRING[999,1]
var sgTocPH							: STRING
var giIncludeLevel			: INTEGER = 0
var sLev : string = "x"

procedure completeLink(dbWIKI, ft:integer; sL : String) : string

	var iPos				: INTEGER
	var bNotWorking	: INTEGER
	var iType				: INTEGER
	var iP					: INTEGER
	var sWiki 			: String
	var sPage 			: String
	var iProtection : INTEGER

			iPos := Pos("|",sL)
			iP :=  Pos("]]",sL)
			if iP = 0 AND iPos = 0 AND sLinkText="" then
				sLink := sLink+sL //+" "
				return sL := ""
			elsif  iP = 0 AND iPos = 0 AND sLinkText#"" then
				sLinkText := sLinkText+" "+sL
				return sL := ""
			elsif iP = 0 AND iPos > 0 then
				sLink := sLink+sL[1,iPos -1]
				sLinkText := sL[iPos+1,255]
				return sL := ""
			elsif iP >0 AND iPos > 0 AND iPos < iP then
				sLink := sLink + sL[1,iPos-1]
				sLinkText := sL[iPos+1,iP -iPos -1]
				sL := sL[iP+2,255]
				gbLinkOn := 0
			elsif iP > 0 and iPos = 0 OR iPos > iP then
				if sLinkText then
					sLinkText := sLinkText + sL[1,iP-1]
				else
					sLinkText := sLink := sLink + sL[1,iP-1]
				end
				sL := sL[iP+2,255]
				gbLinkOn := 0
			end
			if sLink IN ["http://*","https://*","ftp://*","*>*"] then
				write(ft, "<img src='"+sgRelPath+"/images/link.png' border='0' alt='Link' /> ")
				if sLink LIKE "*>*" then
					sWiki := sLink[1,Pos(">",sLink)-1]
					sPage := sLink[Pos(">",sLink)+1,255]
					write(ft, "<a href='"+intermap(sWiki,sPage)+"' target='_blank'>"+sLinkText+"</a>")
				else
					write(ft, "<a href='"+sLink+"' target='_blank'>"+sLinkText+"</a>")
				end
			else
				if sLinkText[1]=":" then sLinkText:=sLinkText[2,255] end //remove leading colon, for the display at least
				if sLink[1]=":" then			//NULL-Context
					sLink:=sLink[2,255]
				elsif iType:=getPageType(sLink) = cigTypePage then	//current or other context
					if Pos(":",sLink)=0, gsCurrentContext then // =current context
						sLink := gsCurrentContext+":"+sLink
					end
				end
				if iType # cigTypeGebo, ReadRec(dbWIKI, FindRec(dbWIKI, cleanName(ansitooem(sLink)),1,1)) then
					bNotWorking := 0
					if MemoLen(dbWIKI, "Content") = 0 then
						bNotWorking := 1
					end
				elsif sLink LIKE "gebo:*" then
					bNotWorking := 0
				else
					bNotWorking := 1
				end

// 				if iProtection := isPageProtected(sLink) then //cleanName(ansitooem(
// //					bNotWorking := 3
// 				end
				writeText(ft,buildWikiLink(sLink,sLinkText,"",bNotWorking,1,isPageProtected(sLink)))
				sLink:=""
				sLinkText:=""
			end
		return sL
endproc

procedure completeFile(dbWIKI, ft:integer; sL : String) : string

	var iPos		: INTEGER
	var bNotWorking	: INTEGER
	var iType		: INTEGER
	var iP			: INTEGER
	var sTarget	: STRING

			iPos := Pos("|",sL)
			iP :=  Pos("))",sL)
			if iP = 0 AND iPos = 0 AND sFileText="" then
				sFile := sFile+sL //+" "
				return sL := ""
			elsif  iP = 0 AND iPos = 0 AND sFileText#"" then
				sFileText := sFileText+" "+sL
				return sL := ""
			elsif iP = 0 AND iPos > 0 then
				sFile := sFile+sL[1,iPos -1]
				sFileText := sL[iPos+1,255]
				return sL := ""
			elsif iP >0 AND iPos > 0 AND iPos < iP then
				sFile := sFile + sL[1,iPos-1]
				sFileText := sL[iPos+1,iP -iPos -1]
				sL := sL[iP+2,255]
				gbFileOn := 0
			elsif iP > 0 and iPos = 0 OR iPos > iP then
				if sFileText then
					sFileText := sFileText + sL[1,iP-1]
				else
					sFileText := sFile := sFile + sL[1,iP-1]
				end
				sL := sL[iP+2,255]
				gbFileOn := 0
			end
			write(ft, "<img src='"+sgRelPath+"/images/file.png' border='0' alt='file' /> ")
			if sFile IN ["http://*","https://*","ftp://*"] then
				sTarget := "<a href='"+sFile+"' target='_blank'>"+ sFileText +"</a>"
				write(ft, sTarget)
			else //internal link
				if ReadRec(dbWIKI, FindRec(dbWIKI, cleanName(sFile),1,1)) then
					if sFileText = "" then
						sFileText := MemoStr(dbWIKI, "Content")
					end
					bNotWorking := 0
					if MemoLen(dbWIKI, "Content") = 0 then
						bNotWorking := 1
					end
					if IsFile(sgRelPath + sgDataFileDir+MemoStr(dbWIKI, "Content")) then
						bNotWorking := 0
					else
						bNotWorking := 1
					end
				else
					if sFileText = "" then
						sFileText := sFile
					end
					bNotWorking := 1
				end
				if bNotWorking then
					sTarget := buildWikiLink(sFile,sFileText,"",bNotWorking,1,0)// "<a class='notworking' href='../data/file/"+MemoStr(db, "Content")+"' target='_blank'>"+sText+"</a>"
					writeText(ft, sTarget)
				else
					sTarget := "<a class='working' href='"+sgRelPath + sgDataFileDir+MemoStr(dbWIKI, "Content")+"' target='_blank'>"+sFileText+"</a>"
					write(ft, sTarget)
				end
				//sTarget := buildWikiLink(sURL,sText,"",bNotWorking)
			end
		return sL
endproc


procedure completeImage(dbWIKI, ft:integer; sL : String) : string

	var iPos				: INTEGER
	var bNotWorking	: INTEGER
	var iType				: INTEGER
	var iP					: INTEGER
	var bInternal		: INTEGER
	var p						: INTEGER
	var sName				: STRING
	var sRevision		: STRING
	var sWidth			: STRING
	var sHeight			: STRING
	var sTarget			: STRING
	var sKeywords		: STRING

		iPos := Pos("|",sL)
		iP :=  Pos("}}",sL)
		if iP = 0 AND iPos = 0 AND sImageFormat="" then
			sImage := sImage+sL //+" "
			return sL := ""
		elsif  iP = 0 AND iPos = 0 AND sImageFormat#"" then
			sImageFormat := sImageFormat+" "+sL
			return sL := ""
		elsif iP = 0 AND iPos > 0 then
			sImage := sImage+sL[1,iPos -1]
			sImageFormat := sL[iPos+1,255]
			return sL := ""
		elsif iP >0 AND iPos > 0 AND iPos < iP then
			sImage := sImage + sL[1,iPos-1]
			sImageFormat := sL[iPos+1,iP -iPos -1]
			sL := sL[iP+2,255]
			gbImageOn := 0
		elsif iP > 0 and iPos = 0 OR iPos > iP then
			if sImageFormat then
				sImageFormat := sImageFormat + sL[1,iP-1]
			else
				sImage := sImage + sL[1,iP-1]
			end
			sL := sL[iP+2,255]
			gbImageOn := 0
		end

		if !sImage IN ["http://*","https://*","ftp://*"] then
			bInternal:=1
			if p:=Pos(",",sImage) then
				sName := sImage[1,p-1]
				sRevision := sImage[p+1,255]
			else
				sName := sImage
				sRevision := ""
			end

			if ReadRec(dbWIKI, FindRec(dbWIKI, cleanName(sName),1,1)) then
				bNotWorking := 0
				if sRevision="" then
					sImage := sgRelPath + sgDataImgDir+MemoStr(dbWIKI, "Content")
					sKeywords := OemToAnsi(GetField(dbWIKI, "Keywords"))
					if MemoLen(dbWIKI, "Content") = 0 then
						bNotWorking := 1
					end
				else
					sImage := sgRelPath + sgDataImgDir+sName[5,255]+","+sRevision
				end
			else
				bNotWorking := 1
			end
		else
			bInternal := 0
			bNotWorking:=0
		end
		if p := Pos("|",sImageFormat)>0 then // get additional stylesheet settings
			sImageStyle := sImageFormat[p+1,255]
			sImageFormat := sImageFormat[1,p-1]
		else
			sImageStyle := ""
		end
		if p:=Pos("x",sImageFormat) > 0 then
			if p>1 then
				sWidth := "width='" +sImageFormat[1,p-1]+"' "
			else
				sWidth := "width='' "
			end
			if p<Length(sImageFormat) then
				sHeight := "height='"+sImageFormat[p+1,255]+"' "
			else
				sHeight := "height='' "
			end
			sImageFormat := sWidth+sHeight
		else
			sImageFormat:=""
		end
		sImageFormat := sImageFormat + sImageStyle
		if bNotWorking then
			write(ft, "<img src='"+sgRelPath+"/images/image.png' border='0' alt='image' /> ")
			sTarget := sName
		else
			sTarget := "<img src='"+sImage+"' style='"+sImageStyle+"' "+sImageFormat+" border='0' alt='image' title='"+sKeywords+"'/>"
		end
		if bInternal then
			write(ft, "<a class='notworking' href='"+sgRelPath+"/programm/gebo.prg?name="+sName+"'>")
			write(ft, sTarget + "</a>")
		else
			write(ft, sTarget)
		end

		return sL
endproc

procedure isListItem(sL : STRING) : integer

	var i : integer
		while i <= giListLevel, sL[i++]=" " do
		end
		if sL[i]="*" or sL[i]="#" then
			return i
		else
			return -1 //no list item
		end


endproc

procedure closeLists(ft,iToLevel : integer)
//closes all lists down to iToLevel
	while giListLevel>iToLevel do
		if gbaLists[giListLevel] = 1 then
				write(ft,"</li></ul>")
		elsif gbaLists[giListLevel] = 2 then
				write(ft,"</li></ol>")
		else
			//error
		end
		gbaLists[giListLevel]:=0
		giListLevel--
	end
endproc

procedure closeCode(ft : INTEGER)
		if gbCodeOn then
			write(ft, sHTMLCodeOff)
			gbCodeOn := 0
		end
endproc

procedure dispatchMacro(dbWIKI, ft : integer; sMacro : STRING)
// parses the macro call end executes it

		var p, q 				: INTEGER
		var sParameter	: STRING
		var rBegin			: REAL
		var bAllowed		: INTEGER

		if p := Pos("(",sMacro)>0, q:=Pos(")",sMacro)>p then
			sParameter := sMacro[p+1,q-p-1]
			sMacro := sMacro[1,p-1]
		end

		sMacro := lower(sMacro)
		write(ft,"<!-- macro: "+sMacro +" "+ sParameter +" //-->")
		rBegin := NOW
		if bgMacroPlugins, sMacro[1,7] = "plugin:" then // execute a macro-plugin
			sMacro := sMacro[8,255]
			Note(sParameter)
			TimeOut(igMacroTimeout)
			SetPara("ec 1")
			do _"ExecMacro("+sgPluginDir + sMacro+",macro("+Str(dbWIKI)+","+Str(ft)+",'"+gsCurrentContext+"','"+sgWikiPageName+"'))"
			TimeOut(0)
			SetPara("ec 0")
			if TDB_LastError then
				write(ft, "<span class='macrofault'>"+lang("badmacroplugin")+ " " +sMacro+"</span>")
			end
		else
			if bAllowed := isMacroAllowed(sMacro) then
				SetPara("ec 1")
				do _"macro_"+sMacro+"(dbWIKI,ft,gsCurrentContext,sgWikiPageName)"
				SetPara("ec 0")
			end
			if !bAllowed OR TDB_LastError then
				write(ft, "<span class='macrofault'>"+lang("badmacro") + " "+sMacro+"</span>")
			end
		end
		write(ft,"<!-- end of macro: "+sMacro + " ["+ Str(Val(Exchange(RightStr(TimeStr(NOW - rBegin,3),6),".","")))+" ms] //-->")
endproc


procedure includePage(dbWIKI,ft : INTEGER; sName : STRING)
/*
Include the content of another page inside the current one
*/
	var sSource,sTarget : STRING
	var f 							: integer
	var sOriginalName 	: STRING
	var sURL						: STRING
	var p								: INTEGER
	var sWiki						: STRING
	var iBeforeParts		: INTEGER
	var sContextBefore	: STRING

	sContextBefore := gsCurrentContext
	if p := Pos(":",sName)=0 then
		sName := sName
	else
		gsCurrentContext := sName[1,p-1]
	end

	if sName # sgWikiPageName, giIncludeLevel <  10 then
		sSource := "ramtext:src"+CGIGetSession+Str(giIncludeLevel)
		if p := Pos(">",sName) then
			sURL := intermap(sWiki := sName[1, p-1], sName := sName[p+1,255])
			p := Pos("?",sURL) -1
	//		sgOverWriteURL :=  sName[1,p]
			LoadTemplate(sURL + "&action=export&format=raw")
			CopyFile("ramtext",sSource)
		else
			sName := cleanName(sName)
			ReadRec(dbWIKI, FindRec(dbWIKI, sName,1,1))
			CopyMemo(dbWIKI, "Content", sSource)
		end
		giIncludeLevel++
		sTarget := "ramtext:"+CGIGetSession+Str(giIncludeLevel)
		if GetSize(sSource) > 0 then
			Ramtext(sTarget,8192)
			giLevelOfRecursion--
			sOriginalName := sgWikiPageName
			sgWikiPageName := sName
			iBeforeParts := giPartCnt //remember the parts counted within the origin page
			do _"sTarget := parse(dbWIKI, '"+sSource+"', '"+sTarget+"')"
			gsCurrentContext := sContextBefore
			giPartCnt := iBeforeParts //reset the parts
			giLevelOfRecursion++
			sgWikiPageName := sOriginalName
			write(ft,"<div class='include'>")
 			f := reset(sTarget)
 			readln(f)
 			repeat
				write(ft, read(f,255))
 			until eot(f)
			close(f)
			write(ft, "<div class='includelink'>[[")
			writeText(ft, buildWikiLink(sName,sName, "",0,1,0))
			writeln(ft, "]]</div></div>")
			sgOverWriteURL := ""
	else
			write(ft,"<div class='include'>"+lang("nothing2include")+" "+sName+"</div>")
		end
		giIncludeLevel--
	else
		write(ft,"<div class='include'>"+lang("toodeep2include")+" "+sName+"</div>")
	end
endproc

procedure parseLine(dbWIKI, ft : integer; sL  : string)

	var iRec						: INTEGER
	var i								: INTEGER
	var iLev						: INTEGER
	var iPos						: INTEGER
	var sWord   				: STRING
	var sMacro					: STRING
	var bNotWorking			: INTEGER
	var iType						: INTEGER
	var iP							: INTEGER
	var bNoFormatting		: INTEGER
	var iLevDelta 			: INTEGER
	var p								: INTEGER
	var bHeadCell 			: INTEGER

		if gbComment then
// ---------------------------------------------
// ignore all wiki code and run through the source
// ---------------------------------------------
			if iPos := Pos("*/",sL)>0 then //turn off run through?
				//write(ft,sL[1,iPos-1])
				gbComment:=0
				sL := sL[iPos+2,255]
			else
				//write(ft, sL)
				return
			end
		end

		if gbRunThru then
// ---------------------------------------------
// ignore all wiki code and run through the source
// ---------------------------------------------
			if iPos := Pos("#|",sL)>0 then //turn off run through?
				write(ft,sL[1,iPos-1])
				gbRunThru:=0
				sL := sL[iPos+2,255]
			else
				write(ft, sL)
				return
			end
		end

		if bgMacroEnabled, gbMacroOn then
// ---------------------------------------------
// a macro beginning was detected, is it a valid macro call?
// ---------------------------------------------
			if iPos := Pos("''",sL) > 0 then
				sMacro := sL[1,iPos-1]
				gbMacroOn:=0
				iPos := iPos+2
				dispatchMacro(dbWIKI, ft, sMacro)
				sL := sL[iPos,255]
			else
				write(ft, "''")
				gbMacroOn:=0
			end

		end
		if gbImageOn then
// ---------------------------------------------
// complete the image
// ---------------------------------------------
			sL := completeImage(dbWIKI,ft,sL)
		elsif gbFileOn then
// ---------------------------------------------
// complete the file
// ---------------------------------------------
			sL := completeFile(dbWIKI,ft,sL)
		end
		if gbLinkOn then
// ---------------------------------------------
// complete the link
// ---------------------------------------------
			sL := completeLink(dbWIKI,ft,sL)
		end

		if gbTableOn then
// ---------------------------------------------
// complete the table
// ---------------------------------------------
			if sL[1,2] = "|}" then
				write(ft, "</tr></table>")
				gbTableOn := 0
				return
			elsif sL[1,2] = "|-" then
				write(ft, "</tr><tr "+sL[3,255]+">")
				return
			elsif sL[1] = "|" or sL[1] = "!" then
				if sL[1]="!" then // head cell? (<th>)
					bHeadCell := 1
				else //no, it's a <td>
					bHeadCell := 0
				end
				if sL[2]=":" then //it's a formatting first
					sL:=sL[3,255] //
					p := Pos(":|",sL)
				end
				if bHeadCell then
					write(ft, "<th ")
				else
					write(ft, "<td ")
				end
				if p then
					write(ft, sL[1,p -1]+">")
					p++
				else
					write(ft, ">")
					p++
				end

 				parseLine(dbWIKI, ft, sL[p+1,255])
				sL := ""
			end

		end

		if giLevelOfRecursion > 10 then //just a figure - too many recursive calls
			giLevelOfRecursion--
			return
		end
		giLevelOfRecursion++

		if !gbComment,!gbRunThru,giLevelOfRecursion=1, sL = "" then
// ---------------------------------------------
// a blank line (closes some objects)
// ---------------------------------------------
			closeCode(ft)
			closeLists(ft,0)
		elsif !gbRunThru,!gbComment,giLevelOfRecursion=1, sL[1,2]="<<" then
// ---------------------------------------------
// page inclusion
// ---------------------------------------------
			closeCode(ft)
			closeLists(ft,0)
			includePage(dbWIKI,ft,LTrim(RTrim(sL[3,255])))
		elsif !gbRunThru,!gbComment,giLevelOfRecursion=1, sL[1,2]="==" then
// ---------------------------------------------
// a headline (level 1 to 5)
// ---------------------------------------------
			closeCode(ft)
			closeLists(ft,0)
			i := 2
			iLev:=1
			while sL[i++]="=",i<=6 do
				iLev++
			end
			giPartCnt++
			write(ft, Exchange(aHTMLHeadOn[iLev],"$id","headline"+Str(giPartCnt)))
			write(ft, sL[i,255])
			write(ft, aHTMLHeadOff[iLev])
			if giPartsEnabled, giIncludeLevel=0 then //display edit link on the right?
				write(ft, "<div class='partedit'><a href='{self}?name={name}&amp;action=edit&amp;part="+Str(giPartCnt)+"'>edit</a></div></div>")
			else
				write(ft, "</div>")
			end
			sL:="" //finished the line
			gbNoBreak:=1
		elsif !gbRunThru,!gbComment,giLevelOfRecursion=1, iLevDelta := isListItem(sL) > 0, sL[iLevDelta+1]=" " then //(sL[1]="*" OR sL[1]="#") AND sL[2]=" " then //list
// ---------------------------------------------
// a list (ordered or unordered)
// ---------------------------------------------
			if iLevDelta < giListLevel then
				closeLists(ft, iLevDelta)
			else
				giListLevel := iLevDelta
			end
			if sL[giListLevel]="*" then
				if gbaLists[giListLevel] = 0 then
					write(ft,"<ul>")
				else
					write(ft,"</li>")
				end
				write(ft,"<li>")
				gbaLists[giListLevel] := 1
			elsif sL[giListLevel]="#" then
				if gbaLists[giListLevel] = 0 then
					write(ft,"<ol>")
				else
					write(ft,"</li>")
				end
				write(ft,"<li>")
				gbaLists[giListLevel] := 2
			end
			parseLine(dbWIKI,ft, sL[2+giListLevel,255])
			gbNoBreak:=1
			sL:="" //finished the line
		elsif !gbRunThru,!gbComment,giLevelOfRecursion=1,sL[1,2]="  " then //not a list item at all
// ---------------------------------------------
// a preformatted (code) block
// ---------------------------------------------
			closeLists(ft,0)
			if !gbCodeOn then
				write(ft,sHTMLCodeOn)
				gbCodeOn := 1
			end
			write(ft, ToHTML(AnsiToOem(sL[3,127])))
			write(ft, ToHTML(AnsiToOem(sL[130,128])))
		elsif !gbRunThru,!gbComment,giLevelOfRecursion=1,sL="----" then
// ---------------------------------------------
// a horizontal ruler
// ---------------------------------------------
			closeCode(ft)
			closeLists(ft,0)
			write(ft,"<hr/>")
			gbNoBreak:=1
		elsif !gbRunThru,!gbComment,giLevelOfRecursion=1,sL[1,2]="{|" then
// ---------------------------------------------
// a table starts
// ---------------------------------------------
			gbTableOn := 1
			if Length(sL) > 2 then
				sTableStyle := sL[3,255]
			end
			write(ft, "<table "+sTableStyle+"><tr>")
			sL:=""
			iPos := 256
		else
// ---------------------------------------------
// now the formattings that are not line based are to be processed
// ---------------------------------------------
			if !gbRunThru,!gbComment,giLevelOfRecursion=1 then
				closeCode(ft)
			end
			iPos:=0
			sWord := ""
			while iPos++<=Length(sL) do

				if sL[iPos,4] LIKE "www." OR sL[iPos,6] LIKE "ftp://" OR sL[iPos,7] LIKE "http://"  OR sL[iPos,8] LIKE "https://" then
					sLink := sL[iPos]
					repeat
						sLink := sLink + sL[iPos++]
					until sL[iPos] = "?" or sL[iPos] = "*"  or Length(sLink) >= 6 or iPos = Length(sL)

					// if last char was a * or ? it can not be an URL
					if Pos(sL[iPos],"*?")<1, sLink IN ["http:/","https:","ftp://","www.??"] then
						//find the end of the URL
						while iPos < Length(sL), !(sL[iPos++] IN ["<",">","|"," ",^t]) OR sL[iPos]="?"  do
							sLink := sLink + sL[iPos]
						end
						if iPos < Length(sL) then //did not reach the end, so set cursor one step back
							iPos:=iPos -1
						end
						if sLink LIKE "www.*" then //add http:// before
							sLinkText := sLink
							sLink := "http://"+sLink
						else
							sLinkText := sLink
						end
						write(ft, "<img src='"+sgRelPath+"/images/link.png' border='0' alt='link' /> ")
						write(ft, "<a href='"+sLink+"' target='_blank'>"+sLinkText+"</a>")
					else
						iPos := iPos - Length(sLink)+1
						write(ft, sLink)
					end
					iPos++
				end
				if gbAutoLink, sWord, !Pos(lower(sL[iPos]), gsWordAtoms) then
					if gbAutoLink, cleanName(sWord)#sgWikiPageName then
						if !gsCurrentContext, iRec := FindRec(dbWIKI, cleanName(sWord),1,1) OR gsCurrentContext, iRec := FindRec(dbWIKI, cleanName(gsCurrentContext+":"+sWord),1,1) OR (gbAutoLinkTwice,iRec := FindRec(dbWIKI, cleanName(sWord),1,1)) then
							if ReadRec(dbWIKI,iRec), MemoLen(dbWIKI, "Content")  then
								writeText(ft,buildWikiLink(extractContext(GetField(dbWIKI,"Name"))+":"+sWord,sWord,"",2,1,0))
							else
								write(ft,sWord)
							end
						else
							write(ft,sWord)
						end
					else
						write(ft,sWord)
					end
					sWord := ""
				end

				if sL[iPos] = "*" OR sL[iPos] IN ["[","{","(","-","_","~","|","#","\","/"," ",^t,",","^","'","`"] then
					bNoFormatting:=0
					if sL[iPos,2] = "|#" then
						gbRunThru:=1
						parseLine(dbWIKI,ft,sL[iPos+2,255])
						sL := "" //sL[iPos+1,255]
						iPos := 255
					elsif sL[iPos,2] = "/*" then
						gbComment:=1
						parseLine(dbWIKI,ft,sL[iPos+2,255])
						sL := "" //sL[iPos+1,255]
						iPos := 255
					elsif bgMacroEnabled, sL[iPos,2] = "''" then //macro
						gbMacroOn:=1
						parseLine(dbWIKI,ft,sL[iPos+2,255])
						sL := "" //sL[iPos+1,255]
						iPos := 255
					elsif 	sL[iPos,2] = "**" then //bold
						if gbBoldOn then
							write(ft,sHTMLBoldOff)
							gbBoldOn:=0
						else
							write(ft,sHTMLBoldOn)
							gbBoldOn:=1
 						end
 						iPos:=iPos+1
					elsif sL[iPos,2] = "//" then //italic
						if gbItalicOn then
							write(ft,sHTMLItalicOff)
							gbItalicOn:=0
						else
							write(ft,sHTMLItalicOn)
							gbItalicOn:=1
 						end
 						iPos:=iPos+1
					elsif sL[iPos,2] = "__" then //underline
						if gbUnderlineOn then
							write(ft,sHTMLUnderlineOff)
							gbUnderlineOn:=0
						else
							write(ft,sHTMLUnderlineOn)
							gbUnderlineOn:=1
 						end
 						iPos:=iPos+1
					elsif sL[iPos,2] = "--" then //stroke
						if gbStrokeOn then
							write(ft,sHTMLStrokeOff)
							gbStrokeOn:=0
						else
							write(ft,sHTMLStrokeOn)
							gbStrokeOn:=1
 						end
 						iPos:=iPos+1
					elsif sL[iPos,2] = sSub then //sub
						if gbSubOn then
							write(ft,sHTMLSubOff)
							gbSubOn:=0
						else
							write(ft,sHTMLSubOn)
							gbSubOn:=1
 						end
 						iPos:=iPos+1
					elsif sL[iPos,2] = sSup then //sup
						if gbSupOn then
							write(ft,sHTMLSupOff)
							gbSupOn:=0
						else
							write(ft,sHTMLSupOn)
							gbSupOn:=1
 						end
 						iPos:=iPos+1
					elsif sL[iPos,2] = "~~" then //monospace
						if gbMonoOn then
							write(ft,sHTMLMonoOff)
							gbMonoOn:=0
						else
							write(ft,sHTMLMonoOn)
							gbMonoOn:=1
 						end
 						iPos:=iPos+1
					elsif sL[iPos,2] = "[[" then //wiki link
						gbLinkOn := 1
						sLink:=""
						sLinkText:=""
 						parseLine(dbWIKI,ft, sL[iPos+2,255])
 						sL:=""
 						iPos := 255
					elsif sL[iPos,2] = "{{" then //wiki image
						gbImageOn := 1
						sImage:=""
						sImageFormat:=""
						sImageStyle:=""
 						parseLine(dbWIKI,ft, sL[iPos+2,255])
 						sL:=""
 						iPos := 255
					elsif sL[iPos,2] = "((" then //wiki file
						gbFileOn := 1
						sFile:=""
						sFileText:=""
 						parseLine(dbWIKI,ft, sL[iPos+2,255])
 						sL:=""
 						iPos := 255
// 					elsif sL[iPos]="|", gbTableOn then
// 						write(ft, "</td><td>")
					elsif sL[iPos]=" " then
						write(ft,sL[iPos])
					else
						bNoFormatting:= 1
					end
					if bNoFormatting then
							write(ft,sL[iPos])
					end

				elsif gbAutoLink, Pos(lower(sL[iPos]), gsWordAtoms) then
					sWord := sWord + sL[iPos]
				else
					write(ft,sL[iPos])
				end
			end
			if gbAutoLink, sWord, cleanName(sWord)#sgWikiPageName then
				if gbAutoLink, ReadRec(dbWIKI,FindRec(dbWIKI, cleanName(sWord),1,1)), MemoLen(dbWIKI, "Content")  then
					writeText(ft,buildWikiLink(sWord,sWord,"",2,1,0))
				else
					write(ft,sWord)
				end
				sWord := ""
			end
			sL := ""
		end
		giLevelOfRecursion--
endproc

procedure parse(dbWIKI:integer; sSource, sTarget : STRING) : STRING
//line based parser
	var fs			: INTEGER
	var ft			: INTEGER
	var sL			: STRING
	var bLongLine : INTEGER

	fs := Reset(sSource)
	ft := Rewrite(sTarget)
	gbNoBreak := 0

	while !eot(fs) do
		if !(gbComment OR gbCodeOn OR gbTableOn OR bLongLine OR gbNoBreak) then
			writeln(ft,"<br/>")
		else
			if !bLongLine then
				writeln(ft,"")
			end
		end
		gbNoBreak := 0
		sL := ReadLn(fs)
		if Length(sL)=255 then
			bLongLine := 1
		else
			bLongLine := 0
		end
		parseLine(dbWIKI,ft,sL)
	end
	closeLists(ft,0)
	close(ft)
	close(fs)
	return sTarget
endproc




procedure processWiki(dbWIKI : INTEGER; sName, sWikiSource, sContext : STRING; bParts : INTEGER) : string

	var sWikiPage				: STRING = "ramtext:wikipage"
	var sTemp						: STRING = "ramtext:temp"
	var aBuffer					: CHAR[]
	var iPos						: INTEGER
	var	p								: INTEGER

	while p:=Pos(":", sName) do
		sName := sName[p+1,255]
	end

	if sContext then
		sgWikiPageFull := sContext +":" +sName
	else
		sgWikiPageFull := sName
	end

	sgWikiPageName := sName

	giPartsEnabled := bParts
	giPartCnt	:= 0
	gsCurrentContext := sContext
	giListLevel := 1
	gbBoldOn := gbUnderlineOn := gbStrokeOn := gbItalicOn := gbCodeOn := gbSupOn := gbSubOn := gbMonoOn := gbTableOn := 0
	clrarray(gbaLists)

	aHTMLHeadOn[5] := "<div class='headline'><a name='$id'></a><span class='hl1'>"
	aHTMLHeadOn[4] := "<div class='headline'><a name='$id'></a><span class='hl2'>"
	aHTMLHeadOn[3] := "<div class='headline'><a name='$id'></a><span class='hl3'>"
	aHTMLHeadOn[2] := "<div class='headline'><a name='$id'></a><span class='hl4'>"
	aHTMLHeadOn[1] := "<div class='headline'><a name='$id'></a><span class='hl5'>"
	aHTMLHeadOff[5] := "</span>"
	aHTMLHeadOff[4] := "</span>"
	aHTMLHeadOff[3] := "</span>"
	aHTMLHeadOff[2] := "</span>"
	aHTMLHeadOff[1] := "</span>"
	InitArray(aTOC[999,1])

	Ramtext(sWikiPage,64000)
	Ramtext(sTemp,64000)
	if dbWIKI then
		dbWIKI := SetAlias(dbWIKI,"clone")
	else
		dbWIKI := OpenDB("../database/wiki.dat")
	end
	var r : real = now

	var fs, ft	: INTEGER

	sWikiPage := parse(dbWIKI,sWikiSource,sWikiPage)
	closedb(dbWIKI)
	return sWikiPage
endproc
