module rss

uses common
uses fulltext

procedure writeHeader
	CGIClearBuffer
	CGIWriteLn('content-type: text/xml')
  CGIWriteLn('')
	CGIWriteLn('<?xml version="1.0" encoding="ISO-8859-1" ?>')
  CGIWriteLn('<rss version="0.91">')
  CGIWriteLn('<channel>')
  CGIWriteLn('')
  CGIWriteLn('<title>'+sgWikiName+'</title>')
  CGIWriteLn('<language>'+sgLanguage+'</language>')
  CGICloseBuffer
endproc



procedure searchRSS
// GET paramater "max=" specifies maximum number of returned items
	var dbWIKI	: INTEGER
	var iRec 		: INTEGER
	var iCnt		: INTEGER
	var bSearch	:	STRING
	var iPos, i		:	INTEGER
	var sFirstWord : STRING
	var sSelection : STRING
	var iMax 		: INTEGER = 20

	if GP("max") then
		iMax := Val(GP("max"))
	end
	writeHeader

  CGIWriteLn('<link>'+sgGeboURL+'</link>')
  CGIWriteLn('<description><![CDATA[Search result for '+GP("search")+']]></description>')
  CGICloseBuffer


	dbWIKI := OpenDB(sgDBDir+"wiki.dat")

	Fulltext_MarkTable(dbWIKI, sSelection := GP("search"))
	SortMark(dbWIKI,"$Name")
	Access(dbWIKI, -2)
	i:=0
	while Pos(lower(sSelection[i++]),"abcdefghijklmnopqrstuvwxyz0123456789.") do
		sFirstWord := sFirstWord + sSelection[i]
	end

	iRec := FirstRec(dbWIKI)
	while Readrec(dbWIKI, iRec), iCnt++ < iMax do

		CGIWriteLn('<item>')
		CGIWrite("<title><![CDATA["+ToHTML(GetField(dbWIKI,'Name'))+" ("+lang("rev")+" "+GetField(dbWIKI,'Revision')+")]]></title>")
		CGIWriteLn("<link><![CDATA["+sgGeboURL+"/programm/gebo.prg?name="+GetField(dbWIKI,'Name')+"]]></link>")
		if sFirstWord then
			CopyMemo(dbWIKI, "Content", "ramtext:hitcontent",1)
			if iPos := RAMTEXT_Find("ramtext:hitcontent", sFirstWord,1,1) then
				cgiwrite("<description><![CDATA[...")
				if iPos := iPos -100 <= 0 then iPos := 1 end
				cgiwrite(Lower(RAMTEXT_Part("ramtext:hitcontent", iPos, 200)))
				cgiwrite("...")
				cgiwriteln("]]></description>")
			end
		end
		CGIWriteLn('</item>')
		iRec := NextRec(dbWIKI)
	end
  CGIWriteLn('</channel>')
  CGIWriteLn('</rss>')
halt
endproc

procedure RSS
// GET paramater "max=" specifies maximum number of returned items

	var dbWIKI	: INTEGER
	var iRec 		: INTEGER
	var iCnt		: INTEGER
	var iMax 		: INTEGER = 20

	if GP("max") then
		iMax := Val(GP("max"))
	end

	writeHeader

	CGIWriteLn('<link>'+sgGeboURL+'</link>')
  CGIWriteLn('<description>GeboGebo Wiki</description>')

	dbWIKI := OpenDB(sgDBDir+"wiki.dat")


	if GP("name") then
		if iRec := FindRec(dbWIKI, cleanName(GP("name")),1,1) then
			SetMark(dbWIKI,iRec)
			Access(dbWIKI, -2)
		end
	else
		Access(dbWIKI, "wikistmp.ind")
	end
	iRec := FirstRec(dbWIKI)
	while Readrec(dbWIKI, iRec), iCnt++ < iMax do

		CGIWriteLn('<item>')
		CGIWrite("<title><![CDATA["+formatStamp(GetRField(dbWIKI,'Stamp'))+": "+ToHTML(GetField(dbWIKI,'Name'))+" ("+lang("rev")+" "+GetField(dbWIKI,'Revision')+": ")
		CGIWRITELN(GetField(dbWIKI, "ChangeLog")+')]]></title>')
		CGIWriteLn("<link><![CDATA["+sgGeboURL+"/programm/gebo.prg?name="+GetField(dbWIKI,'Name')+"]]></link>")
		CGIWriteLn('</item>')
		iRec := NextRec(dbWIKI)
	end
  CGIWriteLn('</channel>')
  CGIWriteLn('</rss>')
halt
endproc

Procedure Main
	EndSema
	initGebo


	if GP("search") then
		searchRSS
	else
		RSS
	end

	RSS
Endproc